                                Release Notes

   The release notes contain the significant changes in each PostgreSQL
   release, with major features and migration issues listed at the top.
   The release notes do not contain changes that affect only a few users
   or changes that are internal and therefore not user-visible. For
   example, the optimizer is improved in almost every release, but the
   improvements are usually observed by users as simply faster queries.

   A complete list of changes for each release can be obtained by viewing
   the Git logs for each release. The pgsql-committers email list records
   all source code changes as well. There is also a web interface that
   shows changes to specific files.

   The name appearing next to each item represents the major developer for
   that item. Of course all changes involve community discussion and patch
   review, so each item is truly a community effort.
     __________________________________________________________________

                                Release 9.0.3

     Release date: 2011-01-31

   This release contains a variety of fixes from 9.0.2. For information
   about new features in the 9.0 major release, see the Section called
   Release 9.0.
     __________________________________________________________________

Migration to Version 9.0.3

   A dump/restore is not required for those running 9.0.X.
     __________________________________________________________________

Changes

     * Before exiting walreceiver, ensure all the received WAL is fsync'd
       to disk (Heikki Linnakangas)
       Otherwise the standby server could replay some un-synced WAL,
       conceivably leading to data corruption if the system crashes just
       at that point.
     * Avoid excess fsync activity in walreceiver (Heikki Linnakangas)
     * Make "ALTER TABLE" revalidate uniqueness and exclusion constraints
       when needed (Noah Misch)
       This was broken in 9.0 by a change that was intended to suppress
       revalidation during "VACUUM FULL" and "CLUSTER", but
       unintentionally affected "ALTER TABLE" as well.
     * Fix EvalPlanQual for "UPDATE" of an inheritance tree in which the
       tables are not all alike (Tom Lane)
       Any variation in the table row types (including dropped columns
       present in only some child tables) would confuse the EvalPlanQual
       code, leading to misbehavior or even crashes. Since EvalPlanQual is
       only executed during concurrent updates to the same row, the
       problem was only seen intermittently.
     * Avoid failures when "EXPLAIN" tries to display a simple-form CASE
       expression (Tom Lane)
       If the CASE's test expression was a constant, the planner could
       simplify the CASE into a form that confused the expression-display
       code, resulting in "unexpected CASE WHEN clause" errors.
     * Fix assignment to an array slice that is before the existing range
       of subscripts (Tom Lane)
       If there was a gap between the newly added subscripts and the first
       pre-existing subscript, the code miscalculated how many entries
       needed to be copied from the old array's null bitmap, potentially
       leading to data corruption or crash.
     * Avoid unexpected conversion overflow in planner for very distant
       date values (Tom Lane)
       The date type supports a wider range of dates than can be
       represented by the timestamp types, but the planner assumed it
       could always convert a date to timestamp with impunity.
     * Fix PL/Python crash when an array contains null entries (Alex
       Hunsaker)
     * Remove ecpg's fixed length limit for constants defining an array
       dimension (Michael Meskes)
     * Fix erroneous parsing of tsquery values containing ... &
       !(subexpression) | ... (Tom Lane)
       Queries containing this combination of operators were not executed
       correctly. The same error existed in "contrib/intarray"'s query_int
       type and "contrib/ltree"'s ltxtquery type.
     * Fix buffer overrun in "contrib/intarray"'s input function for the
       query_int type (Apple)
       This bug is a security risk since the function's return address
       could be overwritten. Thanks to Apple Inc's security team for
       reporting this issue and supplying the fix. (CVE-2010-4015)
     * Fix bug in "contrib/seg"'s GiST picksplit algorithm (Alexander
       Korotkov)
       This could result in considerable inefficiency, though not actually
       incorrect answers, in a GiST index on a seg column. If you have
       such an index, consider "REINDEX"ing it after installing this
       update. (This is identical to the bug that was fixed in
       "contrib/cube" in the previous update.)
     __________________________________________________________________

                                Release 9.0.2

     Release date: 2010-12-16

   This release contains a variety of fixes from 9.0.1. For information
   about new features in the 9.0 major release, see the Section called
   Release 9.0.
     __________________________________________________________________

Migration to Version 9.0.2

   A dump/restore is not required for those running 9.0.X.
     __________________________________________________________________

Changes

     * Force the default wal_sync_method to be fdatasync on Linux (Tom
       Lane, Marti Raudsepp)
       The default on Linux has actually been fdatasync for many years,
       but recent kernel changes caused PostgreSQL to choose open_datasync
       instead. This choice did not result in any performance improvement,
       and caused outright failures on certain filesystems, notably ext4
       with the data=journal mount option.
     * Fix "too many KnownAssignedXids" error during Hot Standby replay
       (Heikki Linnakangas)
     * Fix race condition in lock acquisition during Hot Standby (Simon
       Riggs)
     * Avoid unnecessary conflicts during Hot Standby (Simon Riggs)
       This fixes some cases where replay was considered to conflict with
       standby queries (causing delay of replay or possibly cancellation
       of the queries), but there was no real conflict.
     * Fix assorted bugs in WAL replay logic for GIN indexes (Tom Lane)
       This could result in "bad buffer id: 0" failures or corruption of
       index contents during replication.
     * Fix recovery from base backup when the starting checkpoint WAL
       record is not in the same WAL segment as its redo point (Jeff
       Davis)
     * Fix corner-case bug when streaming replication is enabled
       immediately after creating the master database cluster (Heikki
       Linnakangas)
     * Fix persistent slowdown of autovacuum workers when multiple workers
       remain active for a long time (Tom Lane)
       The effective vacuum_cost_limit for an autovacuum worker could drop
       to nearly zero if it processed enough tables, causing it to run
       extremely slowly.
     * Fix long-term memory leak in autovacuum launcher (Alvaro Herrera)
     * Avoid failure when trying to report an impending transaction
       wraparound condition from outside a transaction (Tom Lane)
       This oversight prevented recovery after transaction wraparound got
       too close, because database startup processing would fail.
     * Add support for detecting register-stack overrun on IA64 (Tom Lane)
       The IA64 architecture has two hardware stacks. Full prevention of
       stack-overrun failures requires checking both.
     * Add a check for stack overflow in copyObject() (Tom Lane)
       Certain code paths could crash due to stack overflow given a
       sufficiently complex query.
     * Fix detection of page splits in temporary GiST indexes (Heikki
       Linnakangas)
       It is possible to have a "concurrent" page split in a temporary
       index, if for example there is an open cursor scanning the index
       when an insertion is done. GiST failed to detect this case and
       hence could deliver wrong results when execution of the cursor
       continued.
     * Fix error checking during early connection processing (Tom Lane)
       The check for too many child processes was skipped in some cases,
       possibly leading to postmaster crash when attempting to add the new
       child process to fixed-size arrays.
     * Improve efficiency of window functions (Tom Lane)
       Certain cases where a large number of tuples needed to be read in
       advance, but work_mem was large enough to allow them all to be held
       in memory, were unexpectedly slow. percent_rank(), cume_dist() and
       ntile() in particular were subject to this problem.
     * Avoid memory leakage while "ANALYZE"'ing complex index expressions
       (Tom Lane)
     * Ensure an index that uses a whole-row Var still depends on its
       table (Tom Lane)
       An index declared like create index i on t (foo(t.*)) would not
       automatically get dropped when its table was dropped.
     * Add missing support in "DROP OWNED BY" for removing foreign data
       wrapper/server privileges belonging to a user (Heikki Linnakangas)
     * Do not "inline" a SQL function with multiple OUT parameters (Tom
       Lane)
       This avoids a possible crash due to loss of information about the
       expected result rowtype.
     * Fix crash when inline-ing a set-returning function whose argument
       list contains a reference to an inline-able user function (Tom
       Lane)
     * Behave correctly if ORDER BY, LIMIT, FOR UPDATE, or WITH is
       attached to the VALUES part of INSERT ... VALUES (Tom Lane)
     * Make the OFF keyword unreserved (Heikki Linnakangas)
       This prevents problems with using off as a variable name in
       PL/pgSQL. That worked before 9.0, but was now broken because
       PL/pgSQL now treats all core reserved words as reserved.
     * Fix constant-folding of COALESCE() expressions (Tom Lane)
       The planner would sometimes attempt to evaluate sub-expressions
       that in fact could never be reached, possibly leading to unexpected
       errors.
     * Fix "could not find pathkey item to sort" planner failure with
       comparison of whole-row Vars (Tom Lane)
     * Fix postmaster crash when connection acceptance (accept() or one of
       the calls made immediately after it) fails, and the postmaster was
       compiled with GSSAPI support (Alexander Chernikov)
     * Retry after receiving an invalid response packet from a RADIUS
       authentication server (Magnus Hagander)
       This fixes a low-risk potential denial of service condition.
     * Fix missed unlink of temporary files when log_temp_files is active
       (Tom Lane)
       If an error occurred while attempting to emit the log message, the
       unlink was not done, resulting in accumulation of temp files.
     * Add print functionality for InhRelation nodes (Tom Lane)
       This avoids a failure when debug_print_parse is enabled and certain
       types of query are executed.
     * Fix incorrect calculation of distance from a point to a horizontal
       line segment (Tom Lane)
       This bug affected several different geometric distance-measurement
       operators.
     * Fix incorrect calculation of transaction status in ecpg (Itagaki
       Takahiro)
     * Fix errors in psql's Unicode-escape support (Tom Lane)
     * Speed up parallel pg_restore when the archive contains many large
       objects (blobs) (Tom Lane)
     * Fix PL/pgSQL's handling of "simple" expressions to not fail in
       recursion or error-recovery cases (Tom Lane)
     * Fix PL/pgSQL's error reporting for no-such-column cases (Tom Lane)
       As of 9.0, it would sometimes report "missing FROM-clause entry for
       table foo" when "record foo has no field bar" would be more
       appropriate.
     * Fix PL/Python to honor typmod (i.e., length or precision
       restrictions) when assigning to tuple fields (Tom Lane)
       This fixes a regression from 8.4.
     * Fix PL/Python's handling of set-returning functions (Jan Urbanski)
       Attempts to call SPI functions within the iterator generating a set
       result would fail.
     * Fix bug in "contrib/cube"'s GiST picksplit algorithm (Alexander
       Korotkov)
       This could result in considerable inefficiency, though not actually
       incorrect answers, in a GiST index on a cube column. If you have
       such an index, consider "REINDEX"ing it after installing this
       update.
     * Don't emit "identifier will be truncated" notices in
       "contrib/dblink" except when creating new connections (Itagaki
       Takahiro)
     * Fix potential coredump on missing public key in "contrib/pgcrypto"
       (Marti Raudsepp)
     * Fix buffer overrun in "contrib/pg_upgrade" (Hernan Gonzalez)
     * Fix memory leak in "contrib/xml2"'s XPath query functions (Tom
       Lane)
     * Update time zone data files to tzdata release 2010o for DST law
       changes in Fiji and Samoa; also historical corrections for Hong
       Kong.
     __________________________________________________________________

                                Release 9.0.1

     Release date: 2010-10-04

   This release contains a variety of fixes from 9.0.0. For information
   about new features in the 9.0 major release, see the Section called
   Release 9.0.
     __________________________________________________________________

Migration to Version 9.0.1

   A dump/restore is not required for those running 9.0.X.
     __________________________________________________________________

Changes

     * Use a separate interpreter for each calling SQL userid in PL/Perl
       and PL/Tcl (Tom Lane)
       This change prevents security problems that can be caused by
       subverting Perl or Tcl code that will be executed later in the same
       session under another SQL user identity (for example, within a
       SECURITY DEFINER function). Most scripting languages offer numerous
       ways that that might be done, such as redefining standard functions
       or operators called by the target function. Without this change,
       any SQL user with Perl or Tcl language usage rights can do
       essentially anything with the SQL privileges of the target
       function's owner.
       The cost of this change is that intentional communication among
       Perl and Tcl functions becomes more difficult. To provide an escape
       hatch, PL/PerlU and PL/TclU functions continue to use only one
       interpreter per session. This is not considered a security issue
       since all such functions execute at the trust level of a database
       superuser already.
       It is likely that third-party procedural languages that claim to
       offer trusted execution have similar security issues. We advise
       contacting the authors of any PL you are depending on for
       security-critical purposes.
       Our thanks to Tim Bunce for pointing out this issue
       (CVE-2010-3433).
     * Improve pg_get_expr() security fix so that the function can still
       be used on the output of a sub-select (Tom Lane)
     * Fix incorrect placement of placeholder evaluation (Tom Lane)
       This bug could result in query outputs being non-null when they
       should be null, in cases where the inner side of an outer join is a
       sub-select with non-strict expressions in its output list.
     * Fix join removal's handling of placeholder expressions (Tom Lane)
     * Fix possible duplicate scans of UNION ALL member relations (Tom
       Lane)
     * Prevent infinite loop in ProcessIncomingNotify() after unlistening
       (Jeff Davis)
     * Prevent show_session_authorization() from crashing within
       autovacuum processes (Tom Lane)
     * Re-allow input of Julian dates prior to 0001-01-01 AD (Tom Lane)
       Input such as 'J100000'::date worked before 8.4, but was
       unintentionally broken by added error-checking.
     * Make psql recognize "DISCARD ALL" as a command that should not be
       encased in a transaction block in autocommit-off mode (Itagaki
       Takahiro)
     * Update build infrastructure and documentation to reflect the source
       code repository's move from CVS to Git (Magnus Hagander and others)
     __________________________________________________________________

                                 Release 9.0

     Release date: 2010-09-20
     __________________________________________________________________

Overview

   This release of PostgreSQL adds features that have been requested for
   years, such as easy-to-use replication, a mass permission-changing
   facility, and anonymous code blocks. While past major releases have
   been conservative in their scope, this release shows a bold new desire
   to provide facilities that new and existing users of PostgreSQL will
   embrace. This has all been done with few incompatibilities. Major
   enhancements include:

     * Built-in replication based on log shipping. This advance consists
       of two features: Streaming Replication, allowing continuous archive
       (WAL) files to be streamed over a network connection to a standby
       server, and Hot Standby, allowing continuous archive standby
       servers to execute read-only queries. The net effect is to support
       a single master with multiple read-only slave servers.
     * Easier database object permissions management. "GRANT"/"REVOKE IN
       SCHEMA" supports mass permissions changes on existing objects,
       while "ALTER DEFAULT PRIVILEGES" allows control of privileges for
       objects created in the future. Large objects (BLOBs) now support
       permissions management as well.
     * Broadly enhanced stored procedure support. The "DO" statement
       supports ad-hoc or "anonymous" code blocks. Functions can now be
       called using named parameters. PL/pgSQL is now installed by
       default, and PL/Perl and PL/Python have been enhanced in several
       ways, including support for Python3.
     * Full support for 64-bit Windows.
     * More advanced reporting queries, including additional windowing
       options (PRECEDING and FOLLOWING) and the ability to control the
       order in which values are fed to aggregate functions.
     * New trigger features, including SQL-standard-compliant per-column
       triggers and conditional trigger execution.
     * Deferrable unique constraints. Mass updates to unique keys are now
       possible without trickery.
     * Exclusion constraints. These provide a generalized version of
       unique constraints, allowing enforcement of complex conditions.
     * New and enhanced security features, including RADIUS
       authentication, LDAP authentication improvements, and a new contrib
       module "passwordcheck" for testing password strength.
     * New high-performance implementation of the "LISTEN"/"NOTIFY"
       feature. Pending events are now stored in a memory-based queue
       rather than a table. Also, a "payload" string can be sent with each
       event, rather than transmitting just an event name as before.
     * New implementation of "VACUUM FULL". This command now rewrites the
       entire table and indexes, rather than moving individual rows to
       compact space. It is substantially faster in most cases, and no
       longer results in index bloat.
     * New contrib module "pg_upgrade" to support in-place upgrades from
       8.3 or 8.4 to 9.0.
     * Multiple performance enhancements for specific types of queries,
       including elimination of unnecessary joins. This helps optimize
       some automatically-generated queries, such as those produced by
       object-relational mappers (ORMs).
     * "EXPLAIN" enhancements. The output is now available in JSON, XML,
       or YAML format, and includes buffer utilization and other data not
       previously available.
     * "hstore" improvements, including new functions and greater data
       capacity.

   The above items are explained in more detail in the sections below.
     __________________________________________________________________

Migration to Version 9.0

   A dump/restore using pg_dump, or use of pg_upgrade, is required for
   those wishing to migrate data from any previous release.

   Version 9.0 contains a number of changes that selectively break
   backwards compatibility in order to support new features and code
   quality improvements. In particular, users who make extensive use of
   PL/pgSQL, Point-In-Time Recovery (PITR), or Warm Standby should test
   their applications because of slight user-visible changes in those
   areas. Observe the following incompatibilities:
     __________________________________________________________________

Server Settings

     * Remove server parameter add_missing_from, which was defaulted to
       off for many years (Tom Lane)
     * Remove server parameter regex_flavor, which was defaulted to
       advanced for many years (Tom Lane)
     * archive_mode now only affects archive_command; a new setting,
       wal_level, affects the contents of the write-ahead log (Heikki
       Linnakangas)
     * log_temp_files now uses default file size units of kilobytes
       (Robert Haas)
     __________________________________________________________________

Queries

     * When querying a parent table, do not do any separate permission
       checks on child tables scanned as part of the query (Peter
       Eisentraut)
       The SQL standard specifies this behavior, and it is also much more
       convenient in practice than the former behavior of checking
       permissions on each child as well as the parent.
     __________________________________________________________________

Data Types

     * bytea output now appears in hex format by default (Peter
       Eisentraut)
       The server parameter bytea_output can be used to select the
       traditional output format if needed for compatibility.
     * Array input now considers only plain ASCII whitespace characters to
       be potentially ignorable; it will never ignore non-ASCII
       characters, even if they are whitespace according to some locales
       (Tom Lane)
       This avoids some corner cases where array values could be
       interpreted differently depending on the server's locale settings.
     * Improve standards compliance of SIMILAR TO patterns and SQL-style
       substring() patterns (Tom Lane)
       This includes treating ? and {...} as pattern metacharacters, while
       they were simple literal characters before; that corresponds to new
       features added in SQL:2008. Also, ^ and $ are now treated as simple
       literal characters; formerly they were treated as metacharacters,
       as if the pattern were following POSIX rather than SQL rules. Also,
       in SQL-standard substring(), use of parentheses for nesting no
       longer interferes with capturing of a substring. Also, processing
       of bracket expressions (character classes) is now more
       standards-compliant.
     * Reject negative length values in 3-parameter substring() for bit
       strings, per the SQL standard (Tom Lane)
     * Make date_trunc truncate rather than round when reducing precision
       of fractional seconds (Tom Lane)
       The code always acted this way for integer-based dates/times. Now
       float-based dates/times behave similarly.
     __________________________________________________________________

Object Renaming

     * Tighten enforcement of column name consistency during "RENAME" when
       a child table inherits the same column from multiple unrelated
       parents (KaiGai Kohei)
     * No longer automatically rename indexes and index columns when the
       underlying table columns are renamed (Tom Lane)
       Administrators can still rename such indexes and columns manually.
       This change will require an update of the JDBC driver, and possibly
       other drivers, so that unique indexes are correctly recognized
       after a rename.
     * "CREATE OR REPLACE FUNCTION" can no longer change the declared
       names of function parameters (Pavel Stehule)
       In order to avoid creating ambiguity in named-parameter calls, it
       is no longer allowed to change the aliases for input parameters in
       the declaration of an existing function (although names can still
       be assigned to previously unnamed parameters). You now have to
       "DROP" and recreate the function to do that.
     __________________________________________________________________

PL/pgSQL

     * PL/pgSQL now throws an error if a variable name conflicts with a
       column name used in a query (Tom Lane)
       The former behavior was to bind ambiguous names to PL/pgSQL
       variables in preference to query columns, which often resulted in
       surprising misbehavior. Throwing an error allows easy detection of
       ambiguous situations. Although it's recommended that functions
       encountering this type of error be modified to remove the conflict,
       the old behavior can be restored if necessary via the configuration
       parameter plpgsql.variable_conflict, or via the per-function option
       #variable_conflict.
     * PL/pgSQL no longer allows variable names that match certain SQL
       reserved words (Tom Lane)
       This is a consequence of aligning the PL/pgSQL parser to match the
       core SQL parser more closely. If necessary, variable names can be
       double-quoted to avoid this restriction.
     * PL/pgSQL now requires columns of composite results to match the
       expected type modifier as well as base type (Pavel Stehule, Tom
       Lane)
       For example, if a column of the result type is declared as
       NUMERIC(30,2), it is no longer acceptable to return a NUMERIC of
       some other precision in that column. Previous versions neglected to
       check the type modifier and would thus allow result rows that
       didn't actually conform to the declared restrictions.
     * PL/pgSQL now treats selection into composite fields more
       consistently (Tom Lane)
       Formerly, a statement like SELECT ... INTO rec.fld FROM ... was
       treated as a scalar assignment even if the record field "fld" was
       of composite type. Now it is treated as a record assignment, the
       same as when the INTO target is a regular variable of composite
       type. So the values to be assigned to the field's subfields should
       be written as separate columns of the "SELECT" list, not as a
       ROW(...) construct as in previous versions.
       If you need to do this in a way that will work in both 9.0 and
       previous releases, you can write something like rec.fld := ROW(...)
       FROM ....
     * Remove PL/pgSQL's RENAME declaration (Tom Lane)
       Instead of RENAME, use ALIAS, which can now create an alias for any
       variable, not only dollar sign parameter names (such as $1) as
       before.
     __________________________________________________________________

Other Incompatibilities

     * Deprecate use of => as an operator name (Robert Haas)
       Future versions of PostgreSQL will probably reject this operator
       name entirely, in order to support the SQL-standard notation for
       named function parameters. For the moment, it is still allowed, but
       a warning is emitted when such an operator is defined.
     * Remove support for platforms that don't have a working 64-bit
       integer data type (Tom Lane)
       It is believed all still-supported platforms have working 64-bit
       integer data types.
     __________________________________________________________________

Changes

   Version 9.0 has an unprecedented number of new major features, and over
   200 enhancements, improvements, new commands, new functions, and other
   changes.
     __________________________________________________________________

Server

Continuous Archiving and Streaming Replication

   PostgreSQL's existing standby-server capability has been expanded both
   to support read-only queries on standby servers and to greatly reduce
   the lag between master and standby servers. For many users, this will
   be a useful and low-administration form of replication, either for high
   availability or for horizontal scalability.

     * Allow a standby server to accept read-only queries (Simon Riggs,
       Heikki Linnakangas)
       This feature is called Hot Standby. There are new "postgresql.conf"
       and "recovery.conf" settings to control this feature, as well as
       extensive documentation.
     * Allow write-ahead log (WAL) data to be streamed to a standby server
       (Fujii Masao, Heikki Linnakangas)
       This feature is called Streaming Replication. Previously WAL data
       could be sent to standby servers only in units of entire WAL files
       (normally 16 megabytes each). Streaming Replication eliminates this
       inefficiency and allows updates on the master to be propagated to
       standby servers with very little delay. There are new
       "postgresql.conf" and "recovery.conf" settings to control this
       feature, as well as extensive documentation.
     * Add pg_last_xlog_receive_location() and
       pg_last_xlog_replay_location(), which can be used to monitor
       standby server WAL activity (Simon Riggs, Fujii Masao, Heikki
       Linnakangas)
     __________________________________________________________________

Performance

     * Allow per-tablespace values to be set for sequential and random
       page cost estimates (seq_page_cost/random_page_cost) via "ALTER
       TABLESPACE ... SET/RESET" (Robert Haas)
     * Improve performance and reliability of EvalPlanQual rechecks in
       join queries (Tom Lane)
       "UPDATE", "DELETE", and "SELECT FOR UPDATE/SHARE" queries that
       involve joins will now behave much better when encountering
       freshly-updated rows.
     * Improve performance of "TRUNCATE" when the table was created or
       truncated earlier in the same transaction (Tom Lane)
     * Improve performance of finding inheritance child tables (Tom Lane)
     __________________________________________________________________

Optimizer

     * Remove unnecessary outer joins (Robert Haas)
       Outer joins where the inner side is unique and not referenced above
       the join are unnecessary and are therefore now removed. This will
       accelerate many automatically generated queries, such as those
       created by object-relational mappers (ORMs).
     * Allow IS NOT NULL restrictions to use indexes (Tom Lane)
       This is particularly useful for finding MAX()/MIN() values in
       indexes that contain many null values.
     * Improve the optimizer's choices about when to use materialize
       nodes, and when to use sorting versus hashing for DISTINCT (Tom
       Lane)
     * Improve the optimizer's equivalence detection for expressions
       involving boolean <> operators (Tom Lane)
     __________________________________________________________________

GEQO

     * Use the same random seed every time GEQO plans a query (Andres
       Freund)
       While the Genetic Query Optimizer (GEQO) still selects random
       plans, it now always selects the same random plans for identical
       queries, thus giving more consistent performance. You can modify
       geqo_seed to experiment with alternative plans.
     * Improve GEQO plan selection (Tom Lane)
       This avoids the rare error "failed to make a valid plan", and
       should also improve planning speed.
     __________________________________________________________________

Optimizer Statistics

     * Improve "ANALYZE" to support inheritance-tree statistics (Tom Lane)
       This is particularly useful for partitioned tables. However,
       autovacuum does not yet automatically re-analyze parent tables when
       child tables change.
     * Improve autovacuum's detection of when re-analyze is necessary (Tom
       Lane)
     * Improve optimizer's estimation for greater/less-than comparisons
       (Tom Lane)
       When looking up statistics for greater/less-than comparisons, if
       the comparison value is in the first or last histogram bucket, use
       an index (if available) to fetch the current actual column minimum
       or maximum. This greatly improves the accuracy of estimates for
       comparison values near the ends of the data range, particularly if
       the range is constantly changing due to addition of new data.
     * Allow setting of number-of-distinct-values statistics using "ALTER
       TABLE" (Robert Haas)
       This allows users to override the estimated number or percentage of
       distinct values for a column. This statistic is normally computed
       by "ANALYZE", but the estimate can be poor, especially on tables
       with very large numbers of rows.
     __________________________________________________________________

Authentication

     * Add support for RADIUS (Remote Authentication Dial In User Service)
       authentication (Magnus Hagander)
     * Allow LDAP (Lightweight Directory Access Protocol) authentication
       to operate in "search/bind" mode (Robert Fleming, Magnus Hagander)
       This allows the user to be looked up first, then the system uses
       the DN (Distinguished Name) returned for that user.
     * Add samehost and samenet designations to "pg_hba.conf" (Stef
       Walter)
       These match the server's IP address and subnet address
       respectively.
     * Pass trusted SSL root certificate names to the client so the client
       can return an appropriate client certificate (Craig Ringer)
     __________________________________________________________________

Monitoring

     * Add the ability for clients to set an application name, which is
       displayed in pg_stat_activity (Dave Page)
       This allows administrators to characterize database traffic and
       troubleshoot problems by source application.
     * Add a SQLSTATE option (%e) to log_line_prefix (Guillaume Smet)
       This allows users to compile statistics on errors and messages by
       error code number.
     * Write to the Windows event log in UTF16 encoding (Itagaki Takahiro)
       Now there is true multilingual support for PostgreSQL log messages
       on Windows.
     __________________________________________________________________

Statistics Counters

     * Add pg_stat_reset_shared('bgwriter') to reset the cluster-wide
       shared statistics for the background writer (Greg Smith)
     * Add pg_stat_reset_single_table_counters() and
       pg_stat_reset_single_function_counters() to allow resetting the
       statistics counters for individual tables and functions (Magnus
       Hagander)
     __________________________________________________________________

Server Settings

     * Allow setting of configuration parameters based on database/role
       combinations (Alvaro Herrera)
       Previously only per-database and per-role settings were possible,
       not combinations. All role and database settings are now stored in
       the new pg_db_role_setting system catalog. A new psql command \drds
       shows these settings. The legacy system views pg_roles, pg_shadow,
       and pg_user do not show combination settings, and therefore no
       longer completely represent the configuration for a user or
       database.
     * Add server parameter bonjour, which controls whether a
       Bonjour-enabled server advertises itself via Bonjour (Tom Lane)
       The default is off, meaning it does not advertise. This allows
       packagers to distribute Bonjour-enabled builds without worrying
       that individual users might not want the feature.
     * Add server parameter enable_material, which controls the use of
       materialize nodes in the optimizer (Robert Haas)
       The default is on. When off, the optimizer will not add materialize
       nodes purely for performance reasons, though they will still be
       used when necessary for correctness.
     * Change server parameter log_temp_files to use default file size
       units of kilobytes (Robert Haas)
       Previously this setting was interpreted in bytes if no units were
       specified.
     * Log changes of parameter values when "postgresql.conf" is reloaded
       (Peter Eisentraut)
       This lets administrators and security staff audit changes of
       database settings, and is also very convenient for checking the
       effects of "postgresql.conf" edits.
     * Properly enforce superuser permissions for custom server parameters
       (Tom Lane)
       Non-superusers can no longer issue "ALTER ROLE"/"DATABASE SET" for
       parameters that are not currently known to the server. This allows
       the server to correctly check that superuser-only parameters are
       only set by superusers. Previously, the SET would be allowed and
       then ignored at session start, making superuser-only custom
       parameters much less useful than they should be.
     __________________________________________________________________

Queries

     * Perform "SELECT FOR UPDATE"/SHARE processing after applying LIMIT,
       so the number of rows returned is always predictable (Tom Lane)
       Previously, changes made by concurrent transactions could cause a
       "SELECT FOR UPDATE" to unexpectedly return fewer rows than
       specified by its LIMIT. FOR UPDATE in combination with ORDER BY can
       still produce surprising results, but that can be corrected by
       placing FOR UPDATE in a subquery.
     * Allow mixing of traditional and SQL-standard LIMIT/OFFSET syntax
       (Tom Lane)
     * Extend the supported frame options in window functions (Hitoshi
       Harada)
       Frames can now start with CURRENT ROW, and the ROWS n
       PRECEDING/FOLLOWING options are now supported.
     * Make "SELECT INTO" and "CREATE TABLE AS" return row counts to the
       client in their command tags (Boszormenyi Zoltan)
       This can save an entire round-trip to the client, allowing result
       counts and pagination to be calculated without an additional
       "COUNT" query.
     __________________________________________________________________

Unicode Strings

     * Support Unicode surrogate pairs (dual 16-bit representation) in U&
       strings and identifiers (Peter Eisentraut)
     * Support Unicode escapes in E'...' strings (Marko Kreen)
     __________________________________________________________________

Object Manipulation

     * Speed up "CREATE DATABASE" by deferring flushes to disk (Andres
       Freund, Greg Stark)
     * Allow comments on columns of tables, views, and composite types
       only, not other relation types such as indexes and TOAST tables
       (Tom Lane)
     * Allow the creation of enumerated types containing no values (Bruce
       Momjian)
     * Let values of columns having storage type MAIN remain on the main
       heap page unless the row cannot fit on a page (Kevin Grittner)
       Previously MAIN values were forced out to TOAST tables until the
       row size was less than one-quarter of the page size.
     __________________________________________________________________

ALTER TABLE

     * Implement IF EXISTS for ALTER TABLE DROP COLUMN and ALTER TABLE
       DROP CONSTRAINT (Andres Freund)
     * Allow "ALTER TABLE" commands that rewrite tables to skip WAL
       logging (Itagaki Takahiro)
       Such operations either produce a new copy of the table or are
       rolled back, so WAL archiving can be skipped, unless running in
       continuous archiving mode. This reduces I/O overhead and improves
       performance.
     * Fix failure of ALTER TABLE table ADD COLUMN col serial when done by
       non-owner of table (Tom Lane)
     __________________________________________________________________

CREATE TABLE

     * Add support for copying COMMENTS and STORAGE settings in "CREATE
       TABLE ... LIKE" commands (Itagaki Takahiro)
     * Add a shortcut for copying all properties in "CREATE TABLE ...
       LIKE" commands (Itagaki Takahiro)
     * Add the SQL-standard CREATE TABLE ... OF type command (Peter
       Eisentraut)
       This allows creation of a table that matches an existing composite
       type. Additional constraints and defaults can be specified in the
       command.
     __________________________________________________________________

Constraints

     * Add deferrable unique constraints (Dean Rasheed)
       This allows mass updates, such as UPDATE tab SET col = col + 1, to
       work reliably on columns that have unique indexes or are marked as
       primary keys. If the constraint is specified as DEFERRABLE it will
       be checked at the end of the statement, rather than after each row
       is updated. The constraint check can also be deferred until the end
       of the current transaction, allowing such updates to be spread over
       multiple SQL commands.
     * Add exclusion constraints (Jeff Davis)
       Exclusion constraints generalize uniqueness constraints by allowing
       arbitrary comparison operators, not just equality. They are created
       with the "CREATE TABLE CONSTRAINT ... EXCLUDE" clause. The most
       common use of exclusion constraints is to specify that column
       entries must not overlap, rather than simply not be equal. This is
       useful for time periods and other ranges, as well as arrays. This
       feature enhances checking of data integrity for many calendaring,
       time-management, and scientific applications.
     * Improve uniqueness-constraint violation error messages to report
       the values causing the failure (Itagaki Takahiro)
       For example, a uniqueness constraint violation might now report Key
       (x)=(2) already exists.
     __________________________________________________________________

Object Permissions

     * Add the ability to make mass permission changes across a whole
       schema using the new "GRANT"/"REVOKE IN SCHEMA" clause (Petr
       Jelinek)
       This simplifies management of object permissions and makes it
       easier to utilize database roles for application data security.
     * Add "ALTER DEFAULT PRIVILEGES" command to control privileges of
       objects created later (Petr Jelinek)
       This greatly simplifies the assignment of object privileges in a
       complex database application. Default privileges can be set for
       tables, views, sequences, and functions. Defaults may be assigned
       on a per-schema basis, or database-wide.
     * Add the ability to control large object (BLOB) permissions with
       "GRANT"/"REVOKE" (KaiGai Kohei)
       Formerly, any database user could read or modify any large object.
       Read and write permissions can now be granted and revoked per large
       object, and the ownership of large objects is tracked.
     __________________________________________________________________

Utility Operations

     * Make "LISTEN"/"NOTIFY" store pending events in a memory queue,
       rather than in a system table (Joachim Wieland)
       This substantially improves performance, while retaining the
       existing features of transactional support and guaranteed delivery.
     * Allow "NOTIFY" to pass an optional "payload" string to listeners
       (Joachim Wieland)
       This greatly improves the usefulness of "LISTEN"/"NOTIFY" as a
       general-purpose event queue system.
     * Allow "CLUSTER" on all per-database system catalogs (Tom Lane)
       Shared catalogs still cannot be clustered.
     __________________________________________________________________

COPY

     * Accept COPY ... CSV FORCE QUOTE * (Itagaki Takahiro)
       Now * can be used as shorthand for "all columns" in the FORCE QUOTE
       clause.
     * Add new "COPY" syntax that allows options to be specified inside
       parentheses (Robert Haas, Emmanuel Cecchet)
       This allows greater flexibility for future "COPY" options. The old
       syntax is still supported, but only for pre-existing options.
     __________________________________________________________________

EXPLAIN

     * Allow "EXPLAIN" to output in XML, JSON, or YAML format (Robert
       Haas, Greg Sabino Mullane)
       The new output formats are easily machine-readable, supporting the
       development of new tools for analysis of "EXPLAIN" output.
     * Add new BUFFERS option to report query buffer usage during "EXPLAIN
       ANALYZE" (Itagaki Takahiro)
       This allows better query profiling for individual queries. Buffer
       usage is no longer reported in the output for log_statement_stats
       and related settings.
     * Add hash usage information to "EXPLAIN" output (Robert Haas)
     * Add new "EXPLAIN" syntax that allows options to be specified inside
       parentheses (Robert Haas)
       This allows greater flexibility for future "EXPLAIN" options. The
       old syntax is still supported, but only for pre-existing options.
     __________________________________________________________________

VACUUM

     * Change "VACUUM FULL" to rewrite the entire table and rebuild its
       indexes, rather than moving individual rows around to compact space
       (Itagaki Takahiro, Tom Lane)
       The previous method was usually slower and caused index bloat. Note
       that the new method will use more disk space transiently during
       "VACUUM FULL"; potentially as much as twice the space normally
       occupied by the table and its indexes.
     * Add new "VACUUM" syntax that allows options to be specified inside
       parentheses (Itagaki Takahiro)
       This allows greater flexibility for future "VACUUM" options. The
       old syntax is still supported, but only for pre-existing options.
     __________________________________________________________________

Indexes

     * Allow an index to be named automatically by omitting the index name
       in "CREATE INDEX" (Tom Lane)
     * By default, multicolumn indexes are now named after all their
       columns; and index expression columns are now named based on their
       expressions (Tom Lane)
     * Reindexing shared system catalogs is now fully transactional and
       crash-safe (Tom Lane)
       Formerly, reindexing a shared index was only allowed in standalone
       mode, and a crash during the operation could leave the index in
       worse condition than it was before.
     * Add point_ops operator class for GiST (Teodor Sigaev)
       This feature permits GiST indexing of point columns. The index can
       be used for several types of queries such as "point" <@ "polygon"
       (point is in polygon). This should make many PostGIS queries
       faster.
     * Use red-black binary trees for GIN index creation (Teodor Sigaev)
       Red-black trees are self-balancing. This avoids slowdowns in cases
       where the input is in nonrandom order.
     __________________________________________________________________

Data Types

     * Allow bytea values to be written in hex notation (Peter Eisentraut)
       The server parameter bytea_output controls whether hex or
       traditional format is used for bytea output. Libpq's
       PQescapeByteaConn() function automatically uses the hex format when
       connected to PostgreSQL 9.0 or newer servers.
       The new hex format will be directly compatible with more
       applications that use binary data, allowing them to store and
       retrieve it without extra conversion. It is also significantly
       faster to read and write than the traditional format.
     * Allow server parameter extra_float_digits to be increased to 3 (Tom
       Lane)
       The previous maximum extra_float_digits setting was 2. There are
       cases where 3 digits are needed to dump and restore float4 values
       exactly. pg_dump will now use the setting of 3 when dumping from a
       server that allows it.
     * Tighten input checking for int2vector values (Caleb Welton)
     __________________________________________________________________

Full Text Search

     * Add prefix support in synonym dictionaries (Teodor Sigaev)
     * Add filtering dictionaries (Teodor Sigaev)
       Filtering dictionaries allow tokens to be modified then passed to
       subsequent dictionaries.
     * Allow underscores in email-address tokens (Teodor Sigaev)
     * Use more standards-compliant rules for parsing URL tokens (Tom
       Lane)
     __________________________________________________________________

Functions

     * Allow function calls to supply parameter names and match them to
       named parameters in the function definition (Pavel Stehule)
       For example, if a function is defined to take parameters a and b,
       it can be called with func(a := 7, b := 12) or func(b := 12, a :=
       7).
     * Support locale-specific regular expression processing with UTF-8
       server encoding (Tom Lane)
       Locale-specific regular expression functionality includes
       case-insensitive matching and locale-specific character classes.
       Previously, these features worked correctly for non-ASCII
       characters only if the database used a single-byte server encoding
       (such as LATIN1). They will still misbehave in multi-byte encodings
       other than UTF-8.
     * Add support for scientific notation in to_char() (EEEE
       specification) (Pavel Stehule, Brendan Jurd)
     * Make to_char() honor FM (fill mode) in Y, YY, and YYY
       specifications (Bruce Momjian, Tom Lane)
       It was already honored by YYYY.
     * Fix to_char() to output localized numeric and monetary strings in
       the correct encoding on Windows (Hiroshi Inoue, Itagaki Takahiro,
       Bruce Momjian)
     * Correct calculations of "overlaps" and "contains" operations for
       polygons (Teodor Sigaev)
       The polygon && (overlaps) operator formerly just checked to see if
       the two polygons' bounding boxes overlapped. It now does a more
       correct check. The polygon @> and <@ (contains/contained by)
       operators formerly checked to see if one polygon's vertexes were
       all contained in the other; this can wrongly report "true" for some
       non-convex polygons. Now they check that all line segments of one
       polygon are contained in the other.
     __________________________________________________________________

Aggregates

     * Allow aggregate functions to use ORDER BY (Andrew Gierth)
       For example, this is now supported: array_agg(a ORDER BY b). This
       is useful with aggregates for which the order of input values is
       significant, and eliminates the need to use a nonstandard subquery
       to determine the ordering.
     * Multi-argument aggregate functions can now use DISTINCT (Andrew
       Gierth)
     * Add the string_agg() aggregate function to combine values into a
       single string (Pavel Stehule)
     * Aggregate functions that are called with DISTINCT are now passed
       NULL values if the aggregate transition function is not marked as
       STRICT (Andrew Gierth)
       For example, agg(DISTINCT x) might pass a NULL x value to agg().
       This is more consistent with the behavior in non-DISTINCT cases.
     __________________________________________________________________

Bit Strings

     * Add get_bit() and set_bit() functions for bit strings, mirroring
       those for bytea (Leonardo F)
     * Implement OVERLAY() (replace) for bit strings and bytea (Leonardo
       F)
     __________________________________________________________________

Object Information Functions

     * Add pg_table_size() and pg_indexes_size() to provide a more
       user-friendly interface to the pg_relation_size() function (Bernd
       Helmle)
     * Add has_sequence_privilege() for sequence permission checking
       (Abhijit Menon-Sen)
     * Update the information_schema views to conform to SQL:2008 (Peter
       Eisentraut)
     * Make the information_schema views correctly display maximum octet
       lengths for char and varchar columns (Peter Eisentraut)
     * Speed up information_schema privilege views (Joachim Wieland)
     __________________________________________________________________

Function and Trigger Creation

     * Support execution of anonymous code blocks using the "DO" statement
       (Petr Jelinek, Joshua Tolley, Hannu Valtonen)
       This allows execution of server-side code without the need to
       create and delete a temporary function definition. Code can be
       executed in any language for which the user has permissions to
       define a function.
     * Implement SQL-standard-compliant per-column triggers (Itagaki
       Takahiro)
       Such triggers are fired only when the specified column(s) are
       affected by the query, e.g. appear in an "UPDATE"'s SET list.
     * Add the WHEN clause to "CREATE TRIGGER" to allow control over
       whether a trigger is fired (Itagaki Takahiro)
       While the same type of check can always be performed inside the
       trigger, doing it in an external WHEN clause can have performance
       benefits.
     __________________________________________________________________

Server-Side Languages

     * Add the OR REPLACE clause to "CREATE LANGUAGE" (Tom Lane)
       This is helpful to optionally install a language if it does not
       already exist, and is particularly helpful now that PL/pgSQL is
       installed by default.
     __________________________________________________________________

PL/pgSQL Server-Side Language

     * Install PL/pgSQL by default (Bruce Momjian)
       The language can still be removed from a particular database if the
       administrator has security or performance concerns about making it
       available.
     * Improve handling of cases where PL/pgSQL variable names conflict
       with identifiers used in queries within a function (Tom Lane)
       The default behavior is now to throw an error when there is a
       conflict, so as to avoid surprising behaviors. This can be
       modified, via the configuration parameter plpgsql.variable_conflict
       or the per-function option #variable_conflict, to allow either the
       variable or the query-supplied column to be used. In any case
       PL/pgSQL will no longer attempt to substitute variables in places
       where they would not be syntactically valid.
     * Make PL/pgSQL use the main lexer, rather than its own version (Tom
       Lane)
       This ensures accurate tracking of the main system's behavior for
       details such as string escaping. Some user-visible details, such as
       the set of keywords considered reserved in PL/pgSQL, have changed
       in consequence.
     * Avoid throwing an unnecessary error for an invalid record reference
       (Tom Lane)
       An error is now thrown only if the reference is actually fetched,
       rather than whenever the enclosing expression is reached. For
       example, many people have tried to do this in triggers:
if TG_OP = 'INSERT' and NEW.col1 = ... then
       This will now actually work as expected.
     * Improve PL/pgSQL's ability to handle row types with dropped columns
       (Pavel Stehule)
     * Allow input parameters to be assigned values within PL/pgSQL
       functions (Steve Prentice)
       Formerly, input parameters were treated as being declared CONST, so
       the function's code could not change their values. This restriction
       has been removed to simplify porting of functions from other DBMSes
       that do not impose the equivalent restriction. An input parameter
       now acts like a local variable initialized to the passed-in value.
     * Improve error location reporting in PL/pgSQL (Tom Lane)
     * Add "count" and ALL options to "MOVE FORWARD"/BACKWARD in PL/pgSQL
       (Pavel Stehule)
     * Allow PL/pgSQL's WHERE CURRENT OF to use a cursor variable (Tom
       Lane)
     * Allow PL/pgSQL's "OPEN cursor FOR EXECUTE" to use parameters (Pavel
       Stehule, Itagaki Takahiro)
       This is accomplished with a new USING clause.
     __________________________________________________________________

PL/Perl Server-Side Language

     * Add new PL/Perl functions: quote_literal(), quote_nullable(),
       quote_ident(), encode_bytea(), decode_bytea(), looks_like_number(),
       encode_array_literal(), encode_array_constructor() (Tim Bunce)
     * Add server parameter plperl.on_init to specify a PL/Perl
       initialization function (Tim Bunce)
       plperl.on_plperl_init and plperl.on_plperlu_init are also available
       for initialization that is specific to the trusted or untrusted
       language respectively.
     * Support "END" blocks in PL/Perl (Tim Bunce)
       "END" blocks do not currently allow database access.
     * Allow "use strict" in PL/Perl (Tim Bunce)
       Perl strict checks can also be globally enabled with the new server
       parameter plperl.use_strict.
     * Allow "require" in PL/Perl (Tim Bunce)
       This basically tests to see if the module is loaded, and if not,
       generates an error. It will not allow loading of modules that the
       administrator has not preloaded via the initialization parameters.
     * Allow "use feature" in PL/Perl if Perl version 5.10 or later is
       used (Tim Bunce)
     * Verify that PL/Perl return values are valid in the server encoding
       (Andrew Dunstan)
     __________________________________________________________________

PL/Python Server-Side Language

     * Add Unicode support in PL/Python (Peter Eisentraut)
       Strings are automatically converted from/to the server encoding as
       necessary.
     * Improve bytea support in PL/Python (Caleb Welton)
       Bytea values passed into PL/Python are now represented as binary,
       rather than the PostgreSQL bytea text format. Bytea values
       containing null bytes are now also output properly from PL/Python.
       Passing of boolean, integer, and float values was also improved.
     * Support arrays as parameters and return values in PL/Python (Peter
       Eisentraut)
     * Improve mapping of SQL domains to Python types (Peter Eisentraut)
     * Add Python 3 support to PL/Python (Peter Eisentraut)
       The new server-side language is called plpython3u. This cannot be
       used in the same session with the Python 2 server-side language.
     * Improve error location and exception reporting in PL/Python (Peter
       Eisentraut)
     __________________________________________________________________

Client Applications

     * Add an "--analyze-only" option to "vacuumdb", to analyze without
       vacuuming (Bruce Momjian)
     __________________________________________________________________

psql

     * Add support for quoting/escaping the values of psql variables as
       SQL strings or identifiers (Pavel Stehule, Robert Haas)
       For example, :'var' will produce the value of var quoted and
       properly escaped as a literal string, while :"var" will produce its
       value quoted and escaped as an identifier.
     * Ignore a leading UTF-8-encoded Unicode byte-order marker in script
       files read by psql (Itagaki Takahiro)
       This is enabled when the client encoding is UTF-8. It improves
       compatibility with certain editors, mostly on Windows, that insist
       on inserting such markers.
     * Fix "psql --file -" to properly honor "--single-transaction" (Bruce
       Momjian)
     * Avoid overwriting of psql's command-line history when two psql
       sessions are run concurrently (Tom Lane)
     * Improve psql's tab completion support (Itagaki Takahiro)
     * Show \timing output when it is enabled, regardless of "quiet" mode
       (Peter Eisentraut)
     __________________________________________________________________

psql Display

     * Improve display of wrapped columns in psql (Roger Leigh)
       This behavior is now the default. The previous formatting is
       available by using "\pset linestyle old-ascii".
     * Allow psql to use fancy Unicode line-drawing characters via "\pset
       linestyle unicode" (Roger Leigh)
     __________________________________________________________________

psql \d Commands

     * Make "\d" show child tables that inherit from the specified parent
       (Damien Clochard)
       "\d" shows only the number of child tables, while "\d+" shows the
       names of all child tables.
     * Show definitions of index columns in "\d index_name" (Khee Chin)
       The definition is useful for expression indexes.
     * Show a view's defining query only in "\d+", not in "\d" (Peter
       Eisentraut)
       Always including the query was deemed overly verbose.
     __________________________________________________________________

pg_dump

     * Make pg_dump/pg_restore "--clean" also remove large objects
       (Itagaki Takahiro)
     * Fix pg_dump to properly dump large objects when
       standard_conforming_strings is enabled (Tom Lane)
       The previous coding could fail when dumping to an archive file and
       then generating script output from pg_restore.
     * pg_restore now emits large-object data in hex format when
       generating script output (Tom Lane)
       This could cause compatibility problems if the script is then
       loaded into a pre-9.0 server. To work around that, restore directly
       to the server, instead.
     * Allow pg_dump to dump comments attached to columns of composite
       types (Taro Minowa (Higepon))
     * Make pg_dump "--verbose" output the pg_dump and server versions in
       text output mode (Jim Cox, Tom Lane)
       These were already provided in custom output mode.
     * pg_restore now complains if any command-line arguments remain after
       the switches and optional file name (Tom Lane)
       Previously, it silently ignored any such arguments.
     __________________________________________________________________

pg_ctl

     * Allow pg_ctl to be used safely to start the postmaster during a
       system reboot (Tom Lane)
       Previously, pg_ctl's parent process could have been mistakenly
       identified as a running postmaster based on a stale postmaster lock
       file, resulting in a transient failure to start the database.
     * Give pg_ctl the ability to initialize the database (by invoking
       initdb) (Zdenek Kotala)
     __________________________________________________________________

Development Tools

libpq

     * Add new libpq functions PQconnectdbParams() and
       PQconnectStartParams() (Guillaume Lelarge)
       These functions are similar to PQconnectdb() and PQconnectStart()
       except that they accept a null-terminated array of connection
       options, rather than requiring all options to be provided in a
       single string.
     * Add libpq functions PQescapeLiteral() and PQescapeIdentifier()
       (Robert Haas)
       These functions return appropriately quoted and escaped SQL string
       literals and identifiers. The caller is not required to
       pre-allocate the string result, as is required by
       PQescapeStringConn().
     * Add support for a per-user service file (".pg_service.conf"), which
       is checked before the site-wide service file (Peter Eisentraut)
     * Properly report an error if the specified libpq service cannot be
       found (Peter Eisentraut)
     * Add TCP keepalive settings in libpq (Tollef Fog Heen, Fujii Masao,
       Robert Haas)
       Keepalive settings were already supported on the server end of TCP
       connections.
     * Avoid extra system calls to block and unblock SIGPIPE in libpq, on
       platforms that offer alternative methods (Jeremy Kerr)
     * When a ".pgpass"-supplied password fails, mention where the
       password came from in the error message (Bruce Momjian)
     * Load all SSL certificates given in the client certificate file (Tom
       Lane)
       This improves support for indirectly-signed SSL certificates.
     __________________________________________________________________

ecpg

     * Add SQLDA (SQL Descriptor Area) support to ecpg (Boszormenyi
       Zoltan)
     * Add the "DESCRIBE" [ OUTPUT ] statement to ecpg (Boszormenyi
       Zoltan)
     * Add an ECPGtransactionStatus function to return the current
       transaction status (Bernd Helmle)
     * Add the string data type in ecpg Informix-compatibility mode
       (Boszormenyi Zoltan)
     * Allow ecpg to use new and old variable names without restriction
       (Michael Meskes)
     * Allow ecpg to use variable names in free() (Michael Meskes)
     * Make ecpg_dynamic_type() return zero for non-SQL3 data types
       (Michael Meskes)
       Previously it returned the negative of the data type OID. This
       could be confused with valid type OIDs, however.
     * Support long long types on platforms that already have 64-bit long
       (Michael Meskes)
     __________________________________________________________________

ecpg Cursors

     * Add out-of-scope cursor support in ecpg's native mode (Boszormenyi
       Zoltan)
       This allows "DECLARE" to use variables that are not in scope when
       "OPEN" is called. This facility already existed in ecpg's
       Informix-compatibility mode.
     * Allow dynamic cursor names in ecpg (Boszormenyi Zoltan)
     * Allow ecpg to use noise words FROM and IN in "FETCH" and "MOVE"
       (Boszormenyi Zoltan)
     __________________________________________________________________

Build Options

     * Enable client thread safety by default (Bruce Momjian)
       The thread-safety option can be disabled with configure
       "--disable-thread-safety".
     * Add support for controlling the Linux out-of-memory killer (Alex
       Hunsaker, Tom Lane)
       Now that "/proc/self/oom_adj" allows disabling of the Linux
       out-of-memory (OOM) killer, it's recommendable to disable OOM kills
       for the postmaster. It may then be desirable to re-enable OOM kills
       for the postmaster's child processes. The new compile-time option
       LINUX_OOM_ADJ allows the killer to be reactivated for child
       processes.
     __________________________________________________________________

Makefiles

     * New "Makefile" targets world, install-world, and installcheck-world
       (Andrew Dunstan)
       These are similar to the existing all, install, and installcheck
       targets, but they also build the HTML documentation, build and test
       "contrib", and test server-side languages and ecpg.
     * Add data and documentation installation location control to PGXS
       Makefiles (Mark Cave-Ayland)
     * Add Makefile rules to build the PostgreSQL documentation as a
       single HTML file or as a single plain-text file (Peter Eisentraut,
       Bruce Momjian)
     __________________________________________________________________

Windows

     * Support compiling on 64-bit Windows and running in 64-bit mode
       (Tsutomu Yamada, Magnus Hagander)
       This allows for large shared memory sizes on Windows.
     * Support server builds using Visual Studio 2008 (Magnus Hagander)
     __________________________________________________________________

Source Code

     * Distribute prebuilt documentation in a subdirectory tree, rather
       than as tar archive files inside the distribution tarball (Peter
       Eisentraut)
       For example, the prebuilt HTML documentation is now in
       "doc/src/sgml/html/"; the manual pages are packaged similarly.
     * Make the server's lexer reentrant (Tom Lane)
       This was needed for use of the lexer by PL/pgSQL.
     * Improve speed of memory allocation (Tom Lane, Greg Stark)
     * User-defined constraint triggers now have entries in pg_constraint
       as well as pg_trigger (Tom Lane)
       Because of this change, pg_constraint.pgconstrname is now redundant
       and has been removed.
     * Add system catalog columns pg_constraint.conindid and
       pg_trigger.tgconstrindid to better document the use of indexes for
       constraint enforcement (Tom Lane)
     * Allow multiple conditions to be communicated to backends using a
       single operating system signal (Fujii Masao)
       This allows new features to be added without a platform-specific
       constraint on the number of signal conditions.
     * Improve source code test coverage, including "contrib", PL/Python,
       and PL/Perl (Peter Eisentraut, Andrew Dunstan)
     * Remove the use of flat files for system table bootstrapping (Tom
       Lane, Alvaro Herrera)
       This improves performance when using many roles or databases, and
       eliminates some possible failure conditions.
     * Automatically generate the initial contents of pg_attribute for
       "bootstrapped" catalogs (John Naylor)
       This greatly simplifies changes to these catalogs.
     * Split the processing of "INSERT"/"UPDATE"/"DELETE" operations out
       of "execMain.c" (Marko Tiikkaja)
       Updates are now executed in a separate ModifyTable node. This
       change is necessary infrastructure for future improvements.
     * Simplify translation of psql's SQL help text (Peter Eisentraut)
     * Reduce the lengths of some file names so that all file paths in the
       distribution tarball are less than 100 characters (Tom Lane)
       Some decompression programs have problems with longer file paths.
     * Add a new ERRCODE_INVALID_PASSWORD SQLSTATE error code (Bruce
       Momjian)
     * With authors' permissions, remove the few remaining personal source
       code copyright notices (Bruce Momjian)
       The personal copyright notices were insignificant but the community
       occasionally had to answer questions about them.
     * Add new documentation section about running PostgreSQL in
       non-durable mode to improve performance (Bruce Momjian)
     * Restructure the HTML documentation "Makefile" rules to make their
       dependency checks work correctly, avoiding unnecessary rebuilds
       (Peter Eisentraut)
     * Use DocBook XSL stylesheets for man page building, rather than
       Docbook2X (Peter Eisentraut)
       This changes the set of tools needed to build the man pages.
     * Improve PL/Perl code structure (Tim Bunce)
     * Improve error context reports in PL/Perl (Alexey Klyukin)
     __________________________________________________________________

New Build Requirements

   Note that these requirements do not apply when building from a
   distribution tarball, since tarballs include the files that these
   programs are used to build.

     * Require Autoconf 2.63 to build configure (Peter Eisentraut)
     * Require Flex 2.5.31 or later to build from a CVS checkout (Tom
       Lane)
     * Require Perl version 5.8 or later to build from a CVS checkout
       (John Naylor, Andrew Dunstan)
     __________________________________________________________________

Portability

     * Use a more modern API for Bonjour (Tom Lane)
       Bonjour support now requires OS X 10.3 or later. The older API has
       been deprecated by Apple.
     * Add spinlock support for the SuperH architecture (Nobuhiro
       Iwamatsu)
     * Allow non-GCC compilers to use inline functions if they support
       them (Kurt Harriman)
     * Remove support for platforms that don't have a working 64-bit
       integer data type (Tom Lane)
     * Restructure use of LDFLAGS to be more consistent across platforms
       (Tom Lane)
       LDFLAGS is now used for linking both executables and shared
       libraries, and we add on LDFLAGS_EX when linking executables, or
       LDFLAGS_SL when linking shared libraries.
     __________________________________________________________________

Server Programming

     * Make backend header files safe to include in C++ (Kurt Harriman,
       Peter Eisentraut)
       These changes remove keyword conflicts that previously made C++
       usage difficult in backend code. However, there are still other
       complexities when using C++ for backend functions. extern "C" { }
       is still necessary in appropriate places, and memory management and
       error handling are still problematic.
     * Add AggCheckCallContext() for use in detecting if a C function is
       being called as an aggregate (Hitoshi Harada)
     * Change calling convention for SearchSysCache() and related
       functions to avoid hard-wiring the maximum number of cache keys
       (Robert Haas)
       Existing calls will still work for the moment, but can be expected
       to break in 9.1 or later if not converted to the new style.
     * Require calls of fastgetattr() and heap_getattr() backend macros to
       provide a non-NULL fourth argument (Robert Haas)
     * Custom typanalyze functions should no longer rely on
       VacAttrStats.attr to determine the type of data they will be passed
       (Tom Lane)
       This was changed to allow collection of statistics on index columns
       for which the storage type is different from the underlying column
       data type. There are new fields that tell the actual datatype being
       analyzed.
     __________________________________________________________________

Server Hooks

     * Add parser hooks for processing ColumnRef and ParamRef nodes (Tom
       Lane)
     * Add a ProcessUtility hook so loadable modules can control utility
       commands (Itagaki Takahiro)
     __________________________________________________________________

Binary Upgrade Support

     * Add "contrib/pg_upgrade" to support in-place upgrades (Bruce
       Momjian)
       This avoids the requirement of dumping/reloading the database when
       upgrading to a new major release of PostgreSQL, thus reducing
       downtime by orders of magnitude. It supports upgrades to 9.0 from
       PostgreSQL 8.3 and 8.4.
     * Add support for preserving relation relfilenode values during
       binary upgrades (Bruce Momjian)
     * Add support for preserving pg_type and pg_enum OIDs during binary
       upgrades (Bruce Momjian)
     * Move data files within tablespaces into PostgreSQL-version-specific
       subdirectories (Bruce Momjian)
       This simplifies binary upgrades.
     __________________________________________________________________

Contrib

     * Add multithreading option ("-j") to "contrib/pgbench" (Itagaki
       Takahiro)
       This allows multiple CPUs to be used by pgbench, reducing the risk
       of pgbench itself becoming the test bottleneck.
     * Add "\shell" and "\setshell" meta commands to "contrib/pgbench"
       (Michael Paquier)
     * New features for "contrib/dict_xsyn" (Sergey Karpov)
       The new options are matchorig, matchsynonyms, and keepsynonyms.
     * Add full text dictionary "contrib/unaccent" (Teodor Sigaev)
       This filtering dictionary removes accents from letters, which makes
       full-text searches over multiple languages much easier.
     * Add dblink_get_notify() to "contrib/dblink" (Marcus Kempe)
       This allows asynchronous notifications in dblink.
     * Improve "contrib/dblink"'s handling of dropped columns (Tom Lane)
       This affects dblink_build_sql_insert() and related functions. These
       functions now number columns according to logical not physical
       column numbers.
     * Greatly increase "contrib/hstore"'s data length limit, and add
       B-tree and hash support so GROUP BY and DISTINCT operations are
       possible on hstore columns (Andrew Gierth)
       New functions and operators were also added. These improvements
       make hstore a full-function key-value store embedded in PostgreSQL.
     * Add "contrib/passwordcheck" to support site-specific password
       strength policies (Laurenz Albe)
       The source code of this module should be modified to implement
       site-specific password policies.
     * Add "contrib/pg_archivecleanup" tool (Simon Riggs)
       This is designed to be used in the archive_cleanup_command server
       parameter, to remove no-longer-needed archive files.
     * Add query text to "contrib/auto_explain" output (Andrew Dunstan)
     * Add buffer access counters to "contrib/pg_stat_statements" (Itagaki
       Takahiro)
     * Update "contrib/start-scripts/linux" to use "/proc/self/oom_adj" to
       disable the Linux out-of-memory (OOM) killer (Alex Hunsaker, Tom
       Lane)
     __________________________________________________________________

                                Release 8.4.7

     Release date: 2011-01-31

   This release contains a variety of fixes from 8.4.6. For information
   about new features in the 8.4 major release, see the Section called
   Release 8.4.
     __________________________________________________________________

Migration to Version 8.4.7

   A dump/restore is not required for those running 8.4.X. However, if you
   are upgrading from a version earlier than 8.4.2, see the release notes
   for 8.4.2.
     __________________________________________________________________

Changes

     * Avoid failures when "EXPLAIN" tries to display a simple-form CASE
       expression (Tom Lane)
       If the CASE's test expression was a constant, the planner could
       simplify the CASE into a form that confused the expression-display
       code, resulting in "unexpected CASE WHEN clause" errors.
     * Fix assignment to an array slice that is before the existing range
       of subscripts (Tom Lane)
       If there was a gap between the newly added subscripts and the first
       pre-existing subscript, the code miscalculated how many entries
       needed to be copied from the old array's null bitmap, potentially
       leading to data corruption or crash.
     * Avoid unexpected conversion overflow in planner for very distant
       date values (Tom Lane)
       The date type supports a wider range of dates than can be
       represented by the timestamp types, but the planner assumed it
       could always convert a date to timestamp with impunity.
     * Fix pg_restore's text output for large objects (BLOBs) when
       standard_conforming_strings is on (Tom Lane)
       Although restoring directly to a database worked correctly, string
       escaping was incorrect if pg_restore was asked for SQL text output
       and standard_conforming_strings had been enabled in the source
       database.
     * Fix erroneous parsing of tsquery values containing ... &
       !(subexpression) | ... (Tom Lane)
       Queries containing this combination of operators were not executed
       correctly. The same error existed in "contrib/intarray"'s query_int
       type and "contrib/ltree"'s ltxtquery type.
     * Fix buffer overrun in "contrib/intarray"'s input function for the
       query_int type (Apple)
       This bug is a security risk since the function's return address
       could be overwritten. Thanks to Apple Inc's security team for
       reporting this issue and supplying the fix. (CVE-2010-4015)
     * Fix bug in "contrib/seg"'s GiST picksplit algorithm (Alexander
       Korotkov)
       This could result in considerable inefficiency, though not actually
       incorrect answers, in a GiST index on a seg column. If you have
       such an index, consider "REINDEX"ing it after installing this
       update. (This is identical to the bug that was fixed in
       "contrib/cube" in the previous update.)
     __________________________________________________________________

                                Release 8.4.6

     Release date: 2010-12-16

   This release contains a variety of fixes from 8.4.5. For information
   about new features in the 8.4 major release, see the Section called
   Release 8.4.
     __________________________________________________________________

Migration to Version 8.4.6

   A dump/restore is not required for those running 8.4.X. However, if you
   are upgrading from a version earlier than 8.4.2, see the release notes
   for 8.4.2.
     __________________________________________________________________

Changes

     * Force the default wal_sync_method to be fdatasync on Linux (Tom
       Lane, Marti Raudsepp)
       The default on Linux has actually been fdatasync for many years,
       but recent kernel changes caused PostgreSQL to choose open_datasync
       instead. This choice did not result in any performance improvement,
       and caused outright failures on certain filesystems, notably ext4
       with the data=journal mount option.
     * Fix assorted bugs in WAL replay logic for GIN indexes (Tom Lane)
       This could result in "bad buffer id: 0" failures or corruption of
       index contents during replication.
     * Fix recovery from base backup when the starting checkpoint WAL
       record is not in the same WAL segment as its redo point (Jeff
       Davis)
     * Fix persistent slowdown of autovacuum workers when multiple workers
       remain active for a long time (Tom Lane)
       The effective vacuum_cost_limit for an autovacuum worker could drop
       to nearly zero if it processed enough tables, causing it to run
       extremely slowly.
     * Add support for detecting register-stack overrun on IA64 (Tom Lane)
       The IA64 architecture has two hardware stacks. Full prevention of
       stack-overrun failures requires checking both.
     * Add a check for stack overflow in copyObject() (Tom Lane)
       Certain code paths could crash due to stack overflow given a
       sufficiently complex query.
     * Fix detection of page splits in temporary GiST indexes (Heikki
       Linnakangas)
       It is possible to have a "concurrent" page split in a temporary
       index, if for example there is an open cursor scanning the index
       when an insertion is done. GiST failed to detect this case and
       hence could deliver wrong results when execution of the cursor
       continued.
     * Fix error checking during early connection processing (Tom Lane)
       The check for too many child processes was skipped in some cases,
       possibly leading to postmaster crash when attempting to add the new
       child process to fixed-size arrays.
     * Improve efficiency of window functions (Tom Lane)
       Certain cases where a large number of tuples needed to be read in
       advance, but work_mem was large enough to allow them all to be held
       in memory, were unexpectedly slow. percent_rank(), cume_dist() and
       ntile() in particular were subject to this problem.
     * Avoid memory leakage while "ANALYZE"'ing complex index expressions
       (Tom Lane)
     * Ensure an index that uses a whole-row Var still depends on its
       table (Tom Lane)
       An index declared like create index i on t (foo(t.*)) would not
       automatically get dropped when its table was dropped.
     * Do not "inline" a SQL function with multiple OUT parameters (Tom
       Lane)
       This avoids a possible crash due to loss of information about the
       expected result rowtype.
     * Behave correctly if ORDER BY, LIMIT, FOR UPDATE, or WITH is
       attached to the VALUES part of INSERT ... VALUES (Tom Lane)
     * Fix constant-folding of COALESCE() expressions (Tom Lane)
       The planner would sometimes attempt to evaluate sub-expressions
       that in fact could never be reached, possibly leading to unexpected
       errors.
     * Fix postmaster crash when connection acceptance (accept() or one of
       the calls made immediately after it) fails, and the postmaster was
       compiled with GSSAPI support (Alexander Chernikov)
     * Fix missed unlink of temporary files when log_temp_files is active
       (Tom Lane)
       If an error occurred while attempting to emit the log message, the
       unlink was not done, resulting in accumulation of temp files.
     * Add print functionality for InhRelation nodes (Tom Lane)
       This avoids a failure when debug_print_parse is enabled and certain
       types of query are executed.
     * Fix incorrect calculation of distance from a point to a horizontal
       line segment (Tom Lane)
       This bug affected several different geometric distance-measurement
       operators.
     * Fix incorrect calculation of transaction status in ecpg (Itagaki
       Takahiro)
     * Fix PL/pgSQL's handling of "simple" expressions to not fail in
       recursion or error-recovery cases (Tom Lane)
     * Fix PL/Python's handling of set-returning functions (Jan Urbanski)
       Attempts to call SPI functions within the iterator generating a set
       result would fail.
     * Fix bug in "contrib/cube"'s GiST picksplit algorithm (Alexander
       Korotkov)
       This could result in considerable inefficiency, though not actually
       incorrect answers, in a GiST index on a cube column. If you have
       such an index, consider "REINDEX"ing it after installing this
       update.
     * Don't emit "identifier will be truncated" notices in
       "contrib/dblink" except when creating new connections (Itagaki
       Takahiro)
     * Fix potential coredump on missing public key in "contrib/pgcrypto"
       (Marti Raudsepp)
     * Fix memory leak in "contrib/xml2"'s XPath query functions (Tom
       Lane)
     * Update time zone data files to tzdata release 2010o for DST law
       changes in Fiji and Samoa; also historical corrections for Hong
       Kong.
     __________________________________________________________________

                                Release 8.4.5

     Release date: 2010-10-04

   This release contains a variety of fixes from 8.4.4. For information
   about new features in the 8.4 major release, see the Section called
   Release 8.4.
     __________________________________________________________________

Migration to Version 8.4.5

   A dump/restore is not required for those running 8.4.X. However, if you
   are upgrading from a version earlier than 8.4.2, see the release notes
   for 8.4.2.
     __________________________________________________________________

Changes

     * Use a separate interpreter for each calling SQL userid in PL/Perl
       and PL/Tcl (Tom Lane)
       This change prevents security problems that can be caused by
       subverting Perl or Tcl code that will be executed later in the same
       session under another SQL user identity (for example, within a
       SECURITY DEFINER function). Most scripting languages offer numerous
       ways that that might be done, such as redefining standard functions
       or operators called by the target function. Without this change,
       any SQL user with Perl or Tcl language usage rights can do
       essentially anything with the SQL privileges of the target
       function's owner.
       The cost of this change is that intentional communication among
       Perl and Tcl functions becomes more difficult. To provide an escape
       hatch, PL/PerlU and PL/TclU functions continue to use only one
       interpreter per session. This is not considered a security issue
       since all such functions execute at the trust level of a database
       superuser already.
       It is likely that third-party procedural languages that claim to
       offer trusted execution have similar security issues. We advise
       contacting the authors of any PL you are depending on for
       security-critical purposes.
       Our thanks to Tim Bunce for pointing out this issue
       (CVE-2010-3433).
     * Prevent possible crashes in pg_get_expr() by disallowing it from
       being called with an argument that is not one of the system catalog
       columns it's intended to be used with (Heikki Linnakangas, Tom
       Lane)
     * Treat exit code 128 (ERROR_WAIT_NO_CHILDREN) as non-fatal on
       Windows (Magnus Hagander)
       Under high load, Windows processes will sometimes fail at startup
       with this error code. Formerly the postmaster treated this as a
       panic condition and restarted the whole database, but that seems to
       be an overreaction.
     * Fix incorrect placement of placeholder evaluation (Tom Lane)
       This bug could result in query outputs being non-null when they
       should be null, in cases where the inner side of an outer join is a
       sub-select with non-strict expressions in its output list.
     * Fix possible duplicate scans of UNION ALL member relations (Tom
       Lane)
     * Fix "cannot handle unplanned sub-select" error (Tom Lane)
       This occurred when a sub-select contains a join alias reference
       that expands into an expression containing another sub-select.
     * Fix mishandling of whole-row Vars that reference a view or
       sub-select and appear within a nested sub-select (Tom Lane)
     * Fix mishandling of cross-type IN comparisons (Tom Lane)
       This could result in failures if the planner tried to implement an
       IN join with a sort-then-unique-then-plain-join plan.
     * Fix computation of "ANALYZE" statistics for tsvector columns (Jan
       Urbanski)
       The original coding could produce incorrect statistics, leading to
       poor plan choices later.
     * Improve planner's estimate of memory used by array_agg(),
       string_agg(), and similar aggregate functions (Hitoshi Harada)
       The previous drastic underestimate could lead to out-of-memory
       failures due to inappropriate choice of a hash-aggregation plan.
     * Fix failure to mark cached plans as transient (Tom Lane)
       If a plan is prepared while "CREATE INDEX CONCURRENTLY" is in
       progress for one of the referenced tables, it is supposed to be
       re-planned once the index is ready for use. This was not happening
       reliably.
     * Reduce PANIC to ERROR in some occasionally-reported btree failure
       cases, and provide additional detail in the resulting error
       messages (Tom Lane)
       This should improve the system's robustness with corrupted indexes.
     * Fix incorrect search logic for partial-match queries with GIN
       indexes (Tom Lane)
       Cases involving AND/OR combination of several GIN index conditions
       didn't always give the right answer, and were sometimes much slower
       than necessary.
     * Prevent show_session_authorization() from crashing within
       autovacuum processes (Tom Lane)
     * Defend against functions returning setof record where not all the
       returned rows are actually of the same rowtype (Tom Lane)
     * Fix possible corruption of pending trigger event lists during
       subtransaction rollback (Tom Lane)
       This could lead to a crash or incorrect firing of triggers.
     * Fix possible failure when hashing a pass-by-reference function
       result (Tao Ma, Tom Lane)
     * Improve merge join's handling of NULLs in the join columns (Tom
       Lane)
       A merge join can now stop entirely upon reaching the first NULL, if
       the sort order is such that NULLs sort high.
     * Take care to fsync the contents of lockfiles (both "postmaster.pid"
       and the socket lockfile) while writing them (Tom Lane)
       This omission could result in corrupted lockfile contents if the
       machine crashes shortly after postmaster start. That could in turn
       prevent subsequent attempts to start the postmaster from
       succeeding, until the lockfile is manually removed.
     * Avoid recursion while assigning XIDs to heavily-nested
       subtransactions (Andres Freund, Robert Haas)
       The original coding could result in a crash if there was limited
       stack space.
     * Avoid holding open old WAL segments in the walwriter process
       (Magnus Hagander, Heikki Linnakangas)
       The previous coding would prevent removal of no-longer-needed
       segments.
     * Fix log_line_prefix's %i escape, which could produce junk early in
       backend startup (Tom Lane)
     * Prevent misinterpretation of partially-specified relation options
       for TOAST tables (Itagaki Takahiro)
       In particular, fillfactor would be read as zero if any other
       reloption had been set for the table, leading to serious bloat.
     * Fix inheritance count tracking in "ALTER TABLE ... ADD CONSTRAINT"
       (Robert Haas)
     * Fix possible data corruption in "ALTER TABLE ... SET TABLESPACE"
       when archiving is enabled (Jeff Davis)
     * Allow "CREATE DATABASE" and "ALTER DATABASE ... SET TABLESPACE" to
       be interrupted by query-cancel (Guillaume Lelarge)
     * Improve "CREATE INDEX"'s checking of whether proposed index
       expressions are immutable (Tom Lane)
     * Fix "REASSIGN OWNED" to handle operator classes and families (Asko
       Tiidumaa)
     * Fix possible core dump when comparing two empty tsquery values (Tom
       Lane)
     * Fix LIKE's handling of patterns containing % followed by _ (Tom
       Lane)
       We've fixed this before, but there were still some
       incorrectly-handled cases.
     * Re-allow input of Julian dates prior to 0001-01-01 AD (Tom Lane)
       Input such as 'J100000'::date worked before 8.4, but was
       unintentionally broken by added error-checking.
     * Fix PL/pgSQL to throw an error, not crash, if a cursor is closed
       within a FOR loop that is iterating over that cursor (Heikki
       Linnakangas)
     * In PL/Python, defend against null pointer results from
       PyCObject_AsVoidPtr and PyCObject_FromVoidPtr (Peter Eisentraut)
     * In libpq, fix full SSL certificate verification for the case where
       both host and hostaddr are specified (Tom Lane)
     * Make psql recognize "DISCARD ALL" as a command that should not be
       encased in a transaction block in autocommit-off mode (Itagaki
       Takahiro)
     * Fix some issues in pg_dump's handling of SQL/MED objects (Tom Lane)
       Notably, pg_dump would always fail if run by a non-superuser, which
       was not intended.
     * Improve pg_dump and pg_restore's handling of non-seekable archive
       files (Tom Lane, Robert Haas)
       This is important for proper functioning of parallel restore.
     * Improve parallel pg_restore's ability to cope with selective
       restore (-L option) (Tom Lane)
       The original code tended to fail if the -L file commanded a
       non-default restore ordering.
     * Fix ecpg to process data from RETURNING clauses correctly (Michael
       Meskes)
     * Fix some memory leaks in ecpg (Zoltan Boszormenyi)
     * Improve "contrib/dblink"'s handling of tables containing dropped
       columns (Tom Lane)
     * Fix connection leak after "duplicate connection name" errors in
       "contrib/dblink" (Itagaki Takahiro)
     * Fix "contrib/dblink" to handle connection names longer than 62
       bytes correctly (Itagaki Takahiro)
     * Add hstore(text, text) function to "contrib/hstore" (Robert Haas)
       This function is the recommended substitute for the now-deprecated
       => operator. It was back-patched so that future-proofed code can be
       used with older server versions. Note that the patch will be
       effective only after "contrib/hstore" is installed or reinstalled
       in a particular database. Users might prefer to execute the "CREATE
       FUNCTION" command by hand, instead.
     * Update build infrastructure and documentation to reflect the source
       code repository's move from CVS to Git (Magnus Hagander and others)
     * Update time zone data files to tzdata release 2010l for DST law
       changes in Egypt and Palestine; also historical corrections for
       Finland.
       This change also adds new names for two Micronesian timezones:
       Pacific/Chuuk is now preferred over Pacific/Truk (and the preferred
       abbreviation is CHUT not TRUT) and Pacific/Pohnpei is preferred
       over Pacific/Ponape.
     * Make Windows' "N. Central Asia Standard Time" timezone map to
       Asia/Novosibirsk, not Asia/Almaty (Magnus Hagander)
       Microsoft changed the DST behavior of this zone in the timezone
       update from KB976098. Asia/Novosibirsk is a better match to its new
       behavior.
     __________________________________________________________________

                                Release 8.4.4

     Release date: 2010-05-17

   This release contains a variety of fixes from 8.4.3. For information
   about new features in the 8.4 major release, see the Section called
   Release 8.4.
     __________________________________________________________________

Migration to Version 8.4.4

   A dump/restore is not required for those running 8.4.X. However, if you
   are upgrading from a version earlier than 8.4.2, see the release notes
   for 8.4.2.
     __________________________________________________________________

Changes

     * Enforce restrictions in plperl using an opmask applied to the whole
       interpreter, instead of using "Safe.pm" (Tim Bunce, Andrew Dunstan)
       Recent developments have convinced us that "Safe.pm" is too
       insecure to rely on for making plperl trustable. This change
       removes use of "Safe.pm" altogether, in favor of using a separate
       interpreter with an opcode mask that is always applied. Pleasant
       side effects of the change include that it is now possible to use
       Perl's strict pragma in a natural way in plperl, and that Perl's $a
       and $b variables work as expected in sort routines, and that
       function compilation is significantly faster. (CVE-2010-1169)
     * Prevent PL/Tcl from executing untrustworthy code from pltcl_modules
       (Tom)
       PL/Tcl's feature for autoloading Tcl code from a database table
       could be exploited for trojan-horse attacks, because there was no
       restriction on who could create or insert into that table. This
       change disables the feature unless pltcl_modules is owned by a
       superuser. (However, the permissions on the table are not checked,
       so installations that really need a less-than-secure modules table
       can still grant suitable privileges to trusted non-superusers.)
       Also, prevent loading code into the unrestricted "normal" Tcl
       interpreter unless we are really going to execute a pltclu
       function. (CVE-2010-1170)
     * Fix data corruption during WAL replay of ALTER ... SET TABLESPACE
       (Tom)
       When archive_mode is on, ALTER ... SET TABLESPACE generates a WAL
       record whose replay logic was incorrect. It could write the data to
       the wrong place, leading to possibly-unrecoverable data corruption.
       Data corruption would be observed on standby slaves, and could
       occur on the master as well if a database crash and recovery
       occurred after committing the ALTER and before the next checkpoint.
     * Fix possible crash if a cache reset message is received during
       rebuild of a relcache entry (Heikki)
       This error was introduced in 8.4.3 while fixing a related failure.
     * Apply per-function GUC settings while running the language
       validator for the function (Itagaki Takahiro)
       This avoids failures if the function's code is invalid without the
       setting; an example is that SQL functions may not parse if the
       search_path is not correct.
     * Do constraint exclusion for inherited "UPDATE" and "DELETE" target
       tables when constraint_exclusion = partition (Tom)
       Due to an oversight, this setting previously only caused constraint
       exclusion to be checked in "SELECT" commands.
     * Do not allow an unprivileged user to reset superuser-only parameter
       settings (Alvaro)
       Previously, if an unprivileged user ran ALTER USER ... RESET ALL
       for himself, or ALTER DATABASE ... RESET ALL for a database he
       owns, this would remove all special parameter settings for the user
       or database, even ones that are only supposed to be changeable by a
       superuser. Now, the "ALTER" will only remove the parameters that
       the user has permission to change.
     * Avoid possible crash during backend shutdown if shutdown occurs
       when a CONTEXT addition would be made to log entries (Tom)
       In some cases the context-printing function would fail because the
       current transaction had already been rolled back when it came time
       to print a log message.
     * Fix erroneous handling of %r parameter in recovery_end_command
       (Heikki)
       The value always came out zero.
     * Ensure the archiver process responds to changes in archive_command
       as soon as possible (Tom)
     * Fix pl/pgsql's CASE statement to not fail when the case expression
       is a query that returns no rows (Tom)
     * Update pl/perl's "ppport.h" for modern Perl versions (Andrew)
     * Fix assorted memory leaks in pl/python (Andreas Freund, Tom)
     * Handle empty-string connect parameters properly in ecpg (Michael)
     * Prevent infinite recursion in psql when expanding a variable that
       refers to itself (Tom)
     * Fix psql's \copy to not add spaces around a dot within \copy
       (select ...) (Tom)
       Addition of spaces around the decimal point in a numeric literal
       would result in a syntax error.
     * Avoid formatting failure in psql when running in a locale context
       that doesn't match the client_encoding (Tom)
     * Fix unnecessary "GIN indexes do not support whole-index scans"
       errors for unsatisfiable queries using "contrib/intarray" operators
       (Tom)
     * Ensure that "contrib/pgstattuple" functions respond to cancel
       interrupts promptly (Tatsuhito Kasahara)
     * Make server startup deal properly with the case that shmget()
       returns EINVAL for an existing shared memory segment (Tom)
       This behavior has been observed on BSD-derived kernels including OS
       X. It resulted in an entirely-misleading startup failure
       complaining that the shared memory request size was too large.
     * Avoid possible crashes in syslogger process on Windows (Heikki)
     * Deal more robustly with incomplete time zone information in the
       Windows registry (Magnus)
     * Update the set of known Windows time zone names (Magnus)
     * Update time zone data files to tzdata release 2010j for DST law
       changes in Argentina, Australian Antarctic, Bangladesh, Mexico,
       Morocco, Pakistan, Palestine, Russia, Syria, Tunisia; also
       historical corrections for Taiwan.
       Also, add PKST (Pakistan Summer Time) to the default set of
       timezone abbreviations.
     __________________________________________________________________

                                Release 8.4.3

     Release date: 2010-03-15

   This release contains a variety of fixes from 8.4.2. For information
   about new features in the 8.4 major release, see the Section called
   Release 8.4.
     __________________________________________________________________

Migration to Version 8.4.3

   A dump/restore is not required for those running 8.4.X. However, if you
   are upgrading from a version earlier than 8.4.2, see the release notes
   for 8.4.2.
     __________________________________________________________________

Changes

     * Add new configuration parameter ssl_renegotiation_limit to control
       how often we do session key renegotiation for an SSL connection
       (Magnus)
       This can be set to zero to disable renegotiation completely, which
       may be required if a broken SSL library is used. In particular,
       some vendors are shipping stopgap patches for CVE-2009-3555 that
       cause renegotiation attempts to fail.
     * Fix possible deadlock during backend startup (Tom)
     * Fix possible crashes due to not handling errors during relcache
       reload cleanly (Tom)
     * Fix possible crash due to use of dangling pointer to a cached plan
       (Tatsuo)
     * Fix possible crash due to overenthusiastic invalidation of cached
       plan for "ROLLBACK" (Tom)
     * Fix possible crashes when trying to recover from a failure in
       subtransaction start (Tom)
     * Fix server memory leak associated with use of savepoints and a
       client encoding different from server's encoding (Tom)
     * Fix incorrect WAL data emitted during end-of-recovery cleanup of a
       GIST index page split (Yoichi Hirai)
       This would result in index corruption, or even more likely an error
       during WAL replay, if we were unlucky enough to crash during
       end-of-recovery cleanup after having completed an incomplete GIST
       insertion.
     * Fix bug in WAL redo cleanup method for GIN indexes (Heikki)
     * Fix incorrect comparison of scan key in GIN index search (Teodor)
     * Make substring() for bit types treat any negative length as meaning
       "all the rest of the string" (Tom)
       The previous coding treated only -1 that way, and would produce an
       invalid result value for other negative values, possibly leading to
       a crash (CVE-2010-0442).
     * Fix integer-to-bit-string conversions to handle the first
       fractional byte correctly when the output bit width is wider than
       the given integer by something other than a multiple of 8 bits
       (Tom)
     * Fix some cases of pathologically slow regular expression matching
       (Tom)
     * Fix bug occurring when trying to inline a SQL function that returns
       a set of a composite type that contains dropped columns (Tom)
     * Fix bug with trying to update a field of an element of a
       composite-type array column (Tom)
     * Avoid failure when "EXPLAIN" has to print a FieldStore or
       assignment ArrayRef expression (Tom)
       These cases can arise now that "EXPLAIN VERBOSE" tries to print
       plan node target lists.
     * Avoid an unnecessary coercion failure in some cases where an
       undecorated literal string appears in a subquery within
       "UNION"/"INTERSECT"/"EXCEPT" (Tom)
       This fixes a regression for some cases that worked before 8.4.
     * Avoid undesirable rowtype compatibility check failures in some
       cases where a whole-row Var has a rowtype that contains dropped
       columns (Tom)
     * Fix the STOP WAL LOCATION entry in backup history files to report
       the next WAL segment's name when the end location is exactly at a
       segment boundary (Itagaki Takahiro)
     * Always pass the catalog ID to an option validator function
       specified in "CREATE FOREIGN DATA WRAPPER" (Martin Pihlak)
     * Fix some more cases of temporary-file leakage (Heikki)
       This corrects a problem introduced in the previous minor release.
       One case that failed is when a plpgsql function returning set is
       called within another function's exception handler.
     * Add support for doing FULL JOIN ON FALSE (Tom)
       This prevents a regression from pre-8.4 releases for some queries
       that can now be simplified to a constant-false join condition.
     * Improve constraint exclusion processing of boolean-variable cases,
       in particular make it possible to exclude a partition that has a
       "bool_column = false" constraint (Tom)
     * Prevent treating an INOUT cast as representing binary compatibility
       (Heikki)
     * Include column name in the message when warning about inability to
       grant or revoke column-level privileges (Stephen Frost)
       This is more useful than before and helps to prevent confusion when
       a "REVOKE" generates multiple messages, which formerly appeared to
       be duplicates.
     * When reading "pg_hba.conf" and related files, do not treat
       @something as a file inclusion request if the @ appears inside
       quote marks; also, never treat @ by itself as a file inclusion
       request (Tom)
       This prevents erratic behavior if a role or database name starts
       with @. If you need to include a file whose path name contains
       spaces, you can still do so, but you must write @"/path to/file"
       rather than putting the quotes around the whole construct.
     * Prevent infinite loop on some platforms if a directory is named as
       an inclusion target in "pg_hba.conf" and related files (Tom)
     * Fix possible infinite loop if SSL_read or SSL_write fails without
       setting errno (Tom)
       This is reportedly possible with some Windows versions of openssl.
     * Disallow GSSAPI authentication on local connections, since it
       requires a hostname to function correctly (Magnus)
     * Protect ecpg against applications freeing strings unexpectedly
       (Michael)
     * Make ecpg report the proper SQLSTATE if the connection disappears
       (Michael)
     * Fix translation of cell contents in psql \d output (Heikki)
     * Fix psql's numericlocale option to not format strings it shouldn't
       in latex and troff output formats (Heikki)
     * Fix a small per-query memory leak in psql (Tom)
     * Make psql return the correct exit status (3) when ON_ERROR_STOP and
       --single-transaction are both specified and an error occurs during
       the implied "COMMIT" (Bruce)
     * Fix pg_dump's output of permissions for foreign servers (Heikki)
     * Fix possible crash in parallel pg_restore due to out-of-range
       dependency IDs (Tom)
     * Fix plpgsql failure in one case where a composite column is set to
       NULL (Tom)
     * Fix possible failure when calling PL/Perl functions from PL/PerlU
       or vice versa (Tim Bunce)
     * Add volatile markings in PL/Python to avoid possible
       compiler-specific misbehavior (Zdenek Kotala)
     * Ensure PL/Tcl initializes the Tcl interpreter fully (Tom)
       The only known symptom of this oversight is that the Tcl clock
       command misbehaves if using Tcl 8.5 or later.
     * Prevent ExecutorEnd from being run on portals created within a
       failed transaction or subtransaction (Tom)
       This is known to cause issues when using "contrib/auto_explain".
     * Prevent crash in "contrib/dblink" when too many key columns are
       specified to a dblink_build_sql_* function (Rushabh Lathia, Joe
       Conway)
     * Allow zero-dimensional arrays in "contrib/ltree" operations (Tom)
       This case was formerly rejected as an error, but it's more
       convenient to treat it the same as a zero-element array. In
       particular this avoids unnecessary failures when an ltree operation
       is applied to the result of ARRAY(SELECT ...) and the sub-select
       returns no rows.
     * Fix assorted crashes in "contrib/xml2" caused by sloppy memory
       management (Tom)
     * Make building of "contrib/xml2" more robust on Windows (Andrew)
     * Fix race condition in Windows signal handling (Radu Ilie)
       One known symptom of this bug is that rows in pg_listener could be
       dropped under heavy load.
     * Make the configure script report failure if the C compiler does not
       provide a working 64-bit integer datatype (Tom)
       This case has been broken for some time, and no longer seems worth
       supporting, so just reject it at configure time instead.
     * Update time zone data files to tzdata release 2010e for DST law
       changes in Bangladesh, Chile, Fiji, Mexico, Paraguay, Samoa.
     __________________________________________________________________

                                Release 8.4.2

     Release date: 2009-12-14

   This release contains a variety of fixes from 8.4.1. For information
   about new features in the 8.4 major release, see the Section called
   Release 8.4.
     __________________________________________________________________

Migration to Version 8.4.2

   A dump/restore is not required for those running 8.4.X. However, if you
   have any hash indexes, you should "REINDEX" them after updating to
   8.4.2, to repair possible damage.
     __________________________________________________________________

Changes

     * Protect against indirect security threats caused by index functions
       changing session-local state (Gurjeet Singh, Tom)
       This change prevents allegedly-immutable index functions from
       possibly subverting a superuser's session (CVE-2009-4136).
     * Reject SSL certificates containing an embedded null byte in the
       common name (CN) field (Magnus)
       This prevents unintended matching of a certificate to a server or
       client name during SSL validation (CVE-2009-4034).
     * Fix hash index corruption (Tom)
       The 8.4 change that made hash indexes keep entries sorted by hash
       value failed to update the bucket splitting and compaction routines
       to preserve the ordering. So application of either of those
       operations could lead to permanent corruption of an index, in the
       sense that searches might fail to find entries that are present. To
       deal with this, it is recommended to REINDEX any hash indexes you
       may have after installing this update.
     * Fix possible crash during backend-startup-time cache initialization
       (Tom)
     * Avoid crash on empty thesaurus dictionary (Tom)
     * Prevent signals from interrupting VACUUM at unsafe times (Alvaro)
       This fix prevents a PANIC if a VACUUM FULL is cancelled after it's
       already committed its tuple movements, as well as transient errors
       if a plain VACUUM is interrupted after having truncated the table.
     * Fix possible crash due to integer overflow in hash table size
       calculation (Tom)
       This could occur with extremely large planner estimates for the
       size of a hashjoin's result.
     * Fix crash if a DROP is attempted on an internally-dependent object
       (Tom)
     * Fix very rare crash in inet/cidr comparisons (Chris Mikkelson)
     * Ensure that shared tuple-level locks held by prepared transactions
       are not ignored (Heikki)
     * Fix premature drop of temporary files used for a cursor that is
       accessed within a subtransaction (Heikki)
     * Fix memory leak in syslogger process when rotating to a new CSV
       logfile (Tom)
     * Fix memory leak in postmaster when re-parsing "pg_hba.conf" (Tom)
     * Fix Windows permission-downgrade logic (Jesse Morris)
       This fixes some cases where the database failed to start on
       Windows, often with misleading error messages such as "could not
       locate matching postgres executable".
     * Make FOR UPDATE/SHARE in the primary query not propagate into WITH
       queries (Tom)
       For example, in
WITH w AS (SELECT * FROM foo) SELECT * FROM w, bar ... FOR UPDATE
       the FOR UPDATE will now affect bar but not foo. This is more useful
       and consistent than the original 8.4 behavior, which tried to
       propagate FOR UPDATE into the WITH query but always failed due to
       assorted implementation restrictions. It also follows the design
       rule that WITH queries are executed as if independent of the main
       query.
     * Fix bug with a WITH RECURSIVE query immediately inside another one
       (Tom)
     * Fix concurrency bug in hash indexes (Tom)
       Concurrent insertions could cause index scans to transiently report
       wrong results.
     * Fix incorrect logic for GiST index page splits, when the split
       depends on a non-first column of the index (Paul Ramsey)
     * Fix wrong search results for a multi-column GIN index with
       fastupdate enabled (Teodor)
     * Fix bugs in WAL entry creation for GIN indexes (Tom)
       These bugs were masked when full_page_writes was on, but with it
       off a WAL replay failure was certain if a crash occurred before the
       next checkpoint.
     * Don't error out if recycling or removing an old WAL file fails at
       the end of checkpoint (Heikki)
       It's better to treat the problem as non-fatal and allow the
       checkpoint to complete. Future checkpoints will retry the removal.
       Such problems are not expected in normal operation, but have been
       seen to be caused by misdesigned Windows anti-virus and backup
       software.
     * Ensure WAL files aren't repeatedly archived on Windows (Heikki)
       This is another symptom that could happen if some other process
       interfered with deletion of a no-longer-needed file.
     * Fix PAM password processing to be more robust (Tom)
       The previous code is known to fail with the combination of the
       Linux pam_krb5 PAM module with Microsoft Active Directory as the
       domain controller. It might have problems elsewhere too, since it
       was making unjustified assumptions about what arguments the PAM
       stack would pass to it.
     * Raise the maximum authentication token (Kerberos ticket) size in
       GSSAPI and SSPI authentication methods (Ian Turner)
       While the old 2000-byte limit was more than enough for Unix
       Kerberos implementations, tickets issued by Windows Domain
       Controllers can be much larger.
     * Ensure that domain constraints are enforced in constructs like
       ARRAY[...]::domain, where the domain is over an array type (Heikki)
     * Fix foreign-key logic for some cases involving composite-type
       columns as foreign keys (Tom)
     * Ensure that a cursor's snapshot is not modified after it is created
       (Alvaro)
       This could lead to a cursor delivering wrong results if later
       operations in the same transaction modify the data the cursor is
       supposed to return.
     * Fix CREATE TABLE to properly merge default expressions coming from
       different inheritance parent tables (Tom)
       This used to work but was broken in 8.4.
     * Re-enable collection of access statistics for sequences (Akira
       Kurosawa)
       This used to work but was broken in 8.3.
     * Fix processing of ownership dependencies during CREATE OR REPLACE
       FUNCTION (Tom)
     * Fix incorrect handling of WHERE "x"="x" conditions (Tom)
       In some cases these could get ignored as redundant, but they aren't
       -- they're equivalent to "x" IS NOT NULL.
     * Fix incorrect plan construction when using hash aggregation to
       implement DISTINCT for textually identical volatile expressions
       (Tom)
     * Fix Assert failure for a volatile SELECT DISTINCT ON expression
       (Tom)
     * Fix ts_stat() to not fail on an empty tsvector value (Tom)
     * Make text search parser accept underscores in XML attributes
       (Peter)
     * Fix encoding handling in xml binary input (Heikki)
       If the XML header doesn't specify an encoding, we now assume UTF-8
       by default; the previous handling was inconsistent.
     * Fix bug with calling plperl from plperlu or vice versa (Tom)
       An error exit from the inner function could result in crashes due
       to failure to re-select the correct Perl interpreter for the outer
       function.
     * Fix session-lifespan memory leak when a PL/Perl function is
       redefined (Tom)
     * Ensure that Perl arrays are properly converted to PostgreSQL arrays
       when returned by a set-returning PL/Perl function (Andrew Dunstan,
       Abhijit Menon-Sen)
       This worked correctly already for non-set-returning functions.
     * Fix rare crash in exception processing in PL/Python (Peter)
     * Fix ecpg problem with comments in DECLARE CURSOR statements
       (Michael)
     * Fix ecpg to not treat recently-added keywords as reserved words
       (Tom)
       This affected the keywords CALLED, CATALOG, DEFINER, ENUM,
       FOLLOWING, INVOKER, OPTIONS, PARTITION, PRECEDING, RANGE, SECURITY,
       SERVER, UNBOUNDED, and WRAPPER.
     * Re-allow regular expression special characters in psql's \df
       function name parameter (Tom)
     * In "contrib/fuzzystrmatch", correct the calculation of levenshtein
       distances with non-default costs (Marcin Mank)
     * In "contrib/pg_standby", disable triggering failover with a signal
       on Windows (Fujii Masao)
       This never did anything useful, because Windows doesn't have
       Unix-style signals, but recent changes made it actually crash.
     * Put FREEZE and VERBOSE options in the right order in the VACUUM
       command that "contrib/vacuumdb" produces (Heikki)
     * Fix possible leak of connections when "contrib/dblink" encounters
       an error (Tatsuhito Kasahara)
     * Ensure psql's flex module is compiled with the correct system
       header definitions (Tom)
       This fixes build failures on platforms where --enable-largefile
       causes incompatible changes in the generated code.
     * Make the postmaster ignore any application_name parameter in
       connection request packets, to improve compatibility with future
       libpq versions (Tom)
     * Update the timezone abbreviation files to match current reality
       (Joachim Wieland)
       This includes adding IDT to the default timezone abbreviation set.
     * Update time zone data files to tzdata release 2009s for DST law
       changes in Antarctica, Argentina, Bangladesh, Fiji, Novokuznetsk,
       Pakistan, Palestine, Samoa, Syria; also historical corrections for
       Hong Kong.
     __________________________________________________________________

                                Release 8.4.1

     Release date: 2009-09-09

   This release contains a variety of fixes from 8.4. For information
   about new features in the 8.4 major release, see the Section called
   Release 8.4.
     __________________________________________________________________

Migration to Version 8.4.1

   A dump/restore is not required for those running 8.4.X.
     __________________________________________________________________

Changes

     * Fix WAL page header initialization at the end of archive recovery
       (Heikki)
       This could lead to failure to process the WAL in a subsequent
       archive recovery.
     * Fix "cannot make new WAL entries during recovery" error (Tom)
     * Fix problem that could make expired rows visible after a crash
       (Tom)
       This bug involved a page status bit potentially not being set
       correctly after a server crash.
     * Disallow "RESET ROLE" and "RESET SESSION AUTHORIZATION" inside
       security-definer functions (Tom, Heikki)
       This covers a case that was missed in the previous patch that
       disallowed "SET ROLE" and "SET SESSION AUTHORIZATION" inside
       security-definer functions. (See CVE-2007-6600)
     * Make "LOAD" of an already-loaded loadable module into a no-op (Tom)
       Formerly, "LOAD" would attempt to unload and re-load the module,
       but this is unsafe and not all that useful.
     * Make window function PARTITION BY and ORDER BY items always be
       interpreted as simple expressions (Tom)
       In 8.4.0 these lists were parsed following the rules used for
       top-level GROUP BY and ORDER BY lists. But this was not correct per
       the SQL standard, and it led to possible circularity.
     * Fix several errors in planning of semi-joins (Tom)
       These led to wrong query results in some cases where IN or EXISTS
       was used together with another join.
     * Fix handling of whole-row references to subqueries that are within
       an outer join (Tom)
       An example is SELECT COUNT(ss.*) FROM ... LEFT JOIN (SELECT ...) ss
       ON .... Here, ss.* would be treated as ROW(NULL,NULL,...) for
       null-extended join rows, which is not the same as a simple NULL.
       Now it is treated as a simple NULL.
     * Fix Windows shared-memory allocation code (Tsutomu Yamada, Magnus)
       This bug led to the often-reported "could not reattach to shared
       memory" error message.
     * Fix locale handling with plperl (Heikki)
       This bug could cause the server's locale setting to change when a
       plperl function is called, leading to data corruption.
     * Fix handling of reloptions to ensure setting one option doesn't
       force default values for others (Itagaki Takahiro)
     * Ensure that a "fast shutdown" request will forcibly terminate open
       sessions, even if a "smart shutdown" was already in progress (Fujii
       Masao)
     * Avoid memory leak for array_agg() in GROUP BY queries (Tom)
     * Treat to_char(..., 'TH') as an uppercase ordinal suffix with
       'HH'/'HH12' (Heikki)
       It was previously handled as 'th' (lowercase).
     * Include the fractional part in the result of EXTRACT(second) and
       EXTRACT(milliseconds) for time and time with time zone inputs (Tom)
       This has always worked for floating-point datetime configurations,
       but was broken in the integer datetime code.
     * Fix overflow for INTERVAL 'x ms' when "x" is more than 2 million
       and integer datetimes are in use (Alex Hunsaker)
     * Improve performance when processing toasted values in index scans
       (Tom)
       This is particularly useful for PostGIS.
     * Fix a typo that disabled commit_delay (Jeff Janes)
     * Output early-startup messages to "postmaster.log" if the server is
       started in silent mode (Tom)
       Previously such error messages were discarded, leading to
       difficulty in debugging.
     * Remove translated FAQs (Peter)
       They are now on the wiki. The main FAQ was moved to the wiki some
       time ago.
     * Fix pg_ctl to not go into an infinite loop if "postgresql.conf" is
       empty (Jeff Davis)
     * Fix several errors in pg_dump's --binary-upgrade mode (Bruce, Tom)
       pg_dump --binary-upgrade is used by pg_migrator.
     * Fix "contrib/xml2"'s xslt_process() to properly handle the maximum
       number of parameters (twenty) (Tom)
     * Improve robustness of libpq's code to recover from errors during
       "COPY FROM STDIN" (Tom)
     * Avoid including conflicting readline and editline header files when
       both libraries are installed (Zdenek Kotala)
     * Work around gcc bug that causes "floating-point exception" instead
       of "division by zero" on some platforms (Tom)
     * Update time zone data files to tzdata release 2009l for DST law
       changes in Bangladesh, Egypt, Mauritius.
     __________________________________________________________________

                                 Release 8.4

     Release date: 2009-07-01
     __________________________________________________________________

Overview

   After many years of development, PostgreSQL has become feature-complete
   in many areas. This release shows a targeted approach to adding
   features (e.g., authentication, monitoring, space reuse), and adds
   capabilities defined in the later SQL standards. The major areas of
   enhancement are:

     * Windowing Functions
     * Common Table Expressions and Recursive Queries
     * Default and variadic parameters for functions
     * Parallel Restore
     * Column Permissions
     * Per-database locale settings
     * Improved hash indexes
     * Improved join performance for EXISTS and NOT EXISTS queries
     * Easier-to-use Warm Standby
     * Automatic sizing of the Free Space Map
     * Visibility Map (greatly reduces vacuum overhead for slowly-changing
       tables)
     * Version-aware psql (backslash commands work against older servers)
     * Support SSL certificates for user authentication
     * Per-function runtime statistics
     * Easy editing of functions in psql
     * New contrib modules: pg_stat_statements, auto_explain, citext,
       btree_gin

   The above items are explained in more detail in the sections below.
     __________________________________________________________________

Migration to Version 8.4

   A dump/restore using pg_dump is required for those wishing to migrate
   data from any previous release.

   Observe the following incompatibilities:
     __________________________________________________________________

General

     * Use 64-bit integer datetimes by default (Neil Conway)
       Previously this was selected by configure's
       "--enable-integer-datetimes" option. To retain the old behavior,
       build with "--disable-integer-datetimes".
     * Remove ipcclean utility command (Bruce)
       The utility only worked on a few platforms. Users should use their
       operating system tools instead.
     __________________________________________________________________

Server Settings

     * Change default setting for log_min_messages to warning (previously
       it was notice) to reduce log file volume (Tom)
     * Change default setting for max_prepared_transactions to zero
       (previously it was 5) (Tom)
     * Make debug_print_parse, debug_print_rewritten, and debug_print_plan
       output appear at LOG message level, not DEBUG1 as formerly (Tom)
     * Make debug_pretty_print default to on (Tom)
     * Remove explain_pretty_print parameter (no longer needed) (Tom)
     * Make log_temp_files settable by superusers only, like other logging
       options (Simon Riggs)
     * Remove automatic appending of the epoch timestamp when no % escapes
       are present in log_filename (Robert Haas)
       This change was made because some users wanted a fixed log
       filename, for use with an external log rotation tool.
     * Remove log_restartpoints from "recovery.conf"; instead use
       log_checkpoints (Simon)
     * Remove krb_realm and krb_server_hostname; these are now set in
       "pg_hba.conf" instead (Magnus)
     * There are also significant changes in "pg_hba.conf", as described
       below.
     __________________________________________________________________

Queries

     * Change "TRUNCATE" and "LOCK" to apply to child tables of the
       specified table(s) (Peter)
       These commands now accept an ONLY option that prevents processing
       child tables; this option must be used if the old behavior is
       needed.
     * "SELECT DISTINCT" and UNION/INTERSECT/EXCEPT no longer always
       produce sorted output (Tom)
       Previously, these types of queries always removed duplicate rows by
       means of Sort/Unique processing (i.e., sort then remove adjacent
       duplicates). Now they can be implemented by hashing, which will not
       produce sorted output. If an application relied on the output being
       in sorted order, the recommended fix is to add an ORDER BY clause.
       As a short-term workaround, the previous behavior can be restored
       by disabling enable_hashagg, but that is a very
       performance-expensive fix. SELECT DISTINCT ON never uses hashing,
       however, so its behavior is unchanged.
     * Force child tables to inherit CHECK constraints from parents (Alex
       Hunsaker, Nikhil Sontakke, Tom)
       Formerly it was possible to drop such a constraint from a child
       table, allowing rows that violate the constraint to be visible when
       scanning the parent table. This was deemed inconsistent, as well as
       contrary to SQL standard.
     * Disallow negative LIMIT or OFFSET values, rather than treating them
       as zero (Simon)
     * Disallow "LOCK TABLE" outside a transaction block (Tom)
       Such an operation is useless because the lock would be released
       immediately.
     * Sequences now contain an additional start_value column (Zoltan
       Boszormenyi)
       This supports "ALTER SEQUENCE ... RESTART".
     __________________________________________________________________

Functions and Operators

     * Make numeric zero raised to a fractional power return 0, rather
       than throwing an error, and make numeric zero raised to the zero
       power return 1, rather than error (Bruce)
       This matches the longstanding float8 behavior.
     * Allow unary minus of floating-point values to produce minus zero
       (Tom)
       The changed behavior is more IEEE-standard compliant.
     * Throw an error if an escape character is the last character in a
       LIKE pattern (i.e., it has nothing to escape) (Tom)
       Previously, such an escape character was silently ignored, thus
       possibly masking application logic errors.
     * Remove ~=~ and ~<>~ operators formerly used for LIKE index
       comparisons (Tom)
       Pattern indexes now use the regular equality operator.
     * xpath() now passes its arguments to libxml without any changes
       (Andrew)
       This means that the XML argument must be a well-formed XML
       document. The previous coding attempted to allow XML fragments, but
       it did not work well.
     * Make xmlelement() format attribute values just like content values
       (Peter)
       Previously, attribute values were formatted according to the normal
       SQL output behavior, which is sometimes at odds with XML rules.
     * Rewrite memory management for libxml-using functions (Tom)
       This change should avoid some compatibility problems with use of
       libxml in PL/Perl and other add-on code.
     * Adopt a faster algorithm for hash functions (Kenneth Marshall,
       based on work of Bob Jenkins)
       Many of the built-in hash functions now deliver different results
       on little-endian and big-endian platforms.
     __________________________________________________________________

Temporal Functions and Operators

     * DateStyle no longer controls interval output formatting; instead
       there is a new variable IntervalStyle (Ron Mayer)
     * Improve consistency of handling of fractional seconds in timestamp
       and interval output (Ron Mayer)
       This may result in displaying a different number of fractional
       digits than before, or rounding instead of truncating.
     * Make to_char()'s localized month/day names depend on LC_TIME, not
       LC_MESSAGES (Euler Taveira de Oliveira)
     * Cause to_date() and to_timestamp() to more consistently report
       errors for invalid input (Brendan Jurd)
       Previous versions would often ignore or silently misread input that
       did not match the format string. Such cases will now result in an
       error.
     * Fix to_timestamp() to not require upper/lower case matching for
       meridian (AM/PM) and era (BC/AD) format designations (Brendan Jurd)
       For example, input value ad now matches the format string AD.
     __________________________________________________________________

Changes

   Below you will find a detailed account of the changes between
   PostgreSQL 8.4 and the previous major release.
     __________________________________________________________________

Performance

     * Improve optimizer statistics calculations (Jan Urbanski, Tom)
       In particular, estimates for full-text-search operators are greatly
       improved.
     * Allow "SELECT DISTINCT" and UNION/INTERSECT/EXCEPT to use hashing
       (Tom)
       This means that these types of queries no longer automatically
       produce sorted output.
     * Create explicit concepts of semi-joins and anti-joins (Tom)
       This work formalizes our previous ad-hoc treatment of IN (SELECT
       ...) clauses, and extends it to EXISTS and NOT EXISTS clauses. It
       should result in significantly better planning of EXISTS and NOT
       EXISTS queries. In general, logically equivalent IN and EXISTS
       clauses should now have similar performance, whereas previously IN
       often won.
     * Improve optimization of sub-selects beneath outer joins (Tom)
       Formerly, a sub-select or view could not be optimized very well if
       it appeared within the nullable side of an outer join and contained
       non-strict expressions (for instance, constants) in its result
       list.
     * Improve the performance of text_position() and related functions by
       using Boyer-Moore-Horspool searching (David Rowley)
       This is particularly helpful for long search patterns.
     * Reduce I/O load of writing the statistics collection file by
       writing the file only when requested (Martin Pihlak)
     * Improve performance for bulk inserts (Robert Haas, Simon)
     * Increase the default value of default_statistics_target from 10 to
       100 (Greg Sabino Mullane, Tom)
       The maximum value was also increased from 1000 to 10000.
     * Perform constraint_exclusion checking by default in queries
       involving inheritance or UNION ALL (Tom)
       A new constraint_exclusion setting, partition, was added to specify
       this behavior.
     * Allow I/O read-ahead for bitmap index scans (Greg Stark)
       The amount of read-ahead is controlled by effective_io_concurrency.
       This feature is available only if the kernel has posix_fadvise()
       support.
     * Inline simple set-returning SQL functions in FROM clauses (Richard
       Rowell)
     * Improve performance of multi-batch hash joins by providing a
       special case for join key values that are especially common in the
       outer relation (Bryce Cutt, Ramon Lawrence)
     * Reduce volume of temporary data in multi-batch hash joins by
       suppressing "physical tlist" optimization (Michael Henderson, Ramon
       Lawrence)
     * Avoid waiting for idle-in-transaction sessions during "CREATE INDEX
       CONCURRENTLY" (Simon)
     * Improve performance of shared cache invalidation (Tom)
     __________________________________________________________________

Server

Settings

     * Convert many "postgresql.conf" settings to enumerated values so
       that pg_settings can display the valid values (Magnus)
     * Add cursor_tuple_fraction parameter to control the fraction of a
       cursor's rows that the planner assumes will be fetched (Robert
       Hell)
     * Allow underscores in the names of custom variable classes in
       "postgresql.conf" (Tom)
     __________________________________________________________________

Authentication and security

     * Remove support for the (insecure) crypt authentication method
       (Magnus)
       This effectively obsoletes pre-PostgreSQL 7.2 client libraries, as
       there is no longer any non-plaintext password method that they can
       use.
     * Support regular expressions in "pg_ident.conf" (Magnus)
     * Allow Kerberos/GSSAPI parameters to be changed without restarting
       the postmaster (Magnus)
     * Support SSL certificate chains in server certificate file (Andrew
       Gierth)
       Including the full certificate chain makes the client able to
       verify the certificate without having all intermediate CA
       certificates present in the local store, which is often the case
       for commercial CAs.
     * Report appropriate error message for combination of MD5
       authentication and db_user_namespace enabled (Bruce)
     __________________________________________________________________

pg_hba.conf

     * Change all authentication options to use name=value syntax (Magnus)
       This makes incompatible changes to the ldap, pam and ident
       authentication methods. All "pg_hba.conf" entries with these
       methods need to be rewritten using the new format.
     * Remove the ident sameuser option, instead making that behavior the
       default if no usermap is specified (Magnus)
     * Allow a usermap parameter for all external authentication methods
       (Magnus)
       Previously a usermap was only supported for ident authentication.
     * Add clientcert option to control requesting of a client certificate
       (Magnus)
       Previously this was controlled by the presence of a root
       certificate file in the server's data directory.
     * Add cert authentication method to allow *user* authentication via
       SSL certificates (Magnus)
       Previously SSL certificates could only verify that the client had
       access to a certificate, not authenticate a user.
     * Allow krb5, gssapi and sspi realm and krb5 host settings to be
       specified in "pg_hba.conf" (Magnus)
       These override the settings in "postgresql.conf".
     * Add include_realm parameter for krb5, gssapi, and sspi methods
       (Magnus)
       This allows identical usernames from different realms to be
       authenticated as different database users using usermaps.
     * Parse "pg_hba.conf" fully when it is loaded, so that errors are
       reported immediately (Magnus)
       Previously, most errors in the file wouldn't be detected until
       clients tried to connect, so an erroneous file could render the
       system unusable. With the new behavior, if an error is detected
       during reload then the bad file is rejected and the postmaster
       continues to use its old copy.
     * Show all parsing errors in "pg_hba.conf" instead of aborting after
       the first one (Selena Deckelmann)
     * Support ident authentication over Unix-domain sockets on Solaris
       (Garick Hamlin)
     __________________________________________________________________

Continuous Archiving

     * Provide an option to pg_start_backup() to force its implied
       checkpoint to finish as quickly as possible (Tom)
       The default behavior avoids excess I/O consumption, but that is
       pointless if no concurrent query activity is going on.
     * Make pg_stop_backup() wait for modified WAL files to be archived
       (Simon)
       This guarantees that the backup is valid at the time
       pg_stop_backup() completes.
     * When archiving is enabled, rotate the last WAL segment at shutdown
       so that all transactions can be archived immediately (Guillaume
       Smet, Heikki)
     * Delay "smart" shutdown while a continuous archiving base backup is
       in progress (Laurenz Albe)
     * Cancel a continuous archiving base backup if "fast" shutdown is
       requested (Laurenz Albe)
     * Allow "recovery.conf" boolean variables to take the same range of
       string values as "postgresql.conf" boolean variables (Bruce)
     __________________________________________________________________

Monitoring

     * Add pg_conf_load_time() to report when the PostgreSQL configuration
       files were last loaded (George Gensure)
     * Add pg_terminate_backend() to safely terminate a backend (the
       SIGTERM signal works also) (Tom, Bruce)
       While it's always been possible to SIGTERM a single backend, this
       was previously considered unsupported; and testing of the case
       found some bugs that are now fixed.
     * Add ability to track user-defined functions' call counts and
       runtimes (Martin Pihlak)
       Function statistics appear in a new system view,
       pg_stat_user_functions. Tracking is controlled by the new parameter
       track_functions.
     * Allow specification of the maximum query string size in
       pg_stat_activity via new track_activity_query_size parameter
       (Thomas Lee)
     * Increase the maximum line length sent to syslog, in hopes of
       improving performance (Tom)
     * Add read-only configuration variables segment_size, wal_block_size,
       and wal_segment_size (Bernd Helmle)
     * When reporting a deadlock, report the text of all queries involved
       in the deadlock to the server log (Itagaki Takahiro)
     * Add pg_stat_get_activity(pid) function to return information about
       a specific process id (Magnus)
     * Allow the location of the server's statistics file to be specified
       via stats_temp_directory (Magnus)
       This allows the statistics file to be placed in a RAM-resident
       directory to reduce I/O requirements. On startup/shutdown, the file
       is copied to its traditional location ($PGDATA/global/) so it is
       preserved across restarts.
     __________________________________________________________________

Queries

     * Add support for WINDOW functions (Hitoshi Harada)
     * Add support for WITH clauses (CTEs), including WITH RECURSIVE
       (Yoshiyuki Asaba, Tatsuo Ishii, Tom)
     * Add "TABLE" command (Peter)
       TABLE tablename is a SQL standard short-hand for SELECT * FROM
       tablename.
     * Allow AS to be optional when specifying a "SELECT" (or RETURNING)
       column output label (Hiroshi Saito)
       This works so long as the column label is not any PostgreSQL
       keyword; otherwise AS is still needed.
     * Support set-returning functions in "SELECT" result lists even for
       functions that return their result via a tuplestore (Tom)
       In particular, this means that functions written in PL/pgSQL and
       other PL languages can now be called this way.
     * Support set-returning functions in the output of aggregation and
       grouping queries (Tom)
     * Allow "SELECT FOR UPDATE"/SHARE to work on inheritance trees (Tom)
     * Add infrastructure for SQL/MED (Martin Pihlak, Peter)
       There are no remote or external SQL/MED capabilities yet, but this
       change provides a standardized and future-proof system for managing
       connection information for modules like "dblink" and "plproxy".
     * Invalidate cached plans when referenced schemas, functions,
       operators, or operator classes are modified (Martin Pihlak, Tom)
       This improves the system's ability to respond to on-the-fly DDL
       changes.
     * Allow comparison of composite types and allow arrays of anonymous
       composite types (Tom)
       This allows constructs such as row(1, 1.1) = any (array[row(7,
       7.7), row(1, 1.0)]). This is particularly useful in recursive
       queries.
     * Add support for Unicode string literal and identifier
       specifications using code points, e.g. U&'d\0061t\+000061' (Peter)
     * Reject \000 in string literals and "COPY" data (Tom)
       Previously, this was accepted but had the effect of terminating the
       string contents.
     * Improve the parser's ability to report error locations (Tom)
       An error location is now reported for many semantic errors, such as
       mismatched datatypes, that previously could not be localized.
     __________________________________________________________________

TRUNCATE

     * Support statement-level ON TRUNCATE triggers (Simon)
     * Add RESTART/CONTINUE IDENTITY options for "TRUNCATE TABLE" (Zoltan
       Boszormenyi)
       The start value of a sequence can be changed by "ALTER SEQUENCE
       START WITH".
     * Allow "TRUNCATE tab1, tab1" to succeed (Bruce)
     * Add a separate "TRUNCATE" permission (Robert Haas)
     __________________________________________________________________

EXPLAIN

     * Make "EXPLAIN VERBOSE" show the output columns of each plan node
       (Tom)
       Previously "EXPLAIN VERBOSE" output an internal representation of
       the query plan. (That behavior is now available via
       debug_print_plan.)
     * Make "EXPLAIN" identify subplans and initplans with individual
       labels (Tom)
     * Make "EXPLAIN" honor debug_print_plan (Tom)
     * Allow "EXPLAIN" on "CREATE TABLE AS" (Peter)
     __________________________________________________________________

LIMIT/OFFSET

     * Allow sub-selects in LIMIT and OFFSET (Tom)
     * Add SQL-standard syntax for LIMIT/OFFSET capabilities (Peter)
       To wit, OFFSET num {ROW|ROWS} FETCH {FIRST|NEXT} [num] {ROW|ROWS}
       ONLY.
     __________________________________________________________________

Object Manipulation

     * Add support for column-level privileges (Stephen Frost, KaiGai
       Kohei)
     * Refactor multi-object "DROP" operations to reduce the need for
       CASCADE (Alex Hunsaker)
       For example, if table B has a dependency on table A, the command
       DROP TABLE A, B no longer requires the CASCADE option.
     * Fix various problems with concurrent "DROP" commands by ensuring
       that locks are taken before we begin to drop dependencies of an
       object (Tom)
     * Improve reporting of dependencies during "DROP" commands (Tom)
     * Add WITH [NO] DATA clause to "CREATE TABLE AS", per the SQL
       standard (Peter, Tom)
     * Add support for user-defined I/O conversion casts (Heikki)
     * Allow "CREATE AGGREGATE" to use an internal transition datatype
       (Tom)
     * Add LIKE clause to "CREATE TYPE" (Tom)
       This simplifies creation of data types that use the same internal
       representation as an existing type.
     * Allow specification of the type category and "preferred" status for
       user-defined base types (Tom)
       This allows more control over the coercion behavior of user-defined
       types.
     * Allow "CREATE OR REPLACE VIEW" to add columns to the end of a view
       (Robert Haas)
     __________________________________________________________________

ALTER

     * Add "ALTER TYPE RENAME" (Petr Jelinek)
     * Add "ALTER SEQUENCE ... RESTART" (with no parameter) to reset a
       sequence to its initial value (Zoltan Boszormenyi)
     * Modify the "ALTER TABLE" syntax to allow all reasonable
       combinations for tables, indexes, sequences, and views (Tom)
       This change allows the following new syntaxes:
          + "ALTER SEQUENCE OWNER TO"
          + "ALTER VIEW ALTER COLUMN SET/DROP DEFAULT"
          + "ALTER VIEW OWNER TO"
          + "ALTER VIEW SET SCHEMA"
       There is no actual new functionality here, but formerly you had to
       say "ALTER TABLE" to do these things, which was confusing.
     * Add support for the syntax "ALTER TABLE ... ALTER COLUMN ... SET
       DATA TYPE" (Peter)
       This is SQL-standard syntax for functionality that was already
       supported.
     * Make "ALTER TABLE SET WITHOUT OIDS" rewrite the table to physically
       remove OID values (Tom)
       Also, add "ALTER TABLE SET WITH OIDS" to rewrite the table to add
       OIDs.
     __________________________________________________________________

Database Manipulation

     * Improve reporting of "CREATE"/"DROP"/"RENAME DATABASE" failure when
       uncommitted prepared transactions are the cause (Tom)
     * Make LC_COLLATE and LC_CTYPE into per-database settings (Radek
       Strnad, Heikki)
       This makes collation similar to encoding, which was always
       configurable per database.
     * Improve checks that the database encoding, collation (LC_COLLATE),
       and character classes (LC_CTYPE) match (Heikki, Tom)
       Note in particular that a new database's encoding and locale
       settings can be changed only when copying from template0. This
       prevents possibly copying data that doesn't match the settings.
     * Add "ALTER DATABASE SET TABLESPACE" to move a database to a new
       tablespace (Guillaume Lelarge, Bernd Helmle)
     __________________________________________________________________

Utility Operations

     * Add a VERBOSE option to the "CLUSTER" command and clusterdb (Jim
       Cox)
     * Decrease memory requirements for recording pending trigger events
       (Tom)
     __________________________________________________________________

Indexes

     * Dramatically improve the speed of building and accessing hash
       indexes (Tom Raney, Shreya Bhargava)
       This allows hash indexes to be sometimes faster than btree indexes.
       However, hash indexes are still not crash-safe.
     * Make hash indexes store only the hash code, not the full value of
       the indexed column (Xiao Meng)
       This greatly reduces the size of hash indexes for long indexed
       values, improving performance.
     * Implement fast update option for GIN indexes (Teodor, Oleg)
       This option greatly improves update speed at a small penalty in
       search speed.
     * xxx_pattern_ops indexes can now be used for simple equality
       comparisons, not only for LIKE (Tom)
     __________________________________________________________________

Full Text Indexes

     * Remove the requirement to use @@@ when doing GIN weighted lookups
       on full text indexes (Tom, Teodor)
       The normal @@ text search operator can be used instead.
     * Add an optimizer selectivity function for @@ text search operations
       (Jan Urbanski)
     * Allow prefix matching in full text searches (Teodor Sigaev, Oleg
       Bartunov)
     * Support multi-column GIN indexes (Teodor Sigaev)
     * Improve support for Nepali language and Devanagari alphabet
       (Teodor)
     __________________________________________________________________

VACUUM

     * Track free space in separate per-relation "fork" files (Heikki)
       Free space discovered by "VACUUM" is now recorded in "*_fsm" files,
       rather than in a fixed-sized shared memory area. The max_fsm_pages
       and max_fsm_relations settings have been removed, greatly
       simplifying administration of free space management.
     * Add a visibility map to track pages that do not require vacuuming
       (Heikki)
       This allows "VACUUM" to avoid scanning all of a table when only a
       portion of the table needs vacuuming. The visibility map is stored
       in per-relation "fork" files.
     * Add vacuum_freeze_table_age parameter to control when "VACUUM"
       should ignore the visibility map and do a full table scan to freeze
       tuples (Heikki)
     * Track transaction snapshots more carefully (Alvaro)
       This improves "VACUUM"'s ability to reclaim space in the presence
       of long-running transactions.
     * Add ability to specify per-relation autovacuum and TOAST parameters
       in "CREATE TABLE" (Alvaro, Euler Taveira de Oliveira)
       Autovacuum options used to be stored in a system table.
     * Add --freeze option to vacuumdb (Bruce)
     __________________________________________________________________

Data Types

     * Add a CaseSensitive option for text search synonym dictionaries
       (Simon)
     * Improve the precision of NUMERIC division (Tom)
     * Add basic arithmetic operators for int2 with int8 (Tom)
       This eliminates the need for explicit casting in some situations.
     * Allow UUID input to accept an optional hyphen after every fourth
       digit (Robert Haas)
     * Allow on/off as input for the boolean data type (Itagaki Takahiro)
     * Allow spaces around NaN in the input string for type numeric (Sam
       Mason)
     __________________________________________________________________

Temporal Data Types

     * Reject year 0 BC and years 000 and 0000 (Tom)
       Previously these were interpreted as 1 BC. (Note: years 0 and 00
       are still assumed to be the year 2000.)
     * Include SGT (Singapore time) in the default list of known time zone
       abbreviations (Tom)
     * Support infinity and -infinity as values of type date (Tom)
     * Make parsing of interval literals more standard-compliant (Tom, Ron
       Mayer)
       For example, INTERVAL '1' YEAR now does what it's supposed to.
     * Allow interval fractional-seconds precision to be specified after
       the second keyword, for SQL standard compliance (Tom)
       Formerly the precision had to be specified after the keyword
       interval. (For backwards compatibility, this syntax is still
       supported, though deprecated.) Data type definitions will now be
       output using the standard format.
     * Support the IS0 8601 interval syntax (Ron Mayer, Kevin Grittner)
       For example, INTERVAL 'P1Y2M3DT4H5M6.7S' is now supported.
     * Add IntervalStyle parameter which controls how interval values are
       output (Ron Mayer)
       Valid values are: postgres, postgres_verbose, sql_standard,
       iso_8601. This setting also controls the handling of negative
       interval input when only some fields have positive/negative
       designations.
     * Improve consistency of handling of fractional seconds in timestamp
       and interval output (Ron Mayer)
     __________________________________________________________________

Arrays

     * Improve the handling of casts applied to ARRAY[] constructs, such
       as ARRAY[...]::integer[] (Brendan Jurd)
       Formerly PostgreSQL attempted to determine a data type for the
       ARRAY[] construct without reference to the ensuing cast. This could
       fail unnecessarily in many cases, in particular when the ARRAY[]
       construct was empty or contained only ambiguous entries such as
       NULL. Now the cast is consulted to determine the type that the
       array elements must be.
     * Make SQL-syntax ARRAY dimensions optional to match the SQL standard
       (Peter)
     * Add array_ndims() to return the number of dimensions of an array
       (Robert Haas)
     * Add array_length() to return the length of an array for a specified
       dimension (Jim Nasby, Robert Haas, Peter Eisentraut)
     * Add aggregate function array_agg(), which returns all aggregated
       values as a single array (Robert Haas, Jeff Davis, Peter)
     * Add unnest(), which converts an array to individual row values
       (Tom)
       This is the opposite of array_agg().
     * Add array_fill() to create arrays initialized with a value (Pavel
       Stehule)
     * Add generate_subscripts() to simplify generating the range of an
       array's subscripts (Pavel Stehule)
     __________________________________________________________________

Wide-Value Storage (TOAST)

     * Consider TOAST compression on values as short as 32 bytes
       (previously 256 bytes) (Greg Stark)
     * Require 25% minimum space savings before using TOAST compression
       (previously 20% for small values and any-savings-at-all for large
       values) (Greg)
     * Improve TOAST heuristics for rows that have a mix of large and
       small toastable fields, so that we prefer to push large values out
       of line and don't compress small values unnecessarily (Greg, Tom)
     __________________________________________________________________

Functions

     * Document that setseed() allows values from -1 to 1 (not just 0 to
       1), and enforce the valid range (Kris Jurka)
     * Add server-side function lo_import(filename, oid) (Tatsuo)
     * Add quote_nullable(), which behaves like quote_literal() but
       returns the string NULL for a null argument (Brendan Jurd)
     * Improve full text search headline() function to allow extracting
       several fragments of text (Sushant Sinha)
     * Add suppress_redundant_updates_trigger() trigger function to avoid
       overhead for non-data-changing updates (Andrew)
     * Add div(numeric, numeric) to perform numeric division without
       rounding (Tom)
     * Add timestamp and timestamptz versions of generate_series()
       (Hitoshi Harada)
     __________________________________________________________________

Object Information Functions

     * Implement current_query() for use by functions that need to know
       the currently running query (Tomas Doran)
     * Add pg_get_keywords() to return a list of the parser keywords (Dave
       Page)
     * Add pg_get_functiondef() to see a function's definition (Abhijit
       Menon-Sen)
     * Allow the second argument of pg_get_expr() to be zero when
       deparsing an expression that does not contain variables (Tom)
     * Modify pg_relation_size() to use regclass (Heikki)
       pg_relation_size(data_type_name) no longer works.
     * Add boot_val and reset_val columns to pg_settings output (Greg
       Smith)
     * Add source file name and line number columns to pg_settings output
       for variables set in a configuration file (Magnus, Alvaro)
       For security reasons, these columns are only visible to superusers.
     * Add support for CURRENT_CATALOG, CURRENT_SCHEMA, SET CATALOG, SET
       SCHEMA (Peter)
       These provide SQL-standard syntax for existing features.
     * Add pg_typeof() which returns the data type of any value (Brendan
       Jurd)
     * Make version() return information about whether the server is a 32-
       or 64-bit binary (Bruce)
     * Fix the behavior of information schema columns is_insertable_into
       and is_updatable to be consistent (Peter)
     * Improve the behavior of information schema datetime_precision
       columns (Peter)
       These columns now show zero for date columns, and 6 (the default
       precision) for time, timestamp, and interval without a declared
       precision, rather than showing null as formerly.
     * Convert remaining builtin set-returning functions to use OUT
       parameters (Jaime Casanova)
       This makes it possible to call these functions without specifying a
       column list: pg_show_all_settings(), pg_lock_status(),
       pg_prepared_xact(), pg_prepared_statement(), pg_cursor()
     * Make pg_*_is_visible() and has_*_privilege() functions return NULL
       for invalid OIDs, rather than reporting an error (Tom)
     * Extend has_*_privilege() functions to allow inquiring about the OR
       of multiple privileges in one call (Stephen Frost, Tom)
     * Add has_column_privilege() and has_any_column_privilege() functions
       (Stephen Frost, Tom)
     __________________________________________________________________

Function Creation

     * Support variadic functions (functions with a variable number of
       arguments) (Pavel Stehule)
       Only trailing arguments can be optional, and they all must be of
       the same data type.
     * Support default values for function arguments (Pavel Stehule)
     * Add "CREATE FUNCTION ... RETURNS TABLE" clause (Pavel Stehule)
     * Allow SQL-language functions to return the output of an
       "INSERT"/"UPDATE"/"DELETE" RETURNING clause (Tom)
     __________________________________________________________________

PL/pgSQL Server-Side Language

     * Support EXECUTE USING for easier insertion of data values into a
       dynamic query string (Pavel Stehule)
     * Allow looping over the results of a cursor using a FOR loop (Pavel
       Stehule)
     * Support RETURN QUERY EXECUTE (Pavel Stehule)
     * Improve the RAISE command (Pavel Stehule)
          + Support DETAIL and HINT fields
          + Support specification of the SQLSTATE error code
          + Support an exception name parameter
          + Allow RAISE without parameters in an exception block to
            re-throw the current error
     * Allow specification of SQLSTATE codes in EXCEPTION lists (Pavel
       Stehule)
       This is useful for handling custom SQLSTATE codes.
     * Support the CASE statement (Pavel Stehule)
     * Make "RETURN QUERY" set the special FOUND and "GET DIAGNOSTICS"
       ROW_COUNT variables (Pavel Stehule)
     * Make "FETCH" and "MOVE" set the "GET DIAGNOSTICS" ROW_COUNT
       variable (Andrew Gierth)
     * Make "EXIT" without a label always exit the innermost loop (Tom)
       Formerly, if there were a BEGIN block more closely nested than any
       loop, it would exit that block instead. The new behavior matches
       Oracle(TM) and is also what was previously stated by our own
       documentation.
     * Make processing of string literals and nested block comments match
       the main SQL parser's processing (Tom)
       In particular, the format string in "RAISE" now works the same as
       any other string literal, including being subject to
       standard_conforming_strings. This change also fixes other cases in
       which valid commands would fail when standard_conforming_strings is
       on.
     * Avoid memory leakage when the same function is called at varying
       exception-block nesting depths (Tom)
     __________________________________________________________________

Client Applications

     * Fix pg_ctl restart to preserve command-line arguments (Bruce)
     * Add -w/--no-password option that prevents password prompting in all
       utilities that have a -W/--password option (Peter)
     * Remove "-q" (quiet) option of createdb, createuser, dropdb,
       dropuser (Peter)
       These options have had no effect since PostgreSQL 8.3.
     __________________________________________________________________

psql

     * Remove verbose startup banner; now just suggest help (Joshua Drake)
     * Make help show common backslash commands (Greg Sabino Mullane)
     * Add \pset format wrapped mode to wrap output to the screen width,
       or file/pipe output too if \pset columns is set (Bryce Nesbitt)
     * Allow all supported spellings of boolean values in "\pset", rather
       than just on and off (Bruce)
       Formerly, any string other than "off" was silently taken to mean
       true. psql will now complain about unrecognized spellings (but
       still take them as true).
     * Use the pager for wide output (Bruce)
     * Require a space between a one-letter backslash command and its
       first argument (Bernd Helmle)
       This removes a historical source of ambiguity.
     * Improve tab completion support for schema-qualified and quoted
       identifiers (Greg Sabino Mullane)
     * Add optional on/off argument for "\timing" (David Fetter)
     * Display access control rights on multiple lines (Brendan Jurd,
       Andreas Scherbaum)
     * Make "\l" show database access privileges (Andrew Gilligan)
     * Make "\l+" show database sizes, if permissions allow (Andrew
       Gilligan)
     * Add the "\ef" command to edit function definitions (Abhijit
       Menon-Sen)
     __________________________________________________________________

psql \d* commands

     * Make "\d*" commands that do not have a pattern argument show system
       objects only if the S modifier is specified (Greg Sabino Mullane,
       Bruce)
       The former behavior was inconsistent across different variants of
       "\d", and in most cases it provided no easy way to see just user
       objects.
     * Improve "\d*" commands to work with older PostgreSQL server
       versions (back to 7.4), not only the current server version
       (Guillaume Lelarge)
     * Make "\d" show foreign-key constraints that reference the selected
       table (Kenneth D'Souza)
     * Make "\d" on a sequence show its column values (Euler Taveira de
       Oliveira)
     * Add column storage type and other relation options to the "\d+"
       display (Gregory Stark, Euler Taveira de Oliveira)
     * Show relation size in "\dt+" output (Dickson S. Guedes)
     * Show the possible values of enum types in "\dT+" (David Fetter)
     * Allow "\dC" to accept a wildcard pattern, which matches either
       datatype involved in the cast (Tom)
     * Add a function type column to "\df"'s output, and add options to
       list only selected types of functions (David Fetter)
     * Make "\df" not hide functions that take or return type cstring
       (Tom)
       Previously, such functions were hidden because most of them are
       datatype I/O functions, which were deemed uninteresting. The new
       policy about hiding system functions by default makes this wart
       unnecessary.
     __________________________________________________________________

pg_dump

     * Add a --no-tablespaces option to pg_dump/pg_dumpall/pg_restore so
       that dumps can be restored to clusters that have non-matching
       tablespace layouts (Gavin Roy)
     * Remove "-d" and "-D" options from pg_dump and pg_dumpall (Tom)
       These options were too frequently confused with the option to
       select a database name in other PostgreSQL client applications. The
       functionality is still available, but you must now spell out the
       long option name "--inserts" or "--column-inserts".
     * Remove "-i"/"--ignore-version" option from pg_dump and pg_dumpall
       (Tom)
       Use of this option does not throw an error, but it has no effect.
       This option was removed because the version checks are necessary
       for safety.
     * Disable statement_timeout during dump and restore (Joshua Drake)
     * Add pg_dump/pg_dumpall option "--lock-wait-timeout" (David Gould)
       This allows dumps to fail if unable to acquire a shared lock within
       the specified amount of time.
     * Reorder pg_dump --data-only output to dump tables referenced by
       foreign keys before the referencing tables (Tom)
       This allows data loads when foreign keys are already present. If
       circular references make a safe ordering impossible, a NOTICE is
       issued.
     * Allow pg_dump, pg_dumpall, and pg_restore to use a specified role
       (Benedek László)
     * Allow pg_restore to use multiple concurrent connections to do the
       restore (Andrew)
       The number of concurrent connections is controlled by the option
       --jobs. This is supported only for custom-format archives.
     __________________________________________________________________

Programming Tools

libpq

     * Allow the OID to be specified when importing a large object, via
       new function lo_import_with_oid() (Tatsuo)
     * Add "events" support (Andrew Chernow, Merlin Moncure)
       This adds the ability to register callbacks to manage private data
       associated with PGconn and PGresult objects.
     * Improve error handling to allow the return of multiple error
       messages as multi-line error reports (Magnus)
     * Make PQexecParams() and related functions return PGRES_EMPTY_QUERY
       for an empty query (Tom)
       They previously returned PGRES_COMMAND_OK.
     * Document how to avoid the overhead of WSACleanup() on Windows
       (Andrew Chernow)
     * Do not rely on Kerberos tickets to determine the default database
       username (Magnus)
       Previously, a Kerberos-capable build of libpq would use the
       principal name from any available Kerberos ticket as default
       database username, even if the connection wasn't using Kerberos
       authentication. This was deemed inconsistent and confusing. The
       default username is now determined the same way with or without
       Kerberos. Note however that the database username must still match
       the ticket when Kerberos authentication is used.
     __________________________________________________________________

libpq SSL (Secure Sockets Layer) support

     * Fix certificate validation for SSL connections (Magnus)
       libpq now supports verifying both the certificate and the name of
       the server when making SSL connections. If a root certificate is
       not available to use for verification, SSL connections will fail.
       The sslmode parameter is used to enable certificate verification
       and set the level of checking. The default is still not to do any
       verification, allowing connections to SSL-enabled servers without
       requiring a root certificate on the client.
     * Support wildcard server certificates (Magnus)
       If a certificate CN starts with *, it will be treated as a wildcard
       when matching the hostname, allowing the use of the same
       certificate for multiple servers.
     * Allow the file locations for client certificates to be specified
       (Mark Woodward, Alvaro, Magnus)
     * Add a PQinitOpenSSL function to allow greater control over
       OpenSSL/libcrypto initialization (Andrew Chernow)
     * Make libpq unregister its OpenSSL callbacks when no database
       connections remain open (Bruce, Magnus, Russell Smith)
       This is required for applications that unload the libpq library,
       otherwise invalid OpenSSL callbacks will remain.
     __________________________________________________________________

ecpg

     * Add localization support for messages (Euler Taveira de Oliveira)
     * ecpg parser is now automatically generated from the server parser
       (Michael)
       Previously the ecpg parser was hand-maintained.
     __________________________________________________________________

Server Programming Interface (SPI)

     * Add support for single-use plans with out-of-line parameters (Tom)
     * Add new SPI_OK_REWRITTEN return code for SPI_execute() (Heikki)
       This is used when a command is rewritten to another type of
       command.
     * Remove unnecessary inclusions from "executor/spi.h" (Tom)
       SPI-using modules might need to add some #include lines if they
       were depending on "spi.h" to include things for them.
     __________________________________________________________________

Build Options

     * Update build system to use Autoconf 2.61 (Peter)
     * Require GNU bison for source code builds (Peter)
       This has effectively been required for several years, but now there
       is no infrastructure claiming to support other parser tools.
     * Add pg_config --htmldir option (Peter)
     * Pass float4 by value inside the server (Zoltan Boszormenyi)
       Add configure option --disable-float4-byval to use the old
       behavior. External C functions that use old-style (version 0) call
       convention and pass or return float4 values will be broken by this
       change, so you may need the configure option if you have such
       functions and don't want to update them.
     * Pass float8, int8, and related datatypes by value inside the server
       on 64-bit platforms (Zoltan Boszormenyi)
       Add configure option --disable-float8-byval to use the old
       behavior. As above, this change might break old-style external C
       functions.
     * Add configure options --with-segsize, --with-blocksize,
       --with-wal-blocksize, --with-wal-segsize (Zdenek Kotala, Tom)
       This simplifies build-time control over several constants that
       previously could only be changed by editing "pg_config_manual.h".
     * Allow threaded builds on Solaris 2.5 (Bruce)
     * Use the system's getopt_long() on Solaris (Zdenek Kotala, Tom)
       This makes option processing more consistent with what Solaris
       users expect.
     * Add support for the Sun Studio compiler on Linux (Julius Stroffek)
     * Append the major version number to the backend gettext domain, and
       the soname major version number to libraries' gettext domain
       (Peter)
       This simplifies parallel installations of multiple versions.
     * Add support for code coverage testing with gcov (Michelle Caisse)
     * Allow out-of-tree builds on Mingw and Cygwin (Richard Evans)
     * Fix the use of Mingw as a cross-compiling source platform (Peter)
     __________________________________________________________________

Source Code

     * Support 64-bit time zone data files (Heikki)
       This adds support for daylight saving time (DST) calculations
       beyond the year 2038.
     * Deprecate use of platform's time_t data type (Tom)
       Some platforms have migrated to 64-bit time_t, some have not, and
       Windows can't make up its mind what it's doing. Define pg_time_t to
       have the same meaning as time_t, but always be 64 bits (unless the
       platform has no 64-bit integer type), and use that type in all
       module APIs and on-disk data formats.
     * Fix bug in handling of the time zone database when cross-compiling
       (Richard Evans)
     * Link backend object files in one step, rather than in stages
       (Peter)
     * Improve gettext support to allow better translation of plurals
       (Peter)
     * Add message translation support to the PL languages (Alvaro, Peter)
     * Add more DTrace probes (Robert Lor)
     * Enable DTrace support on Mac OS X Leopard and other non-Solaris
       platforms (Robert Lor)
     * Simplify and standardize conversions between C strings and text
       datums, by providing common functions for the purpose (Brendan
       Jurd, Tom)
     * Clean up the "include/catalog/" header files so that frontend
       programs can include them without including "postgres.h" (Zdenek
       Kotala)
     * Make name char-aligned, and suppress zero-padding of name entries
       in indexes (Tom)
     * Recover better if dynamically-loaded code executes exit() (Tom)
     * Add a hook to let plug-ins monitor the executor (Itagaki Takahiro)
     * Add a hook to allow the planner's statistics lookup behavior to be
       overridden (Simon Riggs)
     * Add shmem_startup_hook() for custom shared memory requirements
       (Tom)
     * Replace the index access method amgetmulti entry point with
       amgetbitmap, and extend the API for amgettuple to support run-time
       determination of operator lossiness (Heikki, Tom, Teodor)
       The API for GIN and GiST opclass consistent functions has been
       extended as well.
     * Add support for partial-match searches in GIN indexes (Teodor
       Sigaev, Oleg Bartunov)
     * Replace pg_class column reltriggers with boolean relhastriggers
       (Simon)
       Also remove unused pg_class columns relukeys, relfkeys, and
       relrefs.
     * Add a relistemp column to pg_class to ease identification of
       temporary tables (Tom)
     * Move platform FAQs into the main documentation (Peter)
     * Prevent parser input files from being built with any conflicts
       (Peter)
     * Add support for the KOI8U (Ukrainian) encoding (Peter)
     * Add Japanese message translations (Japan PostgreSQL Users Group)
       This used to be maintained as a separate project.
     * Fix problem when setting LC_MESSAGES on MSVC-built systems (Hiroshi
       Inoue, Hiroshi Saito, Magnus)
     __________________________________________________________________

Contrib

     * Add "contrib/auto_explain" to automatically run "EXPLAIN" on
       queries exceeding a specified duration (Itagaki Takahiro, Tom)
     * Add "contrib/btree_gin" to allow GIN indexes to handle more
       datatypes (Oleg, Teodor)
     * Add "contrib/citext" to provide a case-insensitive, multibyte-aware
       text data type (David Wheeler)
     * Add "contrib/pg_stat_statements" for server-wide tracking of
       statement execution statistics (Itagaki Takahiro)
     * Add duration and query mode options to "contrib/pgbench" (Itagaki
       Takahiro)
     * Make "contrib/pgbench" use table names pgbench_accounts,
       pgbench_branches, pgbench_history, and pgbench_tellers, rather than
       just accounts, branches, history, and tellers (Tom)
       This is to reduce the risk of accidentally destroying real data by
       running pgbench.
     * Fix "contrib/pgstattuple" to handle tables and indexes with over 2
       billion pages (Tatsuhito Kasahara)
     * In "contrib/fuzzystrmatch", add a version of the Levenshtein
       string-distance function that allows the user to specify the costs
       of insertion, deletion, and substitution (Volkan Yazici)
     * Make "contrib/ltree" support multibyte encodings (laser)
     * Enable "contrib/dblink" to use connection information stored in the
       SQL/MED catalogs (Joe Conway)
     * Improve "contrib/dblink"'s reporting of errors from the remote
       server (Joe Conway)
     * Make "contrib/dblink" set client_encoding to match the local
       database's encoding (Joe Conway)
       This prevents encoding problems when communicating with a remote
       database that uses a different encoding.
     * Make sure "contrib/dblink" uses a password supplied by the user,
       and not accidentally taken from the server's ".pgpass" file (Joe
       Conway)
       This is a minor security enhancement.
     * Add fsm_page_contents() to "contrib/pageinspect" (Heikki)
     * Modify get_raw_page() to support free space map ("*_fsm") files.
       Also update "contrib/pg_freespacemap".
     * Add support for multibyte encodings to "contrib/pg_trgm" (Teodor)
     * Rewrite "contrib/intagg" to use new functions array_agg() and
       unnest() (Tom)
     * Make "contrib/pg_standby" recover all available WAL before failover
       (Fujii Masao, Simon, Heikki)
       To make this work safely, you now need to set the new
       recovery_end_command option in "recovery.conf" to clean up the
       trigger file after failover. pg_standby will no longer remove the
       trigger file itself.
     * "contrib/pg_standby"'s "-l" option is now a no-op, because it is
       unsafe to use a symlink (Simon)
     __________________________________________________________________

                               Release 8.3.14

     Release date: 2011-01-31

   This release contains a variety of fixes from 8.3.13. For information
   about new features in the 8.3 major release, see the Section called
   Release 8.3.
     __________________________________________________________________

Migration to Version 8.3.14

   A dump/restore is not required for those running 8.3.X. However, if you
   are upgrading from a version earlier than 8.3.8, see the release notes
   for 8.3.8.
     __________________________________________________________________

Changes

     * Avoid failures when "EXPLAIN" tries to display a simple-form CASE
       expression (Tom Lane)
       If the CASE's test expression was a constant, the planner could
       simplify the CASE into a form that confused the expression-display
       code, resulting in "unexpected CASE WHEN clause" errors.
     * Fix assignment to an array slice that is before the existing range
       of subscripts (Tom Lane)
       If there was a gap between the newly added subscripts and the first
       pre-existing subscript, the code miscalculated how many entries
       needed to be copied from the old array's null bitmap, potentially
       leading to data corruption or crash.
     * Avoid unexpected conversion overflow in planner for very distant
       date values (Tom Lane)
       The date type supports a wider range of dates than can be
       represented by the timestamp types, but the planner assumed it
       could always convert a date to timestamp with impunity.
     * Fix pg_restore's text output for large objects (BLOBs) when
       standard_conforming_strings is on (Tom Lane)
       Although restoring directly to a database worked correctly, string
       escaping was incorrect if pg_restore was asked for SQL text output
       and standard_conforming_strings had been enabled in the source
       database.
     * Fix erroneous parsing of tsquery values containing ... &
       !(subexpression) | ... (Tom Lane)
       Queries containing this combination of operators were not executed
       correctly. The same error existed in "contrib/intarray"'s query_int
       type and "contrib/ltree"'s ltxtquery type.
     * Fix buffer overrun in "contrib/intarray"'s input function for the
       query_int type (Apple)
       This bug is a security risk since the function's return address
       could be overwritten. Thanks to Apple Inc's security team for
       reporting this issue and supplying the fix. (CVE-2010-4015)
     * Fix bug in "contrib/seg"'s GiST picksplit algorithm (Alexander
       Korotkov)
       This could result in considerable inefficiency, though not actually
       incorrect answers, in a GiST index on a seg column. If you have
       such an index, consider "REINDEX"ing it after installing this
       update. (This is identical to the bug that was fixed in
       "contrib/cube" in the previous update.)
     __________________________________________________________________

                               Release 8.3.13

     Release date: 2010-12-16

   This release contains a variety of fixes from 8.3.12. For information
   about new features in the 8.3 major release, see the Section called
   Release 8.3.
     __________________________________________________________________

Migration to Version 8.3.13

   A dump/restore is not required for those running 8.3.X. However, if you
   are upgrading from a version earlier than 8.3.8, see the release notes
   for 8.3.8.
     __________________________________________________________________

Changes

     * Force the default wal_sync_method to be fdatasync on Linux (Tom
       Lane, Marti Raudsepp)
       The default on Linux has actually been fdatasync for many years,
       but recent kernel changes caused PostgreSQL to choose open_datasync
       instead. This choice did not result in any performance improvement,
       and caused outright failures on certain filesystems, notably ext4
       with the data=journal mount option.
     * Fix assorted bugs in WAL replay logic for GIN indexes (Tom Lane)
       This could result in "bad buffer id: 0" failures or corruption of
       index contents during replication.
     * Fix recovery from base backup when the starting checkpoint WAL
       record is not in the same WAL segment as its redo point (Jeff
       Davis)
     * Fix persistent slowdown of autovacuum workers when multiple workers
       remain active for a long time (Tom Lane)
       The effective vacuum_cost_limit for an autovacuum worker could drop
       to nearly zero if it processed enough tables, causing it to run
       extremely slowly.
     * Add support for detecting register-stack overrun on IA64 (Tom Lane)
       The IA64 architecture has two hardware stacks. Full prevention of
       stack-overrun failures requires checking both.
     * Add a check for stack overflow in copyObject() (Tom Lane)
       Certain code paths could crash due to stack overflow given a
       sufficiently complex query.
     * Fix detection of page splits in temporary GiST indexes (Heikki
       Linnakangas)
       It is possible to have a "concurrent" page split in a temporary
       index, if for example there is an open cursor scanning the index
       when an insertion is done. GiST failed to detect this case and
       hence could deliver wrong results when execution of the cursor
       continued.
     * Avoid memory leakage while "ANALYZE"'ing complex index expressions
       (Tom Lane)
     * Ensure an index that uses a whole-row Var still depends on its
       table (Tom Lane)
       An index declared like create index i on t (foo(t.*)) would not
       automatically get dropped when its table was dropped.
     * Do not "inline" a SQL function with multiple OUT parameters (Tom
       Lane)
       This avoids a possible crash due to loss of information about the
       expected result rowtype.
     * Behave correctly if ORDER BY, LIMIT, FOR UPDATE, or WITH is
       attached to the VALUES part of INSERT ... VALUES (Tom Lane)
     * Fix constant-folding of COALESCE() expressions (Tom Lane)
       The planner would sometimes attempt to evaluate sub-expressions
       that in fact could never be reached, possibly leading to unexpected
       errors.
     * Fix postmaster crash when connection acceptance (accept() or one of
       the calls made immediately after it) fails, and the postmaster was
       compiled with GSSAPI support (Alexander Chernikov)
     * Fix missed unlink of temporary files when log_temp_files is active
       (Tom Lane)
       If an error occurred while attempting to emit the log message, the
       unlink was not done, resulting in accumulation of temp files.
     * Add print functionality for InhRelation nodes (Tom Lane)
       This avoids a failure when debug_print_parse is enabled and certain
       types of query are executed.
     * Fix incorrect calculation of distance from a point to a horizontal
       line segment (Tom Lane)
       This bug affected several different geometric distance-measurement
       operators.
     * Fix PL/pgSQL's handling of "simple" expressions to not fail in
       recursion or error-recovery cases (Tom Lane)
     * Fix PL/Python's handling of set-returning functions (Jan Urbanski)
       Attempts to call SPI functions within the iterator generating a set
       result would fail.
     * Fix bug in "contrib/cube"'s GiST picksplit algorithm (Alexander
       Korotkov)
       This could result in considerable inefficiency, though not actually
       incorrect answers, in a GiST index on a cube column. If you have
       such an index, consider "REINDEX"ing it after installing this
       update.
     * Don't emit "identifier will be truncated" notices in
       "contrib/dblink" except when creating new connections (Itagaki
       Takahiro)
     * Fix potential coredump on missing public key in "contrib/pgcrypto"
       (Marti Raudsepp)
     * Fix memory leak in "contrib/xml2"'s XPath query functions (Tom
       Lane)
     * Update time zone data files to tzdata release 2010o for DST law
       changes in Fiji and Samoa; also historical corrections for Hong
       Kong.
     __________________________________________________________________

                               Release 8.3.12

     Release date: 2010-10-04

   This release contains a variety of fixes from 8.3.11. For information
   about new features in the 8.3 major release, see the Section called
   Release 8.3.
     __________________________________________________________________

Migration to Version 8.3.12

   A dump/restore is not required for those running 8.3.X. However, if you
   are upgrading from a version earlier than 8.3.8, see the release notes
   for 8.3.8.
     __________________________________________________________________

Changes

     * Use a separate interpreter for each calling SQL userid in PL/Perl
       and PL/Tcl (Tom Lane)
       This change prevents security problems that can be caused by
       subverting Perl or Tcl code that will be executed later in the same
       session under another SQL user identity (for example, within a
       SECURITY DEFINER function). Most scripting languages offer numerous
       ways that that might be done, such as redefining standard functions
       or operators called by the target function. Without this change,
       any SQL user with Perl or Tcl language usage rights can do
       essentially anything with the SQL privileges of the target
       function's owner.
       The cost of this change is that intentional communication among
       Perl and Tcl functions becomes more difficult. To provide an escape
       hatch, PL/PerlU and PL/TclU functions continue to use only one
       interpreter per session. This is not considered a security issue
       since all such functions execute at the trust level of a database
       superuser already.
       It is likely that third-party procedural languages that claim to
       offer trusted execution have similar security issues. We advise
       contacting the authors of any PL you are depending on for
       security-critical purposes.
       Our thanks to Tim Bunce for pointing out this issue
       (CVE-2010-3433).
     * Prevent possible crashes in pg_get_expr() by disallowing it from
       being called with an argument that is not one of the system catalog
       columns it's intended to be used with (Heikki Linnakangas, Tom
       Lane)
     * Treat exit code 128 (ERROR_WAIT_NO_CHILDREN) as non-fatal on
       Windows (Magnus Hagander)
       Under high load, Windows processes will sometimes fail at startup
       with this error code. Formerly the postmaster treated this as a
       panic condition and restarted the whole database, but that seems to
       be an overreaction.
     * Fix incorrect usage of non-strict OR joinclauses in Append
       indexscans (Tom Lane)
       This is a back-patch of an 8.4 fix that was missed in the 8.3
       branch. This corrects an error introduced in 8.3.8 that could cause
       incorrect results for outer joins when the inner relation is an
       inheritance tree or UNION ALL subquery.
     * Fix possible duplicate scans of UNION ALL member relations (Tom
       Lane)
     * Fix "cannot handle unplanned sub-select" error (Tom Lane)
       This occurred when a sub-select contains a join alias reference
       that expands into an expression containing another sub-select.
     * Fix failure to mark cached plans as transient (Tom Lane)
       If a plan is prepared while "CREATE INDEX CONCURRENTLY" is in
       progress for one of the referenced tables, it is supposed to be
       re-planned once the index is ready for use. This was not happening
       reliably.
     * Reduce PANIC to ERROR in some occasionally-reported btree failure
       cases, and provide additional detail in the resulting error
       messages (Tom Lane)
       This should improve the system's robustness with corrupted indexes.
     * Prevent show_session_authorization() from crashing within
       autovacuum processes (Tom Lane)
     * Defend against functions returning setof record where not all the
       returned rows are actually of the same rowtype (Tom Lane)
     * Fix possible failure when hashing a pass-by-reference function
       result (Tao Ma, Tom Lane)
     * Improve merge join's handling of NULLs in the join columns (Tom
       Lane)
       A merge join can now stop entirely upon reaching the first NULL, if
       the sort order is such that NULLs sort high.
     * Take care to fsync the contents of lockfiles (both "postmaster.pid"
       and the socket lockfile) while writing them (Tom Lane)
       This omission could result in corrupted lockfile contents if the
       machine crashes shortly after postmaster start. That could in turn
       prevent subsequent attempts to start the postmaster from
       succeeding, until the lockfile is manually removed.
     * Avoid recursion while assigning XIDs to heavily-nested
       subtransactions (Andres Freund, Robert Haas)
       The original coding could result in a crash if there was limited
       stack space.
     * Avoid holding open old WAL segments in the walwriter process
       (Magnus Hagander, Heikki Linnakangas)
       The previous coding would prevent removal of no-longer-needed
       segments.
     * Fix log_line_prefix's %i escape, which could produce junk early in
       backend startup (Tom Lane)
     * Fix possible data corruption in "ALTER TABLE ... SET TABLESPACE"
       when archiving is enabled (Jeff Davis)
     * Allow "CREATE DATABASE" and "ALTER DATABASE ... SET TABLESPACE" to
       be interrupted by query-cancel (Guillaume Lelarge)
     * Fix "REASSIGN OWNED" to handle operator classes and families (Asko
       Tiidumaa)
     * Fix possible core dump when comparing two empty tsquery values (Tom
       Lane)
     * Fix LIKE's handling of patterns containing % followed by _ (Tom
       Lane)
       We've fixed this before, but there were still some
       incorrectly-handled cases.
     * In PL/Python, defend against null pointer results from
       PyCObject_AsVoidPtr and PyCObject_FromVoidPtr (Peter Eisentraut)
     * Make psql recognize "DISCARD ALL" as a command that should not be
       encased in a transaction block in autocommit-off mode (Itagaki
       Takahiro)
     * Fix ecpg to process data from RETURNING clauses correctly (Michael
       Meskes)
     * Improve "contrib/dblink"'s handling of tables containing dropped
       columns (Tom Lane)
     * Fix connection leak after "duplicate connection name" errors in
       "contrib/dblink" (Itagaki Takahiro)
     * Fix "contrib/dblink" to handle connection names longer than 62
       bytes correctly (Itagaki Takahiro)
     * Add hstore(text, text) function to "contrib/hstore" (Robert Haas)
       This function is the recommended substitute for the now-deprecated
       => operator. It was back-patched so that future-proofed code can be
       used with older server versions. Note that the patch will be
       effective only after "contrib/hstore" is installed or reinstalled
       in a particular database. Users might prefer to execute the "CREATE
       FUNCTION" command by hand, instead.
     * Update build infrastructure and documentation to reflect the source
       code repository's move from CVS to Git (Magnus Hagander and others)
     * Update time zone data files to tzdata release 2010l for DST law
       changes in Egypt and Palestine; also historical corrections for
       Finland.
       This change also adds new names for two Micronesian timezones:
       Pacific/Chuuk is now preferred over Pacific/Truk (and the preferred
       abbreviation is CHUT not TRUT) and Pacific/Pohnpei is preferred
       over Pacific/Ponape.
     * Make Windows' "N. Central Asia Standard Time" timezone map to
       Asia/Novosibirsk, not Asia/Almaty (Magnus Hagander)
       Microsoft changed the DST behavior of this zone in the timezone
       update from KB976098. Asia/Novosibirsk is a better match to its new
       behavior.
     __________________________________________________________________

                               Release 8.3.11

     Release date: 2010-05-17

   This release contains a variety of fixes from 8.3.10. For information
   about new features in the 8.3 major release, see the Section called
   Release 8.3.
     __________________________________________________________________

Migration to Version 8.3.11

   A dump/restore is not required for those running 8.3.X. However, if you
   are upgrading from a version earlier than 8.3.8, see the release notes
   for 8.3.8.
     __________________________________________________________________

Changes

     * Enforce restrictions in plperl using an opmask applied to the whole
       interpreter, instead of using "Safe.pm" (Tim Bunce, Andrew Dunstan)
       Recent developments have convinced us that "Safe.pm" is too
       insecure to rely on for making plperl trustable. This change
       removes use of "Safe.pm" altogether, in favor of using a separate
       interpreter with an opcode mask that is always applied. Pleasant
       side effects of the change include that it is now possible to use
       Perl's strict pragma in a natural way in plperl, and that Perl's $a
       and $b variables work as expected in sort routines, and that
       function compilation is significantly faster. (CVE-2010-1169)
     * Prevent PL/Tcl from executing untrustworthy code from pltcl_modules
       (Tom)
       PL/Tcl's feature for autoloading Tcl code from a database table
       could be exploited for trojan-horse attacks, because there was no
       restriction on who could create or insert into that table. This
       change disables the feature unless pltcl_modules is owned by a
       superuser. (However, the permissions on the table are not checked,
       so installations that really need a less-than-secure modules table
       can still grant suitable privileges to trusted non-superusers.)
       Also, prevent loading code into the unrestricted "normal" Tcl
       interpreter unless we are really going to execute a pltclu
       function. (CVE-2010-1170)
     * Fix possible crash if a cache reset message is received during
       rebuild of a relcache entry (Heikki)
       This error was introduced in 8.3.10 while fixing a related failure.
     * Apply per-function GUC settings while running the language
       validator for the function (Itagaki Takahiro)
       This avoids failures if the function's code is invalid without the
       setting; an example is that SQL functions may not parse if the
       search_path is not correct.
     * Do not allow an unprivileged user to reset superuser-only parameter
       settings (Alvaro)
       Previously, if an unprivileged user ran ALTER USER ... RESET ALL
       for himself, or ALTER DATABASE ... RESET ALL for a database he
       owns, this would remove all special parameter settings for the user
       or database, even ones that are only supposed to be changeable by a
       superuser. Now, the "ALTER" will only remove the parameters that
       the user has permission to change.
     * Avoid possible crash during backend shutdown if shutdown occurs
       when a CONTEXT addition would be made to log entries (Tom)
       In some cases the context-printing function would fail because the
       current transaction had already been rolled back when it came time
       to print a log message.
     * Ensure the archiver process responds to changes in archive_command
       as soon as possible (Tom)
     * Update pl/perl's "ppport.h" for modern Perl versions (Andrew)
     * Fix assorted memory leaks in pl/python (Andreas Freund, Tom)
     * Prevent infinite recursion in psql when expanding a variable that
       refers to itself (Tom)
     * Fix psql's \copy to not add spaces around a dot within \copy
       (select ...) (Tom)
       Addition of spaces around the decimal point in a numeric literal
       would result in a syntax error.
     * Fix unnecessary "GIN indexes do not support whole-index scans"
       errors for unsatisfiable queries using "contrib/intarray" operators
       (Tom)
     * Ensure that "contrib/pgstattuple" functions respond to cancel
       interrupts promptly (Tatsuhito Kasahara)
     * Make server startup deal properly with the case that shmget()
       returns EINVAL for an existing shared memory segment (Tom)
       This behavior has been observed on BSD-derived kernels including OS
       X. It resulted in an entirely-misleading startup failure
       complaining that the shared memory request size was too large.
     * Avoid possible crashes in syslogger process on Windows (Heikki)
     * Deal more robustly with incomplete time zone information in the
       Windows registry (Magnus)
     * Update the set of known Windows time zone names (Magnus)
     * Update time zone data files to tzdata release 2010j for DST law
       changes in Argentina, Australian Antarctic, Bangladesh, Mexico,
       Morocco, Pakistan, Palestine, Russia, Syria, Tunisia; also
       historical corrections for Taiwan.
       Also, add PKST (Pakistan Summer Time) to the default set of
       timezone abbreviations.
     __________________________________________________________________

                               Release 8.3.10

     Release date: 2010-03-15

   This release contains a variety of fixes from 8.3.9. For information
   about new features in the 8.3 major release, see the Section called
   Release 8.3.
     __________________________________________________________________

Migration to Version 8.3.10

   A dump/restore is not required for those running 8.3.X. However, if you
   are upgrading from a version earlier than 8.3.8, see the release notes
   for 8.3.8.
     __________________________________________________________________

Changes

     * Add new configuration parameter ssl_renegotiation_limit to control
       how often we do session key renegotiation for an SSL connection
       (Magnus)
       This can be set to zero to disable renegotiation completely, which
       may be required if a broken SSL library is used. In particular,
       some vendors are shipping stopgap patches for CVE-2009-3555 that
       cause renegotiation attempts to fail.
     * Fix possible deadlock during backend startup (Tom)
     * Fix possible crashes due to not handling errors during relcache
       reload cleanly (Tom)
     * Fix possible crash due to use of dangling pointer to a cached plan
       (Tatsuo)
     * Fix possible crashes when trying to recover from a failure in
       subtransaction start (Tom)
     * Fix server memory leak associated with use of savepoints and a
       client encoding different from server's encoding (Tom)
     * Fix incorrect WAL data emitted during end-of-recovery cleanup of a
       GIST index page split (Yoichi Hirai)
       This would result in index corruption, or even more likely an error
       during WAL replay, if we were unlucky enough to crash during
       end-of-recovery cleanup after having completed an incomplete GIST
       insertion.
     * Make substring() for bit types treat any negative length as meaning
       "all the rest of the string" (Tom)
       The previous coding treated only -1 that way, and would produce an
       invalid result value for other negative values, possibly leading to
       a crash (CVE-2010-0442).
     * Fix integer-to-bit-string conversions to handle the first
       fractional byte correctly when the output bit width is wider than
       the given integer by something other than a multiple of 8 bits
       (Tom)
     * Fix some cases of pathologically slow regular expression matching
       (Tom)
     * Fix assorted crashes in xml processing caused by sloppy memory
       management (Tom)
       This is a back-patch of changes first applied in 8.4. The 8.3 code
       was known buggy, but the new code was sufficiently different to not
       want to back-patch it until it had gotten some field testing.
     * Fix bug with trying to update a field of an element of a
       composite-type array column (Tom)
     * Fix the STOP WAL LOCATION entry in backup history files to report
       the next WAL segment's name when the end location is exactly at a
       segment boundary (Itagaki Takahiro)
     * Fix some more cases of temporary-file leakage (Heikki)
       This corrects a problem introduced in the previous minor release.
       One case that failed is when a plpgsql function returning set is
       called within another function's exception handler.
     * Improve constraint exclusion processing of boolean-variable cases,
       in particular make it possible to exclude a partition that has a
       "bool_column = false" constraint (Tom)
     * When reading "pg_hba.conf" and related files, do not treat
       @something as a file inclusion request if the @ appears inside
       quote marks; also, never treat @ by itself as a file inclusion
       request (Tom)
       This prevents erratic behavior if a role or database name starts
       with @. If you need to include a file whose path name contains
       spaces, you can still do so, but you must write @"/path to/file"
       rather than putting the quotes around the whole construct.
     * Prevent infinite loop on some platforms if a directory is named as
       an inclusion target in "pg_hba.conf" and related files (Tom)
     * Fix possible infinite loop if SSL_read or SSL_write fails without
       setting errno (Tom)
       This is reportedly possible with some Windows versions of openssl.
     * Disallow GSSAPI authentication on local connections, since it
       requires a hostname to function correctly (Magnus)
     * Make ecpg report the proper SQLSTATE if the connection disappears
       (Michael)
     * Fix psql's numericlocale option to not format strings it shouldn't
       in latex and troff output formats (Heikki)
     * Make psql return the correct exit status (3) when ON_ERROR_STOP and
       --single-transaction are both specified and an error occurs during
       the implied "COMMIT" (Bruce)
     * Fix plpgsql failure in one case where a composite column is set to
       NULL (Tom)
     * Fix possible failure when calling PL/Perl functions from PL/PerlU
       or vice versa (Tim Bunce)
     * Add volatile markings in PL/Python to avoid possible
       compiler-specific misbehavior (Zdenek Kotala)
     * Ensure PL/Tcl initializes the Tcl interpreter fully (Tom)
       The only known symptom of this oversight is that the Tcl clock
       command misbehaves if using Tcl 8.5 or later.
     * Prevent crash in "contrib/dblink" when too many key columns are
       specified to a dblink_build_sql_* function (Rushabh Lathia, Joe
       Conway)
     * Allow zero-dimensional arrays in "contrib/ltree" operations (Tom)
       This case was formerly rejected as an error, but it's more
       convenient to treat it the same as a zero-element array. In
       particular this avoids unnecessary failures when an ltree operation
       is applied to the result of ARRAY(SELECT ...) and the sub-select
       returns no rows.
     * Fix assorted crashes in "contrib/xml2" caused by sloppy memory
       management (Tom)
     * Make building of "contrib/xml2" more robust on Windows (Andrew)
     * Fix race condition in Windows signal handling (Radu Ilie)
       One known symptom of this bug is that rows in pg_listener could be
       dropped under heavy load.
     * Update time zone data files to tzdata release 2010e for DST law
       changes in Bangladesh, Chile, Fiji, Mexico, Paraguay, Samoa.
     __________________________________________________________________

                                Release 8.3.9

     Release date: 2009-12-14

   This release contains a variety of fixes from 8.3.8. For information
   about new features in the 8.3 major release, see the Section called
   Release 8.3.
     __________________________________________________________________

Migration to Version 8.3.9

   A dump/restore is not required for those running 8.3.X. However, if you
   are upgrading from a version earlier than 8.3.8, see the release notes
   for 8.3.8.
     __________________________________________________________________

Changes

     * Protect against indirect security threats caused by index functions
       changing session-local state (Gurjeet Singh, Tom)
       This change prevents allegedly-immutable index functions from
       possibly subverting a superuser's session (CVE-2009-4136).
     * Reject SSL certificates containing an embedded null byte in the
       common name (CN) field (Magnus)
       This prevents unintended matching of a certificate to a server or
       client name during SSL validation (CVE-2009-4034).
     * Fix possible crash during backend-startup-time cache initialization
       (Tom)
     * Avoid crash on empty thesaurus dictionary (Tom)
     * Prevent signals from interrupting VACUUM at unsafe times (Alvaro)
       This fix prevents a PANIC if a VACUUM FULL is cancelled after it's
       already committed its tuple movements, as well as transient errors
       if a plain VACUUM is interrupted after having truncated the table.
     * Fix possible crash due to integer overflow in hash table size
       calculation (Tom)
       This could occur with extremely large planner estimates for the
       size of a hashjoin's result.
     * Fix very rare crash in inet/cidr comparisons (Chris Mikkelson)
     * Ensure that shared tuple-level locks held by prepared transactions
       are not ignored (Heikki)
     * Fix premature drop of temporary files used for a cursor that is
       accessed within a subtransaction (Heikki)
     * Fix memory leak in syslogger process when rotating to a new CSV
       logfile (Tom)
     * Fix Windows permission-downgrade logic (Jesse Morris)
       This fixes some cases where the database failed to start on
       Windows, often with misleading error messages such as "could not
       locate matching postgres executable".
     * Fix incorrect logic for GiST index page splits, when the split
       depends on a non-first column of the index (Paul Ramsey)
     * Don't error out if recycling or removing an old WAL file fails at
       the end of checkpoint (Heikki)
       It's better to treat the problem as non-fatal and allow the
       checkpoint to complete. Future checkpoints will retry the removal.
       Such problems are not expected in normal operation, but have been
       seen to be caused by misdesigned Windows anti-virus and backup
       software.
     * Ensure WAL files aren't repeatedly archived on Windows (Heikki)
       This is another symptom that could happen if some other process
       interfered with deletion of a no-longer-needed file.
     * Fix PAM password processing to be more robust (Tom)
       The previous code is known to fail with the combination of the
       Linux pam_krb5 PAM module with Microsoft Active Directory as the
       domain controller. It might have problems elsewhere too, since it
       was making unjustified assumptions about what arguments the PAM
       stack would pass to it.
     * Raise the maximum authentication token (Kerberos ticket) size in
       GSSAPI and SSPI authentication methods (Ian Turner)
       While the old 2000-byte limit was more than enough for Unix
       Kerberos implementations, tickets issued by Windows Domain
       Controllers can be much larger.
     * Re-enable collection of access statistics for sequences (Akira
       Kurosawa)
       This used to work but was broken in 8.3.
     * Fix processing of ownership dependencies during CREATE OR REPLACE
       FUNCTION (Tom)
     * Fix incorrect handling of WHERE "x"="x" conditions (Tom)
       In some cases these could get ignored as redundant, but they aren't
       -- they're equivalent to "x" IS NOT NULL.
     * Make text search parser accept underscores in XML attributes
       (Peter)
     * Fix encoding handling in xml binary input (Heikki)
       If the XML header doesn't specify an encoding, we now assume UTF-8
       by default; the previous handling was inconsistent.
     * Fix bug with calling plperl from plperlu or vice versa (Tom)
       An error exit from the inner function could result in crashes due
       to failure to re-select the correct Perl interpreter for the outer
       function.
     * Fix session-lifespan memory leak when a PL/Perl function is
       redefined (Tom)
     * Ensure that Perl arrays are properly converted to PostgreSQL arrays
       when returned by a set-returning PL/Perl function (Andrew Dunstan,
       Abhijit Menon-Sen)
       This worked correctly already for non-set-returning functions.
     * Fix rare crash in exception processing in PL/Python (Peter)
     * In "contrib/pg_standby", disable triggering failover with a signal
       on Windows (Fujii Masao)
       This never did anything useful, because Windows doesn't have
       Unix-style signals, but recent changes made it actually crash.
     * Ensure psql's flex module is compiled with the correct system
       header definitions (Tom)
       This fixes build failures on platforms where --enable-largefile
       causes incompatible changes in the generated code.
     * Make the postmaster ignore any application_name parameter in
       connection request packets, to improve compatibility with future
       libpq versions (Tom)
     * Update the timezone abbreviation files to match current reality
       (Joachim Wieland)
       This includes adding IDT and SGT to the default timezone
       abbreviation set.
     * Update time zone data files to tzdata release 2009s for DST law
       changes in Antarctica, Argentina, Bangladesh, Fiji, Novokuznetsk,
       Pakistan, Palestine, Samoa, Syria; also historical corrections for
       Hong Kong.
     __________________________________________________________________

                                Release 8.3.8

     Release date: 2009-09-09

   This release contains a variety of fixes from 8.3.7. For information
   about new features in the 8.3 major release, see the Section called
   Release 8.3.
     __________________________________________________________________

Migration to Version 8.3.8

   A dump/restore is not required for those running 8.3.X. However, if you
   have any hash indexes on interval columns, you must "REINDEX" them
   after updating to 8.3.8. Also, if you are upgrading from a version
   earlier than 8.3.5, see the release notes for 8.3.5.
     __________________________________________________________________

Changes

     * Fix Windows shared-memory allocation code (Tsutomu Yamada, Magnus)
       This bug led to the often-reported "could not reattach to shared
       memory" error message.
     * Force WAL segment switch during pg_start_backup() (Heikki)
       This avoids corner cases that could render a base backup unusable.
     * Disallow "RESET ROLE" and "RESET SESSION AUTHORIZATION" inside
       security-definer functions (Tom, Heikki)
       This covers a case that was missed in the previous patch that
       disallowed "SET ROLE" and "SET SESSION AUTHORIZATION" inside
       security-definer functions. (See CVE-2007-6600)
     * Make "LOAD" of an already-loaded loadable module into a no-op (Tom)
       Formerly, "LOAD" would attempt to unload and re-load the module,
       but this is unsafe and not all that useful.
     * Disallow empty passwords during LDAP authentication (Magnus)
     * Fix handling of sub-SELECTs appearing in the arguments of an
       outer-level aggregate function (Tom)
     * Fix bugs associated with fetching a whole-row value from the output
       of a Sort or Materialize plan node (Tom)
     * Prevent synchronize_seqscans from changing the results of
       scrollable and WITH HOLD cursors (Tom)
     * Revert planner change that disabled partial-index and constraint
       exclusion optimizations when there were more than 100 clauses in an
       AND or OR list (Tom)
     * Fix hash calculation for data type interval (Tom)
       This corrects wrong results for hash joins on interval values. It
       also changes the contents of hash indexes on interval columns. If
       you have any such indexes, you must "REINDEX" them after updating.
     * Treat to_char(..., 'TH') as an uppercase ordinal suffix with
       'HH'/'HH12' (Heikki)
       It was previously handled as 'th' (lowercase).
     * Fix overflow for INTERVAL 'x ms' when "x" is more than 2 million
       and integer datetimes are in use (Alex Hunsaker)
     * Fix calculation of distance between a point and a line segment
       (Tom)
       This led to incorrect results from a number of geometric operators.
     * Fix money data type to work in locales where currency amounts have
       no fractional digits, e.g. Japan (Itagaki Takahiro)
     * Fix LIKE for case where pattern contains %_ (Tom)
     * Properly round datetime input like
       00:12:57.9999999999999999999999999999 (Tom)
     * Fix memory leaks in XML operations (Tom)
     * Fix poor choice of page split point in GiST R-tree operator classes
       (Teodor)
     * Ensure that a "fast shutdown" request will forcibly terminate open
       sessions, even if a "smart shutdown" was already in progress (Fujii
       Masao)
     * Avoid performance degradation in bulk inserts into GIN indexes when
       the input values are (nearly) in sorted order (Tom)
     * Correctly enforce NOT NULL domain constraints in some contexts in
       PL/pgSQL (Tom)
     * Fix portability issues in plperl initialization (Andrew Dunstan)
     * Fix pg_ctl to not go into an infinite loop if "postgresql.conf" is
       empty (Jeff Davis)
     * Improve pg_dump's efficiency when there are many large objects
       (Tamas Vincze)
     * Use SIGUSR1, not SIGQUIT, as the failover signal for pg_standby
       (Heikki)
     * Make pg_standby's maxretries option behave as documented (Fujii
       Masao)
     * Make "contrib/hstore" throw an error when a key or value is too
       long to fit in its data structure, rather than silently truncating
       it (Andrew Gierth)
     * Fix "contrib/xml2"'s xslt_process() to properly handle the maximum
       number of parameters (twenty) (Tom)
     * Improve robustness of libpq's code to recover from errors during
       "COPY FROM STDIN" (Tom)
     * Avoid including conflicting readline and editline header files when
       both libraries are installed (Zdenek Kotala)
     * Update time zone data files to tzdata release 2009l for DST law
       changes in Bangladesh, Egypt, Jordan, Pakistan, Argentina/San_Luis,
       Cuba, Jordan (historical correction only), Mauritius, Morocco,
       Palestine, Syria, Tunisia.
     __________________________________________________________________

                                Release 8.3.7

     Release date: 2009-03-16

   This release contains a variety of fixes from 8.3.6. For information
   about new features in the 8.3 major release, see the Section called
   Release 8.3.
     __________________________________________________________________

Migration to Version 8.3.7

   A dump/restore is not required for those running 8.3.X. However, if you
   are upgrading from a version earlier than 8.3.5, see the release notes
   for 8.3.5.
     __________________________________________________________________

Changes

     * Prevent error recursion crashes when encoding conversion fails
       (Tom)
       This change extends fixes made in the last two minor releases for
       related failure scenarios. The previous fixes were narrowly
       tailored for the original problem reports, but we have now
       recognized that *any* error thrown by an encoding conversion
       function could potentially lead to infinite recursion while trying
       to report the error. The solution therefore is to disable
       translation and encoding conversion and report the plain-ASCII form
       of any error message, if we find we have gotten into a recursive
       error reporting situation. (CVE-2009-0922)
     * Disallow "CREATE CONVERSION" with the wrong encodings for the
       specified conversion function (Heikki)
       This prevents one possible scenario for encoding conversion
       failure. The previous change is a backstop to guard against other
       kinds of failures in the same area.
     * Fix xpath() to not modify the path expression unless necessary, and
       to make a saner attempt at it when necessary (Andrew)
       The SQL standard suggests that xpath should work on data that is a
       document fragment, but libxml doesn't support that, and indeed it's
       not clear that this is sensible according to the XPath standard.
       xpath attempted to work around this mismatch by modifying both the
       data and the path expression, but the modification was buggy and
       could cause valid searches to fail. Now, xpath checks whether the
       data is in fact a well-formed document, and if so invokes libxml
       with no change to the data or path expression. Otherwise, a
       different modification method that is somewhat less likely to fail
       is used.

     Note: The new modification method is still not 100% satisfactory,
     and it seems likely that no real solution is possible. This patch
     should therefore be viewed as a band-aid to keep from breaking
     existing applications unnecessarily. It is likely that PostgreSQL
     8.4 will simply reject use of xpath on data that is not a
     well-formed document.
     * Fix core dump when to_char() is given format codes that are
       inappropriate for the type of the data argument (Tom)
     * Fix possible failure in text search when C locale is used with a
       multi-byte encoding (Teodor)
       Crashes were possible on platforms where wchar_t is narrower than
       int; Windows in particular.
     * Fix extreme inefficiency in text search parser's handling of an
       email-like string containing multiple @ characters (Heikki)
     * Fix planner problem with sub-"SELECT" in the output list of a
       larger subquery (Tom)
       The known symptom of this bug is a "failed to locate grouping
       columns" error that is dependent on the datatype involved; but
       there could be other issues as well.
     * Fix decompilation of CASE WHEN with an implicit coercion (Tom)
       This mistake could lead to Assert failures in an Assert-enabled
       build, or an "unexpected CASE WHEN clause" error message in other
       cases, when trying to examine or dump a view.
     * Fix possible misassignment of the owner of a TOAST table's rowtype
       (Tom)
       If "CLUSTER" or a rewriting variant of "ALTER TABLE" were executed
       by someone other than the table owner, the pg_type entry for the
       table's TOAST table would end up marked as owned by that someone.
       This caused no immediate problems, since the permissions on the
       TOAST rowtype aren't examined by any ordinary database operation.
       However, it could lead to unexpected failures if one later tried to
       drop the role that issued the command (in 8.1 or 8.2), or "owner of
       data type appears to be invalid" warnings from pg_dump after having
       done so (in 8.3).
     * Change "UNLISTEN" to exit quickly if the current session has never
       executed any "LISTEN" command (Tom)
       Most of the time this is not a particularly useful optimization,
       but since "DISCARD ALL" invokes "UNLISTEN", the previous coding
       caused a substantial performance problem for applications that made
       heavy use of "DISCARD ALL".
     * Fix PL/pgSQL to not treat INTO after "INSERT" as an INTO-variables
       clause anywhere in the string, not only at the start; in
       particular, don't fail for "INSERT INTO" within "CREATE RULE" (Tom)
     * Clean up PL/pgSQL error status variables fully at block exit
       (Ashesh Vashi and Dave Page)
       This is not a problem for PL/pgSQL itself, but the omission could
       cause the PL/pgSQL Debugger to crash while examining the state of a
       function.
     * Retry failed calls to CallNamedPipe() on Windows (Steve Marshall,
       Magnus)
       It appears that this function can sometimes fail transiently; we
       previously treated any failure as a hard error, which could confuse
       "LISTEN"/"NOTIFY" as well as other operations.
     * Add MUST (Mauritius Island Summer Time) to the default list of
       known timezone abbreviations (Xavier Bugaud)
     __________________________________________________________________

                                Release 8.3.6

     Release date: 2009-02-02

   This release contains a variety of fixes from 8.3.5. For information
   about new features in the 8.3 major release, see the Section called
   Release 8.3.
     __________________________________________________________________

Migration to Version 8.3.6

   A dump/restore is not required for those running 8.3.X. However, if you
   are upgrading from a version earlier than 8.3.5, see the release notes
   for 8.3.5.
     __________________________________________________________________

Changes

     * Make "DISCARD ALL" release advisory locks, in addition to
       everything it already did (Tom)
       This was decided to be the most appropriate behavior. This could
       affect existing applications, however.
     * Fix whole-index GiST scans to work correctly (Teodor)
       This error could cause rows to be lost if a table is clustered on a
       GiST index.
     * Fix crash of xmlconcat(NULL) (Peter)
     * Fix possible crash in ispell dictionary if high-bit-set characters
       are used as flags (Teodor)
       This is known to be done by one widely available Norwegian
       dictionary, and the same condition may exist in others.
     * Fix misordering of pg_dump output for composite types (Tom)
       The most likely problem was for user-defined operator classes to be
       dumped after indexes or views that needed them.
     * Improve handling of URLs in headline() function (Teodor)
     * Improve handling of overlength headlines in headline() function
       (Teodor)
     * Prevent possible Assert failure or misconversion if an encoding
       conversion is created with the wrong conversion function for the
       specified pair of encodings (Tom, Heikki)
     * Fix possible Assert failure if a statement executed in PL/pgSQL is
       rewritten into another kind of statement, for example if an
       "INSERT" is rewritten into an "UPDATE" (Heikki)
     * Ensure that a snapshot is available to datatype input functions
       (Tom)
       This primarily affects domains that are declared with CHECK
       constraints involving user-defined stable or immutable functions.
       Such functions typically fail if no snapshot has been set.
     * Make it safer for SPI-using functions to be used within datatype
       I/O; in particular, to be used in domain check constraints (Tom)
     * Avoid unnecessary locking of small tables in "VACUUM" (Heikki)
     * Fix a problem that sometimes kept "ALTER TABLE ENABLE/DISABLE RULE"
       from being recognized by active sessions (Tom)
     * Fix a problem that made UPDATE RETURNING tableoid return zero
       instead of the correct OID (Tom)
     * Allow functions declared as taking ANYARRAY to work on the
       pg_statistic columns of that type (Tom)
       This used to work, but was unintentionally broken in 8.3.
     * Fix planner misestimation of selectivity when transitive equality
       is applied to an outer-join clause (Tom)
       This could result in bad plans for queries like ... from a left
       join b on a.a1 = b.b1 where a.a1 = 42 ...
     * Improve optimizer's handling of long IN lists (Tom)
       This change avoids wasting large amounts of time on such lists when
       constraint exclusion is enabled.
     * Prevent synchronous scan during GIN index build (Tom)
       Because GIN is optimized for inserting tuples in increasing TID
       order, choosing to use a synchronous scan could slow the build by a
       factor of three or more.
     * Ensure that the contents of a holdable cursor don't depend on the
       contents of TOAST tables (Tom)
       Previously, large field values in a cursor result might be
       represented as TOAST pointers, which would fail if the referenced
       table got dropped before the cursor is read, or if the large value
       is deleted and then vacuumed away. This cannot happen with an
       ordinary cursor, but it could with a cursor that is held past its
       creating transaction.
     * Fix memory leak when a set-returning function is terminated without
       reading its whole result (Tom)
     * Fix encoding conversion problems in XML functions when the database
       encoding isn't UTF-8 (Tom)
     * Fix "contrib/dblink"'s dblink_get_result(text,bool) function (Joe)
     * Fix possible garbage output from "contrib/sslinfo" functions (Tom)
     * Fix incorrect behavior of "contrib/tsearch2" compatibility trigger
       when it's fired more than once in a command (Teodor)
     * Fix possible mis-signaling in autovacuum (Heikki)
     * Support running as a service on Windows 7 beta (Dave and Magnus)
     * Fix ecpg's handling of varchar structs (Michael)
     * Fix configure script to properly report failure when unable to
       obtain linkage information for PL/Perl (Andrew)
     * Make all documentation reference pgsql-bugs and/or pgsql-hackers as
       appropriate, instead of the now-decommissioned pgsql-ports and
       pgsql-patches mailing lists (Tom)
     * Update time zone data files to tzdata release 2009a (for Kathmandu
       and historical DST corrections in Switzerland, Cuba)
     __________________________________________________________________

                                Release 8.3.5

     Release date: 2008-11-03

   This release contains a variety of fixes from 8.3.4. For information
   about new features in the 8.3 major release, see the Section called
   Release 8.3.
     __________________________________________________________________

Migration to Version 8.3.5

   A dump/restore is not required for those running 8.3.X. However, if you
   are upgrading from a version earlier than 8.3.1, see the release notes
   for 8.3.1. Also, if you were running a previous 8.3.X release, it is
   recommended to "REINDEX" all GiST indexes after the upgrade.
     __________________________________________________________________

Changes

     * Fix GiST index corruption due to marking the wrong index entry
       "dead" after a deletion (Teodor)
       This would result in index searches failing to find rows they
       should have found. Corrupted indexes can be fixed with "REINDEX".
     * Fix backend crash when the client encoding cannot represent a
       localized error message (Tom)
       We have addressed similar issues before, but it would still fail if
       the "character has no equivalent" message itself couldn't be
       converted. The fix is to disable localization and send the plain
       ASCII error message when we detect such a situation.
     * Fix possible crash in bytea-to-XML mapping (Michael McMaster)
     * Fix possible crash when deeply nested functions are invoked from a
       trigger (Tom)
     * Improve optimization of "expression" IN ("expression-list") queries
       (Tom, per an idea from Robert Haas)
       Cases in which there are query variables on the right-hand side had
       been handled less efficiently in 8.2.x and 8.3.x than in prior
       versions. The fix restores 8.1 behavior for such cases.
     * Fix mis-expansion of rule queries when a sub-SELECT appears in a
       function call in FROM, a multi-row VALUES list, or a RETURNING list
       (Tom)
       The usual symptom of this problem is an "unrecognized node type"
       error.
     * Fix Assert failure during rescan of an IS NULL search of a GiST
       index (Teodor)
     * Fix memory leak during rescan of a hashed aggregation plan (Neil)
     * Ensure an error is reported when a newly-defined PL/pgSQL trigger
       function is invoked as a normal function (Tom)
     * Force a checkpoint before "CREATE DATABASE" starts to copy files
       (Heikki)
       This prevents a possible failure if files had recently been deleted
       in the source database.
     * Prevent possible collision of relfilenode numbers when moving a
       table to another tablespace with "ALTER SET TABLESPACE" (Heikki)
       The command tried to re-use the existing filename, instead of
       picking one that is known unused in the destination directory.
     * Fix incorrect text search headline generation when single query
       item matches first word of text (Sushant Sinha)
     * Fix improper display of fractional seconds in interval values when
       using a non-ISO datestyle in an "--enable-integer-datetimes" build
       (Ron Mayer)
     * Make ILIKE compare characters case-insensitively even when they're
       escaped (Andrew)
     * Ensure "DISCARD" is handled properly by statement logging (Tom)
     * Fix incorrect logging of last-completed-transaction time during
       PITR recovery (Tom)
     * Ensure SPI_getvalue and SPI_getbinval behave correctly when the
       passed tuple and tuple descriptor have different numbers of columns
       (Tom)
       This situation is normal when a table has had columns added or
       removed, but these two functions didn't handle it properly. The
       only likely consequence is an incorrect error indication.
     * Mark SessionReplicationRole as PGDLLIMPORT so it can be used by
       Slony on Windows (Magnus)
     * Fix small memory leak when using libpq's gsslib parameter (Magnus)
       The space used by the parameter string was not freed at connection
       close.
     * Ensure libgssapi is linked into libpq if needed (Markus Schaaf)
     * Fix ecpg's parsing of "CREATE ROLE" (Michael)
     * Fix recent breakage of pg_ctl restart (Tom)
     * Ensure "pg_control" is opened in binary mode (Itagaki Takahiro)
       pg_controldata and pg_resetxlog did this incorrectly, and so could
       fail on Windows.
     * Update time zone data files to tzdata release 2008i (for DST law
       changes in Argentina, Brazil, Mauritius, Syria)
     __________________________________________________________________

                                Release 8.3.4

     Release date: 2008-09-22

   This release contains a variety of fixes from 8.3.3. For information
   about new features in the 8.3 major release, see the Section called
   Release 8.3.
     __________________________________________________________________

Migration to Version 8.3.4

   A dump/restore is not required for those running 8.3.X. However, if you
   are upgrading from a version earlier than 8.3.1, see the release notes
   for 8.3.1.
     __________________________________________________________________

Changes

     * Fix bug in btree WAL recovery code (Heikki)
       Recovery failed if the WAL ended partway through a page split
       operation.
     * Fix potential use of wrong cutoff XID for HOT page pruning (Alvaro)
       This error created a risk of corruption in system catalogs that are
       consulted by "VACUUM": dead tuple versions might be removed too
       soon. The impact of this on actual database operations would be
       minimal, since the system doesn't follow MVCC rules while examining
       catalogs, but it might result in transiently wrong output from
       pg_dump or other client programs.
     * Fix potential miscalculation of datfrozenxid (Alvaro)
       This error may explain some recent reports of failure to remove old
       pg_clog data.
     * Fix incorrect HOT updates after pg_class is reindexed (Tom)
       Corruption of pg_class could occur if REINDEX TABLE pg_class was
       followed in the same session by an ALTER TABLE RENAME or ALTER
       TABLE SET SCHEMA command.
     * Fix missed "combo cid" case (Karl Schnaitter)
       This error made rows incorrectly invisible to a transaction in
       which they had been deleted by multiple subtransactions that all
       aborted.
     * Prevent autovacuum from crashing if the table it's currently
       checking is deleted at just the wrong time (Alvaro)
     * Widen local lock counters from 32 to 64 bits (Tom)
       This responds to reports that the counters could overflow in
       sufficiently long transactions, leading to unexpected "lock is
       already held" errors.
     * Fix possible duplicate output of tuples during a GiST index scan
       (Teodor)
     * Regenerate foreign key checking queries from scratch when either
       table is modified (Tom)
       Previously, 8.3 would attempt to replan the query, but would work
       from previously generated query text. This led to failures if a
       table or column was renamed.
     * Fix missed permissions checks when a view contains a simple UNION
       ALL construct (Heikki)
       Permissions for the referenced tables were checked properly, but
       not permissions for the view itself.
     * Add checks in executor startup to ensure that the tuples produced
       by an "INSERT" or "UPDATE" will match the target table's current
       rowtype (Tom)
       This situation is believed to be impossible in 8.3, but it can
       happen in prior releases, so a check seems prudent.
     * Fix possible repeated drops during "DROP OWNED" (Tom)
       This would typically result in strange errors such as "cache lookup
       failed for relation NNN".
     * Fix several memory leaks in XML operations (Kris Jurka, Tom)
     * Fix xmlserialize() to raise error properly for unacceptable target
       data type (Tom)
     * Fix a couple of places that mis-handled multibyte characters in
       text search configuration file parsing (Tom)
       Certain characters occurring in configuration files would always
       cause "invalid byte sequence for encoding" failures.
     * Provide file name and line number location for all errors reported
       in text search configuration files (Tom)
     * Fix AT TIME ZONE to first try to interpret its timezone argument as
       a timezone abbreviation, and only try it as a full timezone name if
       that fails, rather than the other way around as formerly (Tom)
       The timestamp input functions have always resolved ambiguous zone
       names in this order. Making AT TIME ZONE do so as well improves
       consistency, and fixes a compatibility bug introduced in 8.1: in
       ambiguous cases we now behave the same as 8.0 and before did, since
       in the older versions AT TIME ZONE accepted *only* abbreviations.
     * Fix datetime input functions to correctly detect integer overflow
       when running on a 64-bit platform (Tom)
     * Prevent integer overflows during units conversion when displaying a
       configuration parameter that has units (Tom)
     * Improve performance of writing very long log messages to syslog
       (Tom)
     * Allow spaces in the suffix part of an LDAP URL in "pg_hba.conf"
       (Tom)
     * Fix bug in backwards scanning of a cursor on a SELECT DISTINCT ON
       query (Tom)
     * Fix planner bug that could improperly push down IS NULL tests below
       an outer join (Tom)
       This was triggered by occurrence of IS NULL tests for the same
       relation in all arms of an upper OR clause.
     * Fix planner bug with nested sub-select expressions (Tom)
       If the outer sub-select has no direct dependency on the parent
       query, but the inner one does, the outer value might not get
       recalculated for new parent query rows.
     * Fix planner to estimate that GROUP BY expressions yielding boolean
       results always result in two groups, regardless of the expressions'
       contents (Tom)
       This is very substantially more accurate than the regular GROUP BY
       estimate for certain boolean tests like "col" IS NULL.
     * Fix PL/pgSQL to not fail when a FOR loop's target variable is a
       record containing composite-type fields (Tom)
     * Fix PL/Tcl to behave correctly with Tcl 8.5, and to be more careful
       about the encoding of data sent to or from Tcl (Tom)
     * Improve performance of PQescapeBytea() (Rudolf Leitgeb)
     * On Windows, work around a Microsoft bug by preventing libpq from
       trying to send more than 64kB per system call (Magnus)
     * Fix ecpg to handle variables properly in "SET" commands (Michael)
     * Improve pg_dump and pg_restore's error reporting after failure to
       send a SQL command (Tom)
     * Fix pg_ctl to properly preserve postmaster command-line arguments
       across a restart (Bruce)
     * Fix erroneous WAL file cutoff point calculation in pg_standby
       (Simon)
     * Update time zone data files to tzdata release 2008f (for DST law
       changes in Argentina, Bahamas, Brazil, Mauritius, Morocco,
       Pakistan, Palestine, and Paraguay)
     __________________________________________________________________

                                Release 8.3.3

     Release date: 2008-06-12

   This release contains one serious and one minor bug fix over 8.3.2. For
   information about new features in the 8.3 major release, see the
   Section called Release 8.3.
     __________________________________________________________________

Migration to Version 8.3.3

   A dump/restore is not required for those running 8.3.X. However, if you
   are upgrading from a version earlier than 8.3.1, see the release notes
   for 8.3.1.
     __________________________________________________________________

Changes

     * Make pg_get_ruledef() parenthesize negative constants (Tom)
       Before this fix, a negative constant in a view or rule might be
       dumped as, say, -42::integer, which is subtly incorrect: it should
       be (-42)::integer due to operator precedence rules. Usually this
       would make little difference, but it could interact with another
       recent patch to cause PostgreSQL to reject what had been a valid
       "SELECT DISTINCT" view query. Since this could result in pg_dump
       output failing to reload, it is being treated as a high-priority
       fix. The only released versions in which dump output is actually
       incorrect are 8.3.1 and 8.2.7.
     * Make "ALTER AGGREGATE ... OWNER TO" update pg_shdepend (Tom)
       This oversight could lead to problems if the aggregate was later
       involved in a "DROP OWNED" or "REASSIGN OWNED" operation.
     __________________________________________________________________

                                Release 8.3.2

     Release date: never released

   This release contains a variety of fixes from 8.3.1. For information
   about new features in the 8.3 major release, see the Section called
   Release 8.3.
     __________________________________________________________________

Migration to Version 8.3.2

   A dump/restore is not required for those running 8.3.X. However, if you
   are upgrading from a version earlier than 8.3.1, see the release notes
   for 8.3.1.
     __________________________________________________________________

Changes

     * Fix ERRORDATA_STACK_SIZE exceeded crash that occurred on Windows
       when using UTF-8 database encoding and a different client encoding
       (Tom)
     * Fix incorrect archive truncation point calculation for the %r macro
       in recovery_command parameters (Simon)
       This could lead to data loss if a warm-standby script relied on %r
       to decide when to throw away WAL segment files.
     * Fix "ALTER TABLE ADD COLUMN ... PRIMARY KEY" so that the new column
       is correctly checked to see if it's been initialized to all
       non-nulls (Brendan Jurd)
       Previous versions neglected to check this requirement at all.
     * Fix "REASSIGN OWNED" so that it works on procedural languages too
       (Alvaro)
     * Fix problems with "SELECT FOR UPDATE/SHARE" occurring as a subquery
       in a query with a non-"SELECT" top-level operation (Tom)
     * Fix possible "CREATE TABLE" failure when inheriting the "same"
       constraint from multiple parent relations that inherited that
       constraint from a common ancestor (Tom)
     * Fix pg_get_ruledef() to show the alias, if any, attached to the
       target table of an "UPDATE" or "DELETE" (Tom)
     * Restore the pre-8.3 behavior that an out-of-range block number in a
       TID being used in a TidScan plan results in silently not matching
       any rows (Tom)
       8.3.0 and 8.3.1 threw an error instead.
     * Fix GIN bug that could result in a too many LWLocks taken failure
       (Teodor)
     * Fix broken GiST comparison function for tsquery (Teodor)
     * Fix tsvector_update_trigger() and ts_stat() to accept domains over
       the types they expect to work with (Tom)
     * Fix failure to support enum data types as foreign keys (Tom)
     * Avoid possible crash when decompressing corrupted data (Zdenek
       Kotala)
     * Fix race conditions between delayed unlinks and "DROP DATABASE"
       (Heikki)
       In the worst case this could result in deleting a newly created
       table in a new database that happened to get the same OID as the
       recently-dropped one; but of course that is an extremely
       low-probability scenario.
     * Repair two places where SIGTERM exit of a backend could leave
       corrupted state in shared memory (Tom)
       Neither case is very important if SIGTERM is used to shut down the
       whole database cluster together, but there was a problem if someone
       tried to SIGTERM individual backends.
     * Fix possible crash due to incorrect plan generated for an x IN
       (SELECT y FROM ...) clause when "x" and "y" have different data
       types; and make sure the behavior is semantically correct when the
       conversion from "y"'s type to "x"'s type is lossy (Tom)
     * Fix oversight that prevented the planner from substituting known
       Param values as if they were constants (Tom)
       This mistake partially disabled optimization of unnamed
       extended-Query statements in 8.3.0 and 8.3.1: in particular the
       LIKE-to-indexscan optimization would never be applied if the LIKE
       pattern was passed as a parameter, and constraint exclusion
       depending on a parameter value didn't work either.
     * Fix planner failure when an indexable MIN or MAX aggregate is used
       with DISTINCT or ORDER BY (Tom)
     * Fix planner to ensure it never uses a "physical tlist" for a plan
       node that is feeding a Sort node (Tom)
       This led to the sort having to push around more data than it really
       needed to, since unused column values were included in the sorted
       data.
     * Avoid unnecessary copying of query strings (Tom)
       This fixes a performance problem introduced in 8.3.0 when a very
       large number of commands are submitted as a single query string.
     * Make TransactionIdIsCurrentTransactionId() use binary search
       instead of linear search when checking child-transaction XIDs
       (Heikki)
       This fixes some cases in which 8.3.0 was significantly slower than
       earlier releases.
     * Fix conversions between ISO-8859-5 and other encodings to handle
       Cyrillic "Yo" characters (e and E with two dots) (Sergey Burladyan)
     * Fix several datatype input functions, notably array_in(), that were
       allowing unused bytes in their results to contain uninitialized,
       unpredictable values (Tom)
       This could lead to failures in which two apparently identical
       literal values were not seen as equal, resulting in the parser
       complaining about unmatched ORDER BY and DISTINCT expressions.
     * Fix a corner case in regular-expression substring matching
       (substring(string from pattern)) (Tom)
       The problem occurs when there is a match to the pattern overall but
       the user has specified a parenthesized subexpression and that
       subexpression hasn't got a match. An example is substring('foo'
       from 'foo(bar)?'). This should return NULL, since (bar) isn't
       matched, but it was mistakenly returning the whole-pattern match
       instead (ie, foo).
     * Prevent cancellation of an auto-vacuum that was launched to prevent
       XID wraparound (Alvaro)
     * Improve "ANALYZE"'s handling of in-doubt tuples (those inserted or
       deleted by a not-yet-committed transaction) so that the counts it
       reports to the stats collector are more likely to be correct (Pavan
       Deolasee)
     * Fix initdb to reject a relative path for its --xlogdir (-X) option
       (Tom)
     * Make psql print tab characters as an appropriate number of spaces,
       rather than \x09 as was done in 8.3.0 and 8.3.1 (Bruce)
     * Update time zone data files to tzdata release 2008c (for DST law
       changes in Morocco, Iraq, Choibalsan, Pakistan, Syria, Cuba, and
       Argentina/San_Luis)
     * Add ECPGget_PGconn() function to ecpglib (Michael)
     * Fix incorrect result from ecpg's PGTYPEStimestamp_sub() function
       (Michael)
     * Fix handling of continuation line markers in ecpg (Michael)
     * Fix possible crashes in "contrib/cube" functions (Tom)
     * Fix core dump in "contrib/xml2"'s xpath_table() function when the
       input query returns a NULL value (Tom)
     * Fix "contrib/xml2"'s makefile to not override CFLAGS, and make it
       auto-configure properly for libxslt present or not (Tom)
     __________________________________________________________________

                                Release 8.3.1

     Release date: 2008-03-17

   This release contains a variety of fixes from 8.3.0. For information
   about new features in the 8.3 major release, see the Section called
   Release 8.3.
     __________________________________________________________________

Migration to Version 8.3.1

   A dump/restore is not required for those running 8.3.X. However, you
   might need to "REINDEX" indexes on textual columns after updating, if
   you are affected by the Windows locale issue described below.
     __________________________________________________________________

Changes

     * Fix character string comparison for Windows locales that consider
       different character combinations as equal (Tom)
       This fix applies only on Windows and only when using UTF-8 database
       encoding. The same fix was made for all other cases over two years
       ago, but Windows with UTF-8 uses a separate code path that was not
       updated. If you are using a locale that considers some
       non-identical strings as equal, you may need to "REINDEX" to fix
       existing indexes on textual columns.
     * Repair corner-case bugs in "VACUUM FULL" (Tom)
       A potential deadlock between concurrent "VACUUM FULL" operations on
       different system catalogs was introduced in 8.2. This has now been
       corrected. 8.3 made this worse because the deadlock could occur
       within a critical code section, making it a PANIC rather than just
       ERROR condition.
       Also, a "VACUUM FULL" that failed partway through vacuuming a
       system catalog could result in cache corruption in concurrent
       database sessions.
       Another "VACUUM FULL" bug introduced in 8.3 could result in a crash
       or out-of-memory report when dealing with pages containing no live
       tuples.
     * Fix misbehavior of foreign key checks involving character or bit
       columns (Tom)
       If the referencing column were of a different but compatible type
       (for instance varchar), the constraint was enforced incorrectly.
     * Avoid needless deadlock failures in no-op foreign-key checks
       (Stephan Szabo, Tom)
     * Fix possible core dump when re-planning a prepared query (Tom)
       This bug affected only protocol-level prepare operations, not SQL
       "PREPARE", and so tended to be seen only with JDBC, DBI, and other
       client-side drivers that use prepared statements heavily.
     * Fix possible failure when re-planning a query that calls an
       SPI-using function (Tom)
     * Fix failure in row-wise comparisons involving columns of different
       datatypes (Tom)
     * Fix longstanding "LISTEN"/"NOTIFY" race condition (Tom)
       In rare cases a session that had just executed a "LISTEN" might not
       get a notification, even though one would be expected because the
       concurrent transaction executing "NOTIFY" was observed to commit
       later.
       A side effect of the fix is that a transaction that has executed a
       not-yet-committed "LISTEN" command will not see any row in
       pg_listener for the "LISTEN", should it choose to look; formerly it
       would have. This behavior was never documented one way or the
       other, but it is possible that some applications depend on the old
       behavior.
     * Disallow "LISTEN" and "UNLISTEN" within a prepared transaction
       (Tom)
       This was formerly allowed but trying to do it had various
       unpleasant consequences, notably that the originating backend could
       not exit as long as an "UNLISTEN" remained uncommitted.
     * Disallow dropping a temporary table within a prepared transaction
       (Heikki)
       This was correctly disallowed by 8.1, but the check was
       inadvertently broken in 8.2 and 8.3.
     * Fix rare crash when an error occurs during a query using a hash
       index (Heikki)
     * Fix incorrect comparison of tsquery values (Teodor)
     * Fix incorrect behavior of LIKE with non-ASCII characters in
       single-byte encodings (Rolf Jentsch)
     * Disable xmlvalidate (Tom)
       This function should have been removed before 8.3 release, but was
       inadvertently left in the source code. It poses a small security
       risk since unprivileged users could use it to read the first few
       characters of any file accessible to the server.
     * Fix memory leaks in certain usages of set-returning functions
       (Neil)
     * Make encode(bytea, 'escape') convert all high-bit-set byte values
       into \"nnn" octal escape sequences (Tom)
       This is necessary to avoid encoding problems when the database
       encoding is multi-byte. This change could pose compatibility issues
       for applications that are expecting specific results from encode.
     * Fix input of datetime values for February 29 in years BC (Tom)
       The former coding was mistaken about which years were leap years.
     * Fix "unrecognized node type" error in some variants of "ALTER
       OWNER" (Tom)
     * Avoid tablespace permissions errors in "CREATE TABLE LIKE INCLUDING
       INDEXES" (Tom)
     * Ensure pg_stat_activity.waiting flag is cleared when a lock wait is
       aborted (Tom)
     * Fix handling of process permissions on Windows Vista (Dave, Magnus)
       In particular, this fix allows starting the server as the
       Administrator user.
     * Update time zone data files to tzdata release 2008a (in particular,
       recent Chile changes); adjust timezone abbreviation VET (Venezuela)
       to mean UTC-4:30, not UTC-4:00 (Tom)
     * Fix ecpg problems with arrays (Michael)
     * Fix pg_ctl to correctly extract the postmaster's port number from
       command-line options (Itagaki Takahiro, Tom)
       Previously, pg_ctl start -w could try to contact the postmaster on
       the wrong port, leading to bogus reports of startup failure.
     * Use "-fwrapv" to defend against possible misoptimization in recent
       gcc versions (Tom)
       This is known to be necessary when building PostgreSQL with gcc 4.3
       or later.
     * Enable building "contrib/uuid-ossp" with MSVC (Hiroshi Saito)
     __________________________________________________________________

                                 Release 8.3

     Release date: 2008-02-04
     __________________________________________________________________

Overview

   With significant new functionality and performance enhancements, this
   release represents a major leap forward for PostgreSQL. This was made
   possible by a growing community that has dramatically accelerated the
   pace of development. This release adds the following major features:

     * Full text search is integrated into the core database system
     * Support for the SQL/XML standard, including new operators and an
       XML data type
     * Enumerated data types (ENUM)
     * Arrays of composite types
     * Universally Unique Identifier (UUID) data type
     * Add control over whether NULLs sort first or last
     * Updatable cursors
     * Server configuration parameters can now be set on a per-function
       basis
     * User-defined types can now have type modifiers
     * Automatically re-plan cached queries when table definitions change
       or statistics are updated
     * Numerous improvements in logging and statistics collection
     * Support Security Service Provider Interface (SSPI) for
       authentication on Windows
     * Support multiple concurrent autovacuum processes, and other
       autovacuum improvements
     * Allow the whole PostgreSQL distribution to be compiled with
       Microsoft Visual C++

   Major performance improvements are listed below. Most of these
   enhancements are automatic and do not require user changes or tuning:

     * Asynchronous commit delays writes to WAL during transaction commit
     * Checkpoint writes can be spread over a longer time period to smooth
       the I/O spike during each checkpoint
     * Heap-Only Tuples (HOT) accelerate space reuse for most "UPDATE"s
       and "DELETE"s
     * Just-in-time background writer strategy improves disk write
       efficiency
     * Using non-persistent transaction IDs for read-only transactions
       reduces overhead and "VACUUM" requirements
     * Per-field and per-row storage overhead has been reduced
     * Large sequential scans no longer force out frequently used cached
       pages
     * Concurrent large sequential scans can now share disk reads
     * ORDER BY ... LIMIT can be done without sorting

   The above items are explained in more detail in the sections below.
     __________________________________________________________________

Migration to Version 8.3

   A dump/restore using pg_dump is required for those wishing to migrate
   data from any previous release.

   Observe the following incompatibilities:
     __________________________________________________________________

General

     * Non-character data types are no longer automatically cast to TEXT
       (Peter, Tom)
       Previously, if a non-character value was supplied to an operator or
       function that requires text input, it was automatically cast to
       text, for most (though not all) built-in data types. This no longer
       happens: an explicit cast to text is now required for all
       non-character-string types. For example, these expressions formerly
       worked:
substr(current_date, 1, 4)
23 LIKE '2%'
       but will now draw "function does not exist" and "operator does not
       exist" errors respectively. Use an explicit cast instead:
substr(current_date::text, 1, 4)
23::text LIKE '2%'
       (Of course, you can use the more verbose CAST() syntax too.) The
       reason for the change is that these automatic casts too often
       caused surprising behavior. An example is that in previous
       releases, this expression was accepted but did not do what was
       expected:
current_date < 2017-11-17
       This is actually comparing a date to an integer, which should be
       (and now is) rejected -- but in the presence of automatic casts
       both sides were cast to text and a textual comparison was done,
       because the text < text operator was able to match the expression
       when no other < operator could.
       Types char(n) and varchar(n) still cast to text automatically.
       Also, automatic casting to text still works for inputs to the
       concatenation (||) operator, so long as least one input is a
       character-string type.
     * Full text search features from "contrib/tsearch2" have been moved
       into the core server, with some minor syntax changes
       "contrib/tsearch2" now contains a compatibility interface.
     * ARRAY(SELECT ...), where the "SELECT" returns no rows, now returns
       an empty array, rather than NULL (Tom)
     * The array type name for a base data type is no longer always the
       base type's name with an underscore prefix
       The old naming convention is still honored when possible, but
       application code should no longer depend on it. Instead use the new
       pg_type.typarray column to identify the array data type associated
       with a given type.
     * ORDER BY ... USING "operator" must now use a less-than or
       greater-than "operator" that is defined in a btree operator class
       This restriction was added to prevent inconsistent results.
     * "SET LOCAL" changes now persist until the end of the outermost
       transaction, unless rolled back (Tom)
       Previously "SET LOCAL"'s effects were lost after subtransaction
       commit ("RELEASE SAVEPOINT" or exit from a PL/pgSQL exception
       block).
     * Commands rejected in transaction blocks are now also rejected in
       multiple-statement query strings (Tom)
       For example, "BEGIN; DROP DATABASE; COMMIT" will now be rejected
       even if submitted as a single query message.
     * "ROLLBACK" outside a transaction block now issues NOTICE instead of
       WARNING (Bruce)
     * Prevent "NOTIFY"/"LISTEN"/"UNLISTEN" from accepting
       schema-qualified names (Bruce)
       Formerly, these commands accepted schema.relation but ignored the
       schema part, which was confusing.
     * "ALTER SEQUENCE" no longer affects the sequence's currval() state
       (Tom)
     * Foreign keys now must match indexable conditions for
       cross-data-type references (Tom)
       This improves semantic consistency and helps avoid performance
       problems.
     * Restrict object size functions to users who have reasonable
       permissions to view such information (Tom)
       For example, pg_database_size() now requires CONNECT permission,
       which is granted to everyone by default. pg_tablespace_size()
       requires CREATE permission in the tablespace, or is allowed if the
       tablespace is the default tablespace for the database.
     * Remove the undocumented !!= (not in) operator (Tom)
       NOT IN (SELECT ...) is the proper way to perform this operation.
     * Internal hashing functions are now more uniformly-distributed (Tom)
       If application code was computing and storing hash values using
       internal PostgreSQL hashing functions, the hash values must be
       regenerated.
     * C-code conventions for handling variable-length data values have
       changed (Greg Stark, Tom)
       The new SET_VARSIZE() macro *must* be used to set the length of
       generated varlena values. Also, it might be necessary to expand
       ("de-TOAST") input values in more cases.
     * Continuous archiving no longer reports each successful archive
       operation to the server logs unless DEBUG level is used (Simon)
     __________________________________________________________________

Configuration Parameters

     * Numerous changes in administrative server parameters
       bgwriter_lru_percent, bgwriter_all_percent, bgwriter_all_maxpages,
       stats_start_collector, and stats_reset_on_server_start are removed.
       redirect_stderr is renamed to logging_collector.
       stats_command_string is renamed to track_activities.
       stats_block_level and stats_row_level are merged into track_counts.
       A new boolean configuration parameter, archive_mode, controls
       archiving. Autovacuum's default settings have changed.
     * Remove stats_start_collector parameter (Tom)
       We now always start the collector process, unless UDP socket
       creation fails.
     * Remove stats_reset_on_server_start parameter (Tom)
       This was removed because pg_stat_reset() can be used for this
       purpose.
     * Commenting out a parameter in "postgresql.conf" now causes it to
       revert to its default value (Joachim Wieland)
       Previously, commenting out an entry left the parameter's value
       unchanged until the next server restart.
     __________________________________________________________________

Character Encodings

     * Add more checks for invalidly-encoded data (Andrew)
       This change plugs some holes that existed in literal backslash
       escape string processing and "COPY" escape processing. Now the
       de-escaped string is rechecked to see if the result created an
       invalid multi-byte character.
     * Disallow database encodings that are inconsistent with the server's
       locale setting (Tom)
       On most platforms, C locale is the only locale that will work with
       any database encoding. Other locale settings imply a specific
       encoding and will misbehave if the database encoding is something
       different. (Typical symptoms include bogus textual sort order and
       wrong results from upper() or lower().) The server now rejects
       attempts to create databases that have an incompatible encoding.
     * Ensure that chr() cannot create invalidly-encoded values (Andrew)
       In UTF8-encoded databases the argument of chr() is now treated as a
       Unicode code point. In other multi-byte encodings chr()'s argument
       must designate a 7-bit ASCII character. Zero is no longer accepted.
       ascii() has been adjusted to match.
     * Adjust convert() behavior to ensure encoding validity (Andrew)
       The two argument form of convert() has been removed. The three
       argument form now takes a bytea first argument and returns a bytea.
       To cover the loss of functionality, three new functions have been
       added:
          + convert_from(bytea, name) returns text -- converts the first
            argument from the named encoding to the database encoding
          + convert_to(text, name) returns bytea -- converts the first
            argument from the database encoding to the named encoding
          + length(bytea, name) returns integer -- gives the length of the
            first argument in characters in the named encoding
     * Remove convert(argument USING conversion_name) (Andrew)
       Its behavior did not match the SQL standard.
     * Make JOHAB encoding client-only (Tatsuo)
       JOHAB is not safe as a server-side encoding.
     __________________________________________________________________

Changes

   Below you will find a detailed account of the changes between
   PostgreSQL 8.3 and the previous major release.
     __________________________________________________________________

Performance

     * Asynchronous commit delays writes to WAL during transaction commit
       (Simon)
       This feature dramatically increases performance for short
       data-modifying transactions. The disadvantage is that because disk
       writes are delayed, if the database or operating system crashes
       before data is written to the disk, committed data will be lost.
       This feature is useful for applications that can accept some data
       loss. Unlike turning off fsync, using asynchronous commit does not
       put database consistency at risk; the worst case is that after a
       crash the last few reportedly-committed transactions might not be
       committed after all. This feature is enabled by turning off
       synchronous_commit (which can be done per-session or
       per-transaction, if some transactions are critical and others are
       not). wal_writer_delay can be adjusted to control the maximum delay
       before transactions actually reach disk.
     * Checkpoint writes can be spread over a longer time period to smooth
       the I/O spike during each checkpoint (Itagaki Takahiro and Heikki
       Linnakangas)
       Previously all modified buffers were forced to disk as quickly as
       possible during a checkpoint, causing an I/O spike that decreased
       server performance. This new approach spreads out disk writes
       during checkpoints, reducing peak I/O usage. (User-requested and
       shutdown checkpoints are still written as quickly as possible.)
     * Heap-Only Tuples (HOT) accelerate space reuse for most "UPDATE"s
       and "DELETE"s (Pavan Deolasee, with ideas from many others)
       "UPDATE"s and "DELETE"s leave dead tuples behind, as do failed
       "INSERT"s. Previously only "VACUUM" could reclaim space taken by
       dead tuples. With HOT dead tuple space can be automatically
       reclaimed at the time of "INSERT" or "UPDATE" if no changes are
       made to indexed columns. This allows for more consistent
       performance. Also, HOT avoids adding duplicate index entries.
     * Just-in-time background writer strategy improves disk write
       efficiency (Greg Smith, Itagaki Takahiro)
       This greatly reduces the need for manual tuning of the background
       writer.
     * Per-field and per-row storage overhead have been reduced (Greg
       Stark, Heikki Linnakangas)
       Variable-length data types with data values less than 128 bytes
       long will see a storage decrease of 3 to 6 bytes. For example, two
       adjacent char(1) fields now use 4 bytes instead of 16. Row headers
       are also 4 bytes shorter than before.
     * Using non-persistent transaction IDs for read-only transactions
       reduces overhead and "VACUUM" requirements (Florian Pflug)
       Non-persistent transaction IDs do not increment the global
       transaction counter. Therefore, they reduce the load on pg_clog and
       increase the time between forced vacuums to prevent transaction ID
       wraparound. Other performance improvements were also made that
       should improve concurrency.
     * Avoid incrementing the command counter after a read-only command
       (Tom)
       There was formerly a hard limit of 2^32 (4 billion) commands per
       transaction. Now only commands that actually changed the database
       count, so while this limit still exists, it should be significantly
       less annoying.
     * Create a dedicated WAL writer process to off-load work from
       backends (Simon)
     * Skip unnecessary WAL writes for "CLUSTER" and "COPY" (Simon)
       Unless WAL archiving is enabled, the system now avoids WAL writes
       for "CLUSTER" and just fsync()s the table at the end of the
       command. It also does the same for "COPY" if the table was created
       in the same transaction.
     * Large sequential scans no longer force out frequently used cached
       pages (Simon, Heikki, Tom)
     * Concurrent large sequential scans can now share disk reads (Jeff
       Davis)
       This is accomplished by starting the new sequential scan in the
       middle of the table (where another sequential scan is already
       in-progress) and wrapping around to the beginning to finish. This
       can affect the order of returned rows in a query that does not
       specify ORDER BY. The synchronize_seqscans configuration parameter
       can be used to disable this if necessary.
     * ORDER BY ... LIMIT can be done without sorting (Greg Stark)
       This is done by sequentially scanning the table and tracking just
       the "top N" candidate rows, rather than performing a full sort of
       the entire table. This is useful when there is no matching index
       and the LIMIT is not large.
     * Put a rate limit on messages sent to the statistics collector by
       backends (Tom)
       This reduces overhead for short transactions, but might sometimes
       increase the delay before statistics are tallied.
     * Improve hash join performance for cases with many NULLs (Tom)
     * Speed up operator lookup for cases with non-exact datatype matches
       (Tom)
     __________________________________________________________________

Server

     * Autovacuum is now enabled by default (Alvaro)
       Several changes were made to eliminate disadvantages of having
       autovacuum enabled, thereby justifying the change in default.
       Several other autovacuum parameter defaults were also modified.
     * Support multiple concurrent autovacuum processes (Alvaro, Itagaki
       Takahiro)
       This allows multiple vacuums to run concurrently. This prevents
       vacuuming of a large table from delaying vacuuming of smaller
       tables.
     * Automatically re-plan cached queries when table definitions change
       or statistics are updated (Tom)
       Previously PL/pgSQL functions that referenced temporary tables
       would fail if the temporary table was dropped and recreated between
       function invocations, unless EXECUTE was used. This improvement
       fixes that problem and many related issues.
     * Add a temp_tablespaces parameter to control the tablespaces for
       temporary tables and files (Jaime Casanova, Albert Cervera, Bernd
       Helmle)
       This parameter defines a list of tablespaces to be used. This
       enables spreading the I/O load across multiple tablespaces. A
       random tablespace is chosen each time a temporary object is
       created. Temporary files are no longer stored in per-database
       "pgsql_tmp/" directories but in per-tablespace directories.
     * Place temporary tables' TOAST tables in special schemas named
       pg_toast_temp_nnn (Tom)
       This allows low-level code to recognize these tables as temporary,
       which enables various optimizations such as not WAL-logging changes
       and using local rather than shared buffers for access. This also
       fixes a bug wherein backends unexpectedly held open file references
       to temporary TOAST tables.
     * Fix problem that a constant flow of new connection requests could
       indefinitely delay the postmaster from completing a shutdown or a
       crash restart (Tom)
     * Guard against a very-low-probability data loss scenario by
       preventing re-use of a deleted table's relfilenode until after the
       next checkpoint (Heikki)
     * Fix "CREATE CONSTRAINT TRIGGER" to convert old-style foreign key
       trigger definitions into regular foreign key constraints (Tom)
       This will ease porting of foreign key constraints carried forward
       from pre-7.3 databases, if they were never converted using
       "contrib/adddepend".
     * Fix DEFAULT NULL to override inherited defaults (Tom)
       DEFAULT NULL was formerly considered a noise phrase, but it should
       (and now does) override non-null defaults that would otherwise be
       inherited from a parent table or domain.
     * Add new encodings EUC_JIS_2004 and SHIFT_JIS_2004 (Tatsuo)
       These new encodings can be converted to and from UTF-8.
     * Change server startup log message from "database system is ready"
       to "database system is ready to accept connections", and adjust its
       timing
       The message now appears only when the postmaster is really ready to
       accept connections.
     __________________________________________________________________

Monitoring

     * Add log_autovacuum_min_duration parameter to support configurable
       logging of autovacuum activity (Simon, Alvaro)
     * Add log_lock_waits parameter to log lock waiting (Simon)
     * Add log_temp_files parameter to log temporary file usage (Bill
       Moran)
     * Add log_checkpoints parameter to improve logging of checkpoints
       (Greg Smith, Heikki)
     * log_line_prefix now supports %s and %c escapes in all processes
       (Andrew)
       Previously these escapes worked only for user sessions, not for
       background database processes.
     * Add log_restartpoints to control logging of point-in-time recovery
       restart points (Simon)
     * Last transaction end time is now logged at end of recovery and at
       each logged restart point (Simon)
     * Autovacuum now reports its activity start time in pg_stat_activity
       (Tom)
     * Allow server log output in comma-separated value (CSV) format (Arul
       Shaji, Greg Smith, Andrew Dunstan)
       CSV-format log files can easily be loaded into a database table for
       subsequent analysis.
     * Use PostgreSQL-supplied timezone support for formatting timestamps
       displayed in the server log (Tom)
       This avoids Windows-specific problems with localized time zone
       names that are in the wrong encoding. There is a new log_timezone
       parameter that controls the timezone used in log messages,
       independently of the client-visible timezone parameter.
     * New system view pg_stat_bgwriter displays statistics about
       background writer activity (Magnus)
     * Add new columns for database-wide tuple statistics to
       pg_stat_database (Magnus)
     * Add an xact_start (transaction start time) column to
       pg_stat_activity (Neil)
       This makes it easier to identify long-running transactions.
     * Add n_live_tuples and n_dead_tuples columns to pg_stat_all_tables
       and related views (Glen Parker)
     * Merge stats_block_level and stats_row_level parameters into a
       single parameter track_counts, which controls all messages sent to
       the statistics collector process (Tom)
     * Rename stats_command_string parameter to track_activities (Tom)
     * Fix statistical counting of live and dead tuples to recognize that
       committed and aborted transactions have different effects (Tom)
     __________________________________________________________________

Authentication

     * Support Security Service Provider Interface (SSPI) for
       authentication on Windows (Magnus)
     * Support GSSAPI authentication (Henry Hotz, Magnus)
       This should be preferred to native Kerberos authentication because
       GSSAPI is an industry standard.
     * Support a global SSL configuration file (Victor Wagner)
     * Add ssl_ciphers parameter to control accepted SSL ciphers (Victor
       Wagner)
     * Add a Kerberos realm parameter, krb_realm (Magnus)
     __________________________________________________________________

Write-Ahead Log (WAL) and Continuous Archiving

     * Change the timestamps recorded in transaction WAL records from
       time_t to TimestampTz representation (Tom)
       This provides sub-second resolution in WAL, which can be useful for
       point-in-time recovery.
     * Reduce WAL disk space needed by warm standby servers (Simon)
       This change allows a warm standby server to pass the name of the
       earliest still-needed WAL file to the recovery script, allowing
       automatic removal of no-longer-needed WAL files. This is done using
       %r in the restore_command parameter of "recovery.conf".
     * New boolean configuration parameter, archive_mode, controls
       archiving (Simon)
       Previously setting archive_command to an empty string turned off
       archiving. Now archive_mode turns archiving on and off,
       independently of archive_command. This is useful for stopping
       archiving temporarily.
     __________________________________________________________________

Queries

     * Full text search is integrated into the core database system
       (Teodor, Oleg)
       Text search has been improved, moved into the core code, and is now
       installed by default. "contrib/tsearch2" now contains a
       compatibility interface.
     * Add control over whether NULLs sort first or last (Teodor, Tom)
       The syntax is ORDER BY ... NULLS FIRST/LAST.
     * Allow per-column ascending/descending (ASC/DESC) ordering options
       for indexes (Teodor, Tom)
       Previously a query using ORDER BY with mixed ASC/DESC specifiers
       could not fully use an index. Now an index can be fully used in
       such cases if the index was created with matching ASC/DESC
       specifications. NULL sort order within an index can be controlled,
       too.
     * Allow col IS NULL to use an index (Teodor)
     * Updatable cursors (Arul Shaji, Tom)
       This eliminates the need to reference a primary key to "UPDATE" or
       "DELETE" rows returned by a cursor. The syntax is UPDATE/DELETE
       WHERE CURRENT OF.
     * Allow FOR UPDATE in cursors (Arul Shaji, Tom)
     * Create a general mechanism that supports casts to and from the
       standard string types (TEXT, VARCHAR, CHAR) for *every* datatype,
       by invoking the datatype's I/O functions (Tom)
       Previously, such casts were available only for types that had
       specialized function(s) for the purpose. These new casts are
       assignment-only in the to-string direction, explicit-only in the
       other direction, and therefore should create no surprising
       behavior.
     * Allow UNION and related constructs to return a domain type, when
       all inputs are of that domain type (Tom)
       Formerly, the output would be considered to be of the domain's base
       type.
     * Allow limited hashing when using two different data types (Tom)
       This allows hash joins, hash indexes, hashed subplans, and hash
       aggregation to be used in situations involving cross-data-type
       comparisons, if the data types have compatible hash functions.
       Currently, cross-data-type hashing support exists for
       smallint/integer/bigint, and for float4/float8.
     * Improve optimizer logic for detecting when variables are equal in a
       WHERE clause (Tom)
       This allows mergejoins to work with descending sort orders, and
       improves recognition of redundant sort columns.
     * Improve performance when planning large inheritance trees in cases
       where most tables are excluded by constraints (Tom)
     __________________________________________________________________

Object Manipulation

     * Arrays of composite types (David Fetter, Andrew, Tom)
       In addition to arrays of explicitly-declared composite types,
       arrays of the rowtypes of regular tables and views are now
       supported, except for rowtypes of system catalogs, sequences, and
       TOAST tables.
     * Server configuration parameters can now be set on a per-function
       basis (Tom)
       For example, functions can now set their own search_path to prevent
       unexpected behavior if a different search_path exists at run-time.
       Security definer functions should set search_path to avoid security
       loopholes.
     * "CREATE/ALTER FUNCTION" now supports COST and ROWS options (Tom)
       COST allows specification of the cost of a function call. ROWS
       allows specification of the average number or rows returned by a
       set-returning function. These values are used by the optimizer in
       choosing the best plan.
     * Implement "CREATE TABLE LIKE ... INCLUDING INDEXES" (Trevor
       Hardcastle, Nikhil Sontakke, Neil)
     * Allow "CREATE INDEX CONCURRENTLY" to ignore transactions in other
       databases (Simon)
     * Add "ALTER VIEW ... RENAME TO" and "ALTER SEQUENCE ... RENAME TO"
       (David Fetter, Neil)
       Previously this could only be done via "ALTER TABLE ... RENAME TO".
     * Make "CREATE/DROP/RENAME DATABASE" wait briefly for conflicting
       backends to exit before failing (Tom)
       This increases the likelihood that these commands will succeed.
     * Allow triggers and rules to be deactivated in groups using a
       configuration parameter, for replication purposes (Jan)
       This allows replication systems to disable triggers and rewrite
       rules as a group without modifying the system catalogs directly.
       The behavior is controlled by "ALTER TABLE" and a new parameter
       session_replication_role.
     * User-defined types can now have type modifiers (Teodor, Tom)
       This allows a user-defined type to take a modifier, like ssnum(7).
       Previously only built-in data types could have modifiers.
     __________________________________________________________________

Utility Commands

     * Non-superuser database owners now are able to add trusted
       procedural languages to their databases by default (Jeremy Drake)
       While this is reasonably safe, some administrators might wish to
       revoke the privilege. It is controlled by
       pg_pltemplate.tmpldbacreate.
     * Allow a session's current parameter setting to be used as the
       default for future sessions (Tom)
       This is done with SET ... FROM CURRENT in "CREATE/ALTER FUNCTION",
       "ALTER DATABASE", or "ALTER ROLE".
     * Implement new commands "DISCARD ALL", "DISCARD PLANS", "DISCARD
       TEMPORARY", "CLOSE ALL", and "DEALLOCATE ALL" (Marko Kreen, Neil)
       These commands simplify resetting a database session to its initial
       state, and are particularly useful for connection-pooling software.
     * Make "CLUSTER" MVCC-safe (Heikki Linnakangas)
       Formerly, "CLUSTER" would discard all tuples that were committed
       dead, even if there were still transactions that should be able to
       see them under MVCC visibility rules.
     * Add new "CLUSTER" syntax: CLUSTER table USING index (Holger
       Schurig)
       The old "CLUSTER" syntax is still supported, but the new form is
       considered more logical.
     * Fix "EXPLAIN" so it can show complex plans more accurately (Tom)
       References to subplan outputs are now always shown correctly,
       instead of using ?columnN? for complicated cases.
     * Limit the amount of information reported when a user is dropped
       (Alvaro)
       Previously, dropping (or attempting to drop) a user who owned many
       objects could result in large NOTICE or ERROR messages listing all
       these objects; this caused problems for some client applications.
       The length of the message is now limited, although a full list is
       still sent to the server log.
     __________________________________________________________________

Data Types

     * Support for the SQL/XML standard, including new operators and an
       XML data type (Nikolay Samokhvalov, Pavel Stehule, Peter)
     * Enumerated data types (ENUM) (Tom Dunstan)
       This feature provides convenient support for fields that have a
       small, fixed set of allowed values. An example of creating an ENUM
       type is CREATE TYPE mood AS ENUM ('sad', 'ok', 'happy').
     * Universally Unique Identifier (UUID) data type (Gevik Babakhani,
       Neil)
       This closely matches RFC 4122.
     * Widen the MONEY data type to 64 bits (D'Arcy Cain)
       This greatly increases the range of supported MONEY values.
     * Fix float4/float8 to handle Infinity and NAN (Not A Number)
       consistently (Bruce)
       The code formerly was not consistent about distinguishing Infinity
       from overflow conditions.
     * Allow leading and trailing whitespace during input of boolean
       values (Neil)
     * Prevent "COPY" from using digits and lowercase letters as
       delimiters (Tom)
     __________________________________________________________________

Functions

     * Add new regular expression functions regexp_matches(),
       regexp_split_to_array(), and regexp_split_to_table() (Jeremy Drake,
       Neil)
       These functions provide extraction of regular expression
       subexpressions and allow splitting a string using a POSIX regular
       expression.
     * Add lo_truncate() for large object truncation (Kris Jurka)
     * Implement width_bucket() for the float8 data type (Neil)
     * Add pg_stat_clear_snapshot() to discard statistics snapshots
       collected during the current transaction (Tom)
       The first request for statistics in a transaction takes a
       statistics snapshot that does not change during the transaction.
       This function allows the snapshot to be discarded and a new
       snapshot loaded during the next statistics query. This is
       particularly useful for PL/pgSQL functions, which are confined to a
       single transaction.
     * Add isodow option to EXTRACT() and date_part() (Bruce)
       This returns the day of the week, with Sunday as seven. (dow
       returns Sunday as zero.)
     * Add ID (ISO day of week) and IDDD (ISO day of year) format codes
       for to_char(), to_date(), and to_timestamp() (Brendan Jurd)
     * Make to_timestamp() and to_date() assume TM (trim) option for
       potentially variable-width fields (Bruce)
       This matches Oracle's behavior.
     * Fix off-by-one conversion error in to_date()/to_timestamp() D
       (non-ISO day of week) fields (Bruce)
     * Make setseed() return void, rather than a useless integer value
       (Neil)
     * Add a hash function for NUMERIC (Neil)
       This allows hash indexes and hash-based plans to be used with
       NUMERIC columns.
     * Improve efficiency of LIKE/ILIKE, especially for multi-byte
       character sets like UTF-8 (Andrew, Itagaki Takahiro)
     * Make currtid() functions require SELECT privileges on the target
       table (Tom)
     * Add several txid_*() functions to query active transaction IDs
       (Jan)
       This is useful for various replication solutions.
     __________________________________________________________________

PL/pgSQL Server-Side Language

     * Add scrollable cursor support, including directional control in
       "FETCH" (Pavel Stehule)
     * Allow IN as an alternative to FROM in PL/pgSQL's "FETCH" statement,
       for consistency with the backend's "FETCH" command (Pavel Stehule)
     * Add "MOVE" to PL/pgSQL (Magnus, Pavel Stehule, Neil)
     * Implement "RETURN QUERY" (Pavel Stehule, Neil)
       This adds convenient syntax for PL/pgSQL set-returning functions
       that want to return the result of a query. "RETURN QUERY" is easier
       and more efficient than a loop around "RETURN NEXT".
     * Allow function parameter names to be qualified with the function's
       name (Tom)
       For example, myfunc.myvar. This is particularly useful for
       specifying variables in a query where the variable name might match
       a column name.
     * Make qualification of variables with block labels work properly
       (Tom)
       Formerly, outer-level block labels could unexpectedly interfere
       with recognition of inner-level record or row references.
     * Tighten requirements for FOR loop STEP values (Tom)
       Prevent non-positive STEP values, and handle loop overflows.
     * Improve accuracy when reporting syntax error locations (Tom)
     __________________________________________________________________

Other Server-Side Languages

     * Allow type-name arguments to PL/Perl spi_prepare() to be data type
       aliases in addition to names found in pg_type (Andrew)
     * Allow type-name arguments to PL/Python plpy.prepare() to be data
       type aliases in addition to names found in pg_type (Andrew)
     * Allow type-name arguments to PL/Tcl spi_prepare to be data type
       aliases in addition to names found in pg_type (Andrew)
     * Enable PL/PythonU to compile on Python 2.5 (Marko Kreen)
     * Support a true PL/Python boolean type in compatible Python versions
       (Python 2.3 and later) (Marko Kreen)
     * Fix PL/Tcl problems with thread-enabled "libtcl" spawning multiple
       threads within the backend (Steve Marshall, Paul Bayer, Doug
       Knight)
       This caused all sorts of unpleasantness.
     __________________________________________________________________

psql

     * List disabled triggers separately in \d output (Brendan Jurd)
     * In \d patterns, always match $ literally (Tom)
     * Show aggregate return types in \da output (Greg Sabino Mullane)
     * Add the function's volatility status to the output of \df+ (Neil)
     * Add \prompt capability (Chad Wagner)
     * Allow \pset, \t, and \x to specify on or off, rather than just
       toggling (Chad Wagner)
     * Add \sleep capability (Jan)
     * Enable \timing output for \copy (Andrew)
     * Improve \timing resolution on Windows (Itagaki Takahiro)
     * Flush \o output after each backslash command (Tom)
     * Correctly detect and report errors while reading a -f input file
       (Peter)
     * Remove -u option (this option has long been deprecated) (Tom)
     __________________________________________________________________

pg_dump

     * Add --tablespaces-only and --roles-only options to pg_dumpall (Dave
       Page)
     * Add an output file option to pg_dumpall (Dave Page)
       This is primarily useful on Windows, where output redirection of
       child pg_dump processes does not work.
     * Allow pg_dumpall to accept an initial-connection database name
       rather than the default template1 (Dave Page)
     * In -n and -t switches, always match $ literally (Tom)
     * Improve performance when a database has thousands of objects (Tom)
     * Remove -u option (this option has long been deprecated) (Tom)
     __________________________________________________________________

Other Client Applications

     * In initdb, allow the location of the "pg_xlog" directory to be
       specified (Euler Taveira de Oliveira)
     * Enable server core dump generation in pg_regress on supported
       operating systems (Andrew)
     * Add a -t (timeout) parameter to pg_ctl (Bruce)
       This controls how long pg_ctl will wait when waiting for server
       startup or shutdown. Formerly the timeout was hard-wired as 60
       seconds.
     * Add a pg_ctl option to control generation of server core dumps
       (Andrew)
     * Allow Control-C to cancel clusterdb, reindexdb, and vacuumdb
       (Itagaki Takahiro, Magnus)
     * Suppress command tag output for createdb, createuser, dropdb, and
       dropuser (Peter)
       The --quiet option is ignored and will be removed in 8.4. Progress
       messages when acting on all databases now go to stdout instead of
       stderr because they are not actually errors.
     __________________________________________________________________

libpq

     * Interpret the dbName parameter of PQsetdbLogin() as a conninfo
       string if it contains an equals sign (Andrew)
       This allows use of conninfo strings in client programs that still
       use PQsetdbLogin().
     * Support a global SSL configuration file (Victor Wagner)
     * Add environment variable PGSSLKEY to control SSL hardware keys
       (Victor Wagner)
     * Add lo_truncate() for large object truncation (Kris Jurka)
     * Add PQconnectionNeedsPassword() that returns true if the server
       required a password but none was supplied (Joe Conway, Tom)
       If this returns true after a failed connection attempt, a client
       application should prompt the user for a password. In the past
       applications have had to check for a specific error message string
       to decide whether a password is needed; that approach is now
       deprecated.
     * Add PQconnectionUsedPassword() that returns true if the supplied
       password was actually used (Joe Conway, Tom)
       This is useful in some security contexts where it is important to
       know whether a user-supplied password is actually valid.
     __________________________________________________________________

ecpg

     * Use V3 frontend/backend protocol (Michael)
       This adds support for server-side prepared statements.
     * Use native threads, instead of pthreads, on Windows (Magnus)
     * Improve thread-safety of ecpglib (Itagaki Takahiro)
     * Make the ecpg libraries export only necessary API symbols (Michael)
     __________________________________________________________________

Windows Port

     * Allow the whole PostgreSQL distribution to be compiled with
       Microsoft Visual C++ (Magnus and others)
       This allows Windows-based developers to use familiar development
       and debugging tools. Windows executables made with Visual C++ might
       also have better stability and performance than those made with
       other tool sets. The client-only Visual C++ build scripts have been
       removed.
     * Drastically reduce postmaster's memory usage when it has many child
       processes (Magnus)
     * Allow regression tests to be started by an administrative user
       (Magnus)
     * Add native shared memory implementation (Magnus)
     __________________________________________________________________

Server Programming Interface (SPI)

     * Add cursor-related functionality in SPI (Pavel Stehule)
       Allow access to the cursor-related planning options, and add
       "FETCH"/"MOVE" routines.
     * Allow execution of cursor commands through SPI_execute (Tom)
       The macro SPI_ERROR_CURSOR still exists but will never be returned.
     * SPI plan pointers are now declared as SPIPlanPtr instead of void *
       (Tom)
       This does not break application code, but switching is recommended
       to help catch simple programming mistakes.
     __________________________________________________________________

Build Options

     * Add configure option --enable-profiling to enable code profiling
       (works only with gcc) (Korry Douglas and Nikhil Sontakke)
     * Add configure option --with-system-tzdata to use the operating
       system's time zone database (Peter)
     * Fix PGXS so extensions can be built against PostgreSQL
       installations whose pg_config program does not appear first in the
       PATH (Tom)
     * Support "gmake draft" when building the SGML documentation (Bruce)
       Unless draft is used, the documentation build will now be repeated
       if necessary to ensure the index is up-to-date.
     __________________________________________________________________

Source Code

     * Rename macro DLLIMPORT to PGDLLIMPORT to avoid conflicting with
       third party includes (like Tcl) that define DLLIMPORT (Magnus)
     * Create "operator families" to improve planning of queries involving
       cross-data-type comparisons (Tom)
     * Update GIN extractQuery() API to allow signalling that nothing can
       satisfy the query (Teodor)
     * Move NAMEDATALEN definition from "postgres_ext.h" to
       "pg_config_manual.h" (Peter)
     * Provide strlcpy() and strlcat() on all platforms, and replace
       error-prone uses of strncpy(), strncat(), etc (Peter)
     * Create hooks to let an external plugin monitor (or even replace)
       the planner and create plans for hypothetical situations (Gurjeet
       Singh, Tom)
     * Create a function variable join_search_hook to let plugins override
       the join search order portion of the planner (Julius Stroffek)
     * Add tas() support for Renesas' M32R processor (Kazuhiro Inaoka)
     * quote_identifier() and pg_dump no longer quote keywords that are
       unreserved according to the grammar (Tom)
     * Change the on-disk representation of the NUMERIC data type so that
       the sign_dscale word comes before the weight (Tom)
     * Use SYSV semaphores rather than POSIX on Darwin >= 6.0, i.e., OS X
       10.2 and up (Chris Marcellino)
     * Add acronym and NFS documentation sections (Bruce)
     * "Postgres" is now documented as an accepted alias for "PostgreSQL"
       (Peter)
     * Add documentation about preventing database server spoofing when
       the server is down (Bruce)
     __________________________________________________________________

Contrib

     * Move "contrib" "README" content into the main PostgreSQL
       documentation (Albert Cervera i Areny)
     * Add "contrib/pageinspect" module for low-level page inspection
       (Simon, Heikki)
     * Add "contrib/pg_standby" module for controlling warm standby
       operation (Simon)
     * Add "contrib/uuid-ossp" module for generating UUID values using the
       OSSP UUID library (Peter)
       Use configure --with-ossp-uuid to activate. This takes advantage of
       the new UUID builtin type.
     * Add "contrib/dict_int", "contrib/dict_xsyn", and
       "contrib/test_parser" modules to provide sample add-on text search
       dictionary templates and parsers (Sergey Karpov)
     * Allow contrib/pgbench to set the fillfactor (Pavan Deolasee)
     * Add timestamps to contrib/pgbench -l (Greg Smith)
     * Add usage count statistics to "contrib/pgbuffercache" (Greg Smith)
     * Add GIN support for "contrib/hstore" (Teodor)
     * Add GIN support for "contrib/pg_trgm" (Guillaume Smet, Teodor)
     * Update OS/X startup scripts in "contrib/start-scripts" (Mark
       Cotner, David Fetter)
     * Restrict pgrowlocks() and dblink_get_pkey() to users who have
       SELECT privilege on the target table (Tom)
     * Restrict "contrib/pgstattuple" functions to superusers (Tom)
     * "contrib/xml2" is deprecated and planned for removal in 8.4 (Peter)
       The new XML support in core PostgreSQL supersedes this module.
     __________________________________________________________________

                               Release 8.2.20

     Release date: 2011-01-31

   This release contains a variety of fixes from 8.2.19. For information
   about new features in the 8.2 major release, see the Section called
   Release 8.2.
     __________________________________________________________________

Migration to Version 8.2.20

   A dump/restore is not required for those running 8.2.X. However, if you
   are upgrading from a version earlier than 8.2.14, see the release notes
   for 8.2.14.
     __________________________________________________________________

Changes

     * Avoid failures when "EXPLAIN" tries to display a simple-form CASE
       expression (Tom Lane)
       If the CASE's test expression was a constant, the planner could
       simplify the CASE into a form that confused the expression-display
       code, resulting in "unexpected CASE WHEN clause" errors.
     * Fix assignment to an array slice that is before the existing range
       of subscripts (Tom Lane)
       If there was a gap between the newly added subscripts and the first
       pre-existing subscript, the code miscalculated how many entries
       needed to be copied from the old array's null bitmap, potentially
       leading to data corruption or crash.
     * Avoid unexpected conversion overflow in planner for very distant
       date values (Tom Lane)
       The date type supports a wider range of dates than can be
       represented by the timestamp types, but the planner assumed it
       could always convert a date to timestamp with impunity.
     * Fix pg_restore's text output for large objects (BLOBs) when
       standard_conforming_strings is on (Tom Lane)
       Although restoring directly to a database worked correctly, string
       escaping was incorrect if pg_restore was asked for SQL text output
       and standard_conforming_strings had been enabled in the source
       database.
     * Fix erroneous parsing of tsquery values containing ... &
       !(subexpression) | ... (Tom Lane)
       Queries containing this combination of operators were not executed
       correctly. The same error existed in "contrib/intarray"'s query_int
       type and "contrib/ltree"'s ltxtquery type.
     * Fix buffer overrun in "contrib/intarray"'s input function for the
       query_int type (Apple)
       This bug is a security risk since the function's return address
       could be overwritten. Thanks to Apple Inc's security team for
       reporting this issue and supplying the fix. (CVE-2010-4015)
     * Fix bug in "contrib/seg"'s GiST picksplit algorithm (Alexander
       Korotkov)
       This could result in considerable inefficiency, though not actually
       incorrect answers, in a GiST index on a seg column. If you have
       such an index, consider "REINDEX"ing it after installing this
       update. (This is identical to the bug that was fixed in
       "contrib/cube" in the previous update.)
     __________________________________________________________________

                               Release 8.2.19

     Release date: 2010-12-16

   This release contains a variety of fixes from 8.2.18. For information
   about new features in the 8.2 major release, see the Section called
   Release 8.2.
     __________________________________________________________________

Migration to Version 8.2.19

   A dump/restore is not required for those running 8.2.X. However, if you
   are upgrading from a version earlier than 8.2.14, see the release notes
   for 8.2.14.
     __________________________________________________________________

Changes

     * Force the default wal_sync_method to be fdatasync on Linux (Tom
       Lane, Marti Raudsepp)
       The default on Linux has actually been fdatasync for many years,
       but recent kernel changes caused PostgreSQL to choose open_datasync
       instead. This choice did not result in any performance improvement,
       and caused outright failures on certain filesystems, notably ext4
       with the data=journal mount option.
     * Fix assorted bugs in WAL replay logic for GIN indexes (Tom Lane)
       This could result in "bad buffer id: 0" failures or corruption of
       index contents during replication.
     * Fix recovery from base backup when the starting checkpoint WAL
       record is not in the same WAL segment as its redo point (Jeff
       Davis)
     * Add support for detecting register-stack overrun on IA64 (Tom Lane)
       The IA64 architecture has two hardware stacks. Full prevention of
       stack-overrun failures requires checking both.
     * Add a check for stack overflow in copyObject() (Tom Lane)
       Certain code paths could crash due to stack overflow given a
       sufficiently complex query.
     * Fix detection of page splits in temporary GiST indexes (Heikki
       Linnakangas)
       It is possible to have a "concurrent" page split in a temporary
       index, if for example there is an open cursor scanning the index
       when an insertion is done. GiST failed to detect this case and
       hence could deliver wrong results when execution of the cursor
       continued.
     * Avoid memory leakage while "ANALYZE"'ing complex index expressions
       (Tom Lane)
     * Ensure an index that uses a whole-row Var still depends on its
       table (Tom Lane)
       An index declared like create index i on t (foo(t.*)) would not
       automatically get dropped when its table was dropped.
     * Do not "inline" a SQL function with multiple OUT parameters (Tom
       Lane)
       This avoids a possible crash due to loss of information about the
       expected result rowtype.
     * Behave correctly if ORDER BY, LIMIT, FOR UPDATE, or WITH is
       attached to the VALUES part of INSERT ... VALUES (Tom Lane)
     * Fix constant-folding of COALESCE() expressions (Tom Lane)
       The planner would sometimes attempt to evaluate sub-expressions
       that in fact could never be reached, possibly leading to unexpected
       errors.
     * Add print functionality for InhRelation nodes (Tom Lane)
       This avoids a failure when debug_print_parse is enabled and certain
       types of query are executed.
     * Fix incorrect calculation of distance from a point to a horizontal
       line segment (Tom Lane)
       This bug affected several different geometric distance-measurement
       operators.
     * Fix PL/pgSQL's handling of "simple" expressions to not fail in
       recursion or error-recovery cases (Tom Lane)
     * Fix PL/Python's handling of set-returning functions (Jan Urbanski)
       Attempts to call SPI functions within the iterator generating a set
       result would fail.
     * Fix bug in "contrib/cube"'s GiST picksplit algorithm (Alexander
       Korotkov)
       This could result in considerable inefficiency, though not actually
       incorrect answers, in a GiST index on a cube column. If you have
       such an index, consider "REINDEX"ing it after installing this
       update.
     * Don't emit "identifier will be truncated" notices in
       "contrib/dblink" except when creating new connections (Itagaki
       Takahiro)
     * Fix potential coredump on missing public key in "contrib/pgcrypto"
       (Marti Raudsepp)
     * Fix memory leak in "contrib/xml2"'s XPath query functions (Tom
       Lane)
     * Update time zone data files to tzdata release 2010o for DST law
       changes in Fiji and Samoa; also historical corrections for Hong
       Kong.
     __________________________________________________________________

                               Release 8.2.18

     Release date: 2010-10-04

   This release contains a variety of fixes from 8.2.17. For information
   about new features in the 8.2 major release, see the Section called
   Release 8.2.
     __________________________________________________________________

Migration to Version 8.2.18

   A dump/restore is not required for those running 8.2.X. However, if you
   are upgrading from a version earlier than 8.2.14, see the release notes
   for 8.2.14.
     __________________________________________________________________

Changes

     * Use a separate interpreter for each calling SQL userid in PL/Perl
       and PL/Tcl (Tom Lane)
       This change prevents security problems that can be caused by
       subverting Perl or Tcl code that will be executed later in the same
       session under another SQL user identity (for example, within a
       SECURITY DEFINER function). Most scripting languages offer numerous
       ways that that might be done, such as redefining standard functions
       or operators called by the target function. Without this change,
       any SQL user with Perl or Tcl language usage rights can do
       essentially anything with the SQL privileges of the target
       function's owner.
       The cost of this change is that intentional communication among
       Perl and Tcl functions becomes more difficult. To provide an escape
       hatch, PL/PerlU and PL/TclU functions continue to use only one
       interpreter per session. This is not considered a security issue
       since all such functions execute at the trust level of a database
       superuser already.
       It is likely that third-party procedural languages that claim to
       offer trusted execution have similar security issues. We advise
       contacting the authors of any PL you are depending on for
       security-critical purposes.
       Our thanks to Tim Bunce for pointing out this issue
       (CVE-2010-3433).
     * Prevent possible crashes in pg_get_expr() by disallowing it from
       being called with an argument that is not one of the system catalog
       columns it's intended to be used with (Heikki Linnakangas, Tom
       Lane)
     * Fix Windows shared-memory allocation code (Tsutomu Yamada, Magnus
       Hagander)
       This bug led to the often-reported "could not reattach to shared
       memory" error message. This is a back-patch of a fix that was
       applied to newer branches some time ago.
     * Treat exit code 128 (ERROR_WAIT_NO_CHILDREN) as non-fatal on
       Windows (Magnus Hagander)
       Under high load, Windows processes will sometimes fail at startup
       with this error code. Formerly the postmaster treated this as a
       panic condition and restarted the whole database, but that seems to
       be an overreaction.
     * Fix possible duplicate scans of UNION ALL member relations (Tom
       Lane)
     * Fix "cannot handle unplanned sub-select" error (Tom Lane)
       This occurred when a sub-select contains a join alias reference
       that expands into an expression containing another sub-select.
     * Reduce PANIC to ERROR in some occasionally-reported btree failure
       cases, and provide additional detail in the resulting error
       messages (Tom Lane)
       This should improve the system's robustness with corrupted indexes.
     * Prevent show_session_authorization() from crashing within
       autovacuum processes (Tom Lane)
     * Defend against functions returning setof record where not all the
       returned rows are actually of the same rowtype (Tom Lane)
     * Fix possible failure when hashing a pass-by-reference function
       result (Tao Ma, Tom Lane)
     * Take care to fsync the contents of lockfiles (both "postmaster.pid"
       and the socket lockfile) while writing them (Tom Lane)
       This omission could result in corrupted lockfile contents if the
       machine crashes shortly after postmaster start. That could in turn
       prevent subsequent attempts to start the postmaster from
       succeeding, until the lockfile is manually removed.
     * Avoid recursion while assigning XIDs to heavily-nested
       subtransactions (Andres Freund, Robert Haas)
       The original coding could result in a crash if there was limited
       stack space.
     * Fix log_line_prefix's %i escape, which could produce junk early in
       backend startup (Tom Lane)
     * Fix possible data corruption in "ALTER TABLE ... SET TABLESPACE"
       when archiving is enabled (Jeff Davis)
     * Allow "CREATE DATABASE" and "ALTER DATABASE ... SET TABLESPACE" to
       be interrupted by query-cancel (Guillaume Lelarge)
     * In PL/Python, defend against null pointer results from
       PyCObject_AsVoidPtr and PyCObject_FromVoidPtr (Peter Eisentraut)
     * Improve "contrib/dblink"'s handling of tables containing dropped
       columns (Tom Lane)
     * Fix connection leak after "duplicate connection name" errors in
       "contrib/dblink" (Itagaki Takahiro)
     * Fix "contrib/dblink" to handle connection names longer than 62
       bytes correctly (Itagaki Takahiro)
     * Add hstore(text, text) function to "contrib/hstore" (Robert Haas)
       This function is the recommended substitute for the now-deprecated
       => operator. It was back-patched so that future-proofed code can be
       used with older server versions. Note that the patch will be
       effective only after "contrib/hstore" is installed or reinstalled
       in a particular database. Users might prefer to execute the "CREATE
       FUNCTION" command by hand, instead.
     * Update build infrastructure and documentation to reflect the source
       code repository's move from CVS to Git (Magnus Hagander and others)
     * Update time zone data files to tzdata release 2010l for DST law
       changes in Egypt and Palestine; also historical corrections for
       Finland.
       This change also adds new names for two Micronesian timezones:
       Pacific/Chuuk is now preferred over Pacific/Truk (and the preferred
       abbreviation is CHUT not TRUT) and Pacific/Pohnpei is preferred
       over Pacific/Ponape.
     * Make Windows' "N. Central Asia Standard Time" timezone map to
       Asia/Novosibirsk, not Asia/Almaty (Magnus Hagander)
       Microsoft changed the DST behavior of this zone in the timezone
       update from KB976098. Asia/Novosibirsk is a better match to its new
       behavior.
     __________________________________________________________________

                               Release 8.2.17

     Release date: 2010-05-17

   This release contains a variety of fixes from 8.2.16. For information
   about new features in the 8.2 major release, see the Section called
   Release 8.2.
     __________________________________________________________________

Migration to Version 8.2.17

   A dump/restore is not required for those running 8.2.X. However, if you
   are upgrading from a version earlier than 8.2.14, see the release notes
   for 8.2.14.
     __________________________________________________________________

Changes

     * Enforce restrictions in plperl using an opmask applied to the whole
       interpreter, instead of using "Safe.pm" (Tim Bunce, Andrew Dunstan)
       Recent developments have convinced us that "Safe.pm" is too
       insecure to rely on for making plperl trustable. This change
       removes use of "Safe.pm" altogether, in favor of using a separate
       interpreter with an opcode mask that is always applied. Pleasant
       side effects of the change include that it is now possible to use
       Perl's strict pragma in a natural way in plperl, and that Perl's $a
       and $b variables work as expected in sort routines, and that
       function compilation is significantly faster. (CVE-2010-1169)
     * Prevent PL/Tcl from executing untrustworthy code from pltcl_modules
       (Tom)
       PL/Tcl's feature for autoloading Tcl code from a database table
       could be exploited for trojan-horse attacks, because there was no
       restriction on who could create or insert into that table. This
       change disables the feature unless pltcl_modules is owned by a
       superuser. (However, the permissions on the table are not checked,
       so installations that really need a less-than-secure modules table
       can still grant suitable privileges to trusted non-superusers.)
       Also, prevent loading code into the unrestricted "normal" Tcl
       interpreter unless we are really going to execute a pltclu
       function. (CVE-2010-1170)
     * Fix possible crash if a cache reset message is received during
       rebuild of a relcache entry (Heikki)
       This error was introduced in 8.2.16 while fixing a related failure.
     * Do not allow an unprivileged user to reset superuser-only parameter
       settings (Alvaro)
       Previously, if an unprivileged user ran ALTER USER ... RESET ALL
       for himself, or ALTER DATABASE ... RESET ALL for a database he
       owns, this would remove all special parameter settings for the user
       or database, even ones that are only supposed to be changeable by a
       superuser. Now, the "ALTER" will only remove the parameters that
       the user has permission to change.
     * Avoid possible crash during backend shutdown if shutdown occurs
       when a CONTEXT addition would be made to log entries (Tom)
       In some cases the context-printing function would fail because the
       current transaction had already been rolled back when it came time
       to print a log message.
     * Update pl/perl's "ppport.h" for modern Perl versions (Andrew)
     * Fix assorted memory leaks in pl/python (Andreas Freund, Tom)
     * Prevent infinite recursion in psql when expanding a variable that
       refers to itself (Tom)
     * Fix psql's \copy to not add spaces around a dot within \copy
       (select ...) (Tom)
       Addition of spaces around the decimal point in a numeric literal
       would result in a syntax error.
     * Ensure that "contrib/pgstattuple" functions respond to cancel
       interrupts promptly (Tatsuhito Kasahara)
     * Make server startup deal properly with the case that shmget()
       returns EINVAL for an existing shared memory segment (Tom)
       This behavior has been observed on BSD-derived kernels including OS
       X. It resulted in an entirely-misleading startup failure
       complaining that the shared memory request size was too large.
     * Avoid possible crashes in syslogger process on Windows (Heikki)
     * Deal more robustly with incomplete time zone information in the
       Windows registry (Magnus)
     * Update the set of known Windows time zone names (Magnus)
     * Update time zone data files to tzdata release 2010j for DST law
       changes in Argentina, Australian Antarctic, Bangladesh, Mexico,
       Morocco, Pakistan, Palestine, Russia, Syria, Tunisia; also
       historical corrections for Taiwan.
       Also, add PKST (Pakistan Summer Time) to the default set of
       timezone abbreviations.
     __________________________________________________________________

                               Release 8.2.16

     Release date: 2010-03-15

   This release contains a variety of fixes from 8.2.15. For information
   about new features in the 8.2 major release, see the Section called
   Release 8.2.
     __________________________________________________________________

Migration to Version 8.2.16

   A dump/restore is not required for those running 8.2.X. However, if you
   are upgrading from a version earlier than 8.2.14, see the release notes
   for 8.2.14.
     __________________________________________________________________

Changes

     * Add new configuration parameter ssl_renegotiation_limit to control
       how often we do session key renegotiation for an SSL connection
       (Magnus)
       This can be set to zero to disable renegotiation completely, which
       may be required if a broken SSL library is used. In particular,
       some vendors are shipping stopgap patches for CVE-2009-3555 that
       cause renegotiation attempts to fail.
     * Fix possible deadlock during backend startup (Tom)
     * Fix possible crashes due to not handling errors during relcache
       reload cleanly (Tom)
     * Fix possible crashes when trying to recover from a failure in
       subtransaction start (Tom)
     * Fix server memory leak associated with use of savepoints and a
       client encoding different from server's encoding (Tom)
     * Fix incorrect WAL data emitted during end-of-recovery cleanup of a
       GIST index page split (Yoichi Hirai)
       This would result in index corruption, or even more likely an error
       during WAL replay, if we were unlucky enough to crash during
       end-of-recovery cleanup after having completed an incomplete GIST
       insertion.
     * Make substring() for bit types treat any negative length as meaning
       "all the rest of the string" (Tom)
       The previous coding treated only -1 that way, and would produce an
       invalid result value for other negative values, possibly leading to
       a crash (CVE-2010-0442).
     * Fix integer-to-bit-string conversions to handle the first
       fractional byte correctly when the output bit width is wider than
       the given integer by something other than a multiple of 8 bits
       (Tom)
     * Fix some cases of pathologically slow regular expression matching
       (Tom)
     * Fix the STOP WAL LOCATION entry in backup history files to report
       the next WAL segment's name when the end location is exactly at a
       segment boundary (Itagaki Takahiro)
     * Fix some more cases of temporary-file leakage (Heikki)
       This corrects a problem introduced in the previous minor release.
       One case that failed is when a plpgsql function returning set is
       called within another function's exception handler.
     * Improve constraint exclusion processing of boolean-variable cases,
       in particular make it possible to exclude a partition that has a
       "bool_column = false" constraint (Tom)
     * When reading "pg_hba.conf" and related files, do not treat
       @something as a file inclusion request if the @ appears inside
       quote marks; also, never treat @ by itself as a file inclusion
       request (Tom)
       This prevents erratic behavior if a role or database name starts
       with @. If you need to include a file whose path name contains
       spaces, you can still do so, but you must write @"/path to/file"
       rather than putting the quotes around the whole construct.
     * Prevent infinite loop on some platforms if a directory is named as
       an inclusion target in "pg_hba.conf" and related files (Tom)
     * Fix possible infinite loop if SSL_read or SSL_write fails without
       setting errno (Tom)
       This is reportedly possible with some Windows versions of openssl.
     * Fix psql's numericlocale option to not format strings it shouldn't
       in latex and troff output formats (Heikki)
     * Make psql return the correct exit status (3) when ON_ERROR_STOP and
       --single-transaction are both specified and an error occurs during
       the implied "COMMIT" (Bruce)
     * Fix plpgsql failure in one case where a composite column is set to
       NULL (Tom)
     * Fix possible failure when calling PL/Perl functions from PL/PerlU
       or vice versa (Tim Bunce)
     * Add volatile markings in PL/Python to avoid possible
       compiler-specific misbehavior (Zdenek Kotala)
     * Ensure PL/Tcl initializes the Tcl interpreter fully (Tom)
       The only known symptom of this oversight is that the Tcl clock
       command misbehaves if using Tcl 8.5 or later.
     * Prevent crash in "contrib/dblink" when too many key columns are
       specified to a dblink_build_sql_* function (Rushabh Lathia, Joe
       Conway)
     * Fix assorted crashes in "contrib/xml2" caused by sloppy memory
       management (Tom)
     * Make building of "contrib/xml2" more robust on Windows (Andrew)
     * Fix race condition in Windows signal handling (Radu Ilie)
       One known symptom of this bug is that rows in pg_listener could be
       dropped under heavy load.
     * Update time zone data files to tzdata release 2010e for DST law
       changes in Bangladesh, Chile, Fiji, Mexico, Paraguay, Samoa.
     __________________________________________________________________

                               Release 8.2.15

     Release date: 2009-12-14

   This release contains a variety of fixes from 8.2.14. For information
   about new features in the 8.2 major release, see the Section called
   Release 8.2.
     __________________________________________________________________

Migration to Version 8.2.15

   A dump/restore is not required for those running 8.2.X. However, if you
   are upgrading from a version earlier than 8.2.14, see the release notes
   for 8.2.14.
     __________________________________________________________________

Changes

     * Protect against indirect security threats caused by index functions
       changing session-local state (Gurjeet Singh, Tom)
       This change prevents allegedly-immutable index functions from
       possibly subverting a superuser's session (CVE-2009-4136).
     * Reject SSL certificates containing an embedded null byte in the
       common name (CN) field (Magnus)
       This prevents unintended matching of a certificate to a server or
       client name during SSL validation (CVE-2009-4034).
     * Fix possible crash during backend-startup-time cache initialization
       (Tom)
     * Prevent signals from interrupting VACUUM at unsafe times (Alvaro)
       This fix prevents a PANIC if a VACUUM FULL is cancelled after it's
       already committed its tuple movements, as well as transient errors
       if a plain VACUUM is interrupted after having truncated the table.
     * Fix possible crash due to integer overflow in hash table size
       calculation (Tom)
       This could occur with extremely large planner estimates for the
       size of a hashjoin's result.
     * Fix very rare crash in inet/cidr comparisons (Chris Mikkelson)
     * Ensure that shared tuple-level locks held by prepared transactions
       are not ignored (Heikki)
     * Fix premature drop of temporary files used for a cursor that is
       accessed within a subtransaction (Heikki)
     * Fix incorrect logic for GiST index page splits, when the split
       depends on a non-first column of the index (Paul Ramsey)
     * Don't error out if recycling or removing an old WAL file fails at
       the end of checkpoint (Heikki)
       It's better to treat the problem as non-fatal and allow the
       checkpoint to complete. Future checkpoints will retry the removal.
       Such problems are not expected in normal operation, but have been
       seen to be caused by misdesigned Windows anti-virus and backup
       software.
     * Ensure WAL files aren't repeatedly archived on Windows (Heikki)
       This is another symptom that could happen if some other process
       interfered with deletion of a no-longer-needed file.
     * Fix PAM password processing to be more robust (Tom)
       The previous code is known to fail with the combination of the
       Linux pam_krb5 PAM module with Microsoft Active Directory as the
       domain controller. It might have problems elsewhere too, since it
       was making unjustified assumptions about what arguments the PAM
       stack would pass to it.
     * Fix processing of ownership dependencies during CREATE OR REPLACE
       FUNCTION (Tom)
     * Fix bug with calling plperl from plperlu or vice versa (Tom)
       An error exit from the inner function could result in crashes due
       to failure to re-select the correct Perl interpreter for the outer
       function.
     * Fix session-lifespan memory leak when a PL/Perl function is
       redefined (Tom)
     * Ensure that Perl arrays are properly converted to PostgreSQL arrays
       when returned by a set-returning PL/Perl function (Andrew Dunstan,
       Abhijit Menon-Sen)
       This worked correctly already for non-set-returning functions.
     * Fix rare crash in exception processing in PL/Python (Peter)
     * Ensure psql's flex module is compiled with the correct system
       header definitions (Tom)
       This fixes build failures on platforms where --enable-largefile
       causes incompatible changes in the generated code.
     * Make the postmaster ignore any application_name parameter in
       connection request packets, to improve compatibility with future
       libpq versions (Tom)
     * Update the timezone abbreviation files to match current reality
       (Joachim Wieland)
       This includes adding IDT and SGT to the default timezone
       abbreviation set.
     * Update time zone data files to tzdata release 2009s for DST law
       changes in Antarctica, Argentina, Bangladesh, Fiji, Novokuznetsk,
       Pakistan, Palestine, Samoa, Syria; also historical corrections for
       Hong Kong.
     __________________________________________________________________

                               Release 8.2.14

     Release date: 2009-09-09

   This release contains a variety of fixes from 8.2.13. For information
   about new features in the 8.2 major release, see the Section called
   Release 8.2.
     __________________________________________________________________

Migration to Version 8.2.14

   A dump/restore is not required for those running 8.2.X. However, if you
   have any hash indexes on interval columns, you must "REINDEX" them
   after updating to 8.2.14. Also, if you are upgrading from a version
   earlier than 8.2.11, see the release notes for 8.2.11.
     __________________________________________________________________

Changes

     * Force WAL segment switch during pg_start_backup() (Heikki)
       This avoids corner cases that could render a base backup unusable.
     * Disallow "RESET ROLE" and "RESET SESSION AUTHORIZATION" inside
       security-definer functions (Tom, Heikki)
       This covers a case that was missed in the previous patch that
       disallowed "SET ROLE" and "SET SESSION AUTHORIZATION" inside
       security-definer functions. (See CVE-2007-6600)
     * Make "LOAD" of an already-loaded loadable module into a no-op (Tom)
       Formerly, "LOAD" would attempt to unload and re-load the module,
       but this is unsafe and not all that useful.
     * Disallow empty passwords during LDAP authentication (Magnus)
     * Fix handling of sub-SELECTs appearing in the arguments of an
       outer-level aggregate function (Tom)
     * Fix bugs associated with fetching a whole-row value from the output
       of a Sort or Materialize plan node (Tom)
     * Revert planner change that disabled partial-index and constraint
       exclusion optimizations when there were more than 100 clauses in an
       AND or OR list (Tom)
     * Fix hash calculation for data type interval (Tom)
       This corrects wrong results for hash joins on interval values. It
       also changes the contents of hash indexes on interval columns. If
       you have any such indexes, you must "REINDEX" them after updating.
     * Treat to_char(..., 'TH') as an uppercase ordinal suffix with
       'HH'/'HH12' (Heikki)
       It was previously handled as 'th' (lowercase).
     * Fix overflow for INTERVAL 'x ms' when "x" is more than 2 million
       and integer datetimes are in use (Alex Hunsaker)
     * Fix calculation of distance between a point and a line segment
       (Tom)
       This led to incorrect results from a number of geometric operators.
     * Fix money data type to work in locales where currency amounts have
       no fractional digits, e.g. Japan (Itagaki Takahiro)
     * Properly round datetime input like
       00:12:57.9999999999999999999999999999 (Tom)
     * Fix poor choice of page split point in GiST R-tree operator classes
       (Teodor)
     * Avoid performance degradation in bulk inserts into GIN indexes when
       the input values are (nearly) in sorted order (Tom)
     * Correctly enforce NOT NULL domain constraints in some contexts in
       PL/pgSQL (Tom)
     * Fix portability issues in plperl initialization (Andrew Dunstan)
     * Fix pg_ctl to not go into an infinite loop if "postgresql.conf" is
       empty (Jeff Davis)
     * Make "contrib/hstore" throw an error when a key or value is too
       long to fit in its data structure, rather than silently truncating
       it (Andrew Gierth)
     * Fix "contrib/xml2"'s xslt_process() to properly handle the maximum
       number of parameters (twenty) (Tom)
     * Improve robustness of libpq's code to recover from errors during
       "COPY FROM STDIN" (Tom)
     * Avoid including conflicting readline and editline header files when
       both libraries are installed (Zdenek Kotala)
     * Update time zone data files to tzdata release 2009l for DST law
       changes in Bangladesh, Egypt, Jordan, Pakistan, Argentina/San_Luis,
       Cuba, Jordan (historical correction only), Mauritius, Morocco,
       Palestine, Syria, Tunisia.
     __________________________________________________________________

                               Release 8.2.13

     Release date: 2009-03-16

   This release contains a variety of fixes from 8.2.12. For information
   about new features in the 8.2 major release, see the Section called
   Release 8.2.
     __________________________________________________________________

Migration to Version 8.2.13

   A dump/restore is not required for those running 8.2.X. However, if you
   are upgrading from a version earlier than 8.2.11, see the release notes
   for 8.2.11.
     __________________________________________________________________

Changes

     * Prevent error recursion crashes when encoding conversion fails
       (Tom)
       This change extends fixes made in the last two minor releases for
       related failure scenarios. The previous fixes were narrowly
       tailored for the original problem reports, but we have now
       recognized that *any* error thrown by an encoding conversion
       function could potentially lead to infinite recursion while trying
       to report the error. The solution therefore is to disable
       translation and encoding conversion and report the plain-ASCII form
       of any error message, if we find we have gotten into a recursive
       error reporting situation. (CVE-2009-0922)
     * Disallow "CREATE CONVERSION" with the wrong encodings for the
       specified conversion function (Heikki)
       This prevents one possible scenario for encoding conversion
       failure. The previous change is a backstop to guard against other
       kinds of failures in the same area.
     * Fix core dump when to_char() is given format codes that are
       inappropriate for the type of the data argument (Tom)
     * Fix possible failure in "contrib/tsearch2" when C locale is used
       with a multi-byte encoding (Teodor)
       Crashes were possible on platforms where wchar_t is narrower than
       int; Windows in particular.
     * Fix extreme inefficiency in "contrib/tsearch2" parser's handling of
       an email-like string containing multiple @ characters (Heikki)
     * Fix decompilation of CASE WHEN with an implicit coercion (Tom)
       This mistake could lead to Assert failures in an Assert-enabled
       build, or an "unexpected CASE WHEN clause" error message in other
       cases, when trying to examine or dump a view.
     * Fix possible misassignment of the owner of a TOAST table's rowtype
       (Tom)
       If "CLUSTER" or a rewriting variant of "ALTER TABLE" were executed
       by someone other than the table owner, the pg_type entry for the
       table's TOAST table would end up marked as owned by that someone.
       This caused no immediate problems, since the permissions on the
       TOAST rowtype aren't examined by any ordinary database operation.
       However, it could lead to unexpected failures if one later tried to
       drop the role that issued the command (in 8.1 or 8.2), or "owner of
       data type appears to be invalid" warnings from pg_dump after having
       done so (in 8.3).
     * Fix PL/pgSQL to not treat INTO after "INSERT" as an INTO-variables
       clause anywhere in the string, not only at the start; in
       particular, don't fail for "INSERT INTO" within "CREATE RULE" (Tom)
     * Clean up PL/pgSQL error status variables fully at block exit
       (Ashesh Vashi and Dave Page)
       This is not a problem for PL/pgSQL itself, but the omission could
       cause the PL/pgSQL Debugger to crash while examining the state of a
       function.
     * Retry failed calls to CallNamedPipe() on Windows (Steve Marshall,
       Magnus)
       It appears that this function can sometimes fail transiently; we
       previously treated any failure as a hard error, which could confuse
       "LISTEN"/"NOTIFY" as well as other operations.
     * Add MUST (Mauritius Island Summer Time) to the default list of
       known timezone abbreviations (Xavier Bugaud)
     __________________________________________________________________

                               Release 8.2.12

     Release date: 2009-02-02

   This release contains a variety of fixes from 8.2.11. For information
   about new features in the 8.2 major release, see the Section called
   Release 8.2.
     __________________________________________________________________

Migration to Version 8.2.12

   A dump/restore is not required for those running 8.2.X. However, if you
   are upgrading from a version earlier than 8.2.11, see the release notes
   for 8.2.11.
     __________________________________________________________________

Changes

     * Improve handling of URLs in headline() function (Teodor)
     * Improve handling of overlength headlines in headline() function
       (Teodor)
     * Prevent possible Assert failure or misconversion if an encoding
       conversion is created with the wrong conversion function for the
       specified pair of encodings (Tom, Heikki)
     * Fix possible Assert failure if a statement executed in PL/pgSQL is
       rewritten into another kind of statement, for example if an
       "INSERT" is rewritten into an "UPDATE" (Heikki)
     * Ensure that a snapshot is available to datatype input functions
       (Tom)
       This primarily affects domains that are declared with CHECK
       constraints involving user-defined stable or immutable functions.
       Such functions typically fail if no snapshot has been set.
     * Make it safer for SPI-using functions to be used within datatype
       I/O; in particular, to be used in domain check constraints (Tom)
     * Avoid unnecessary locking of small tables in "VACUUM" (Heikki)
     * Fix a problem that made UPDATE RETURNING tableoid return zero
       instead of the correct OID (Tom)
     * Fix planner misestimation of selectivity when transitive equality
       is applied to an outer-join clause (Tom)
       This could result in bad plans for queries like ... from a left
       join b on a.a1 = b.b1 where a.a1 = 42 ...
     * Improve optimizer's handling of long IN lists (Tom)
       This change avoids wasting large amounts of time on such lists when
       constraint exclusion is enabled.
     * Ensure that the contents of a holdable cursor don't depend on the
       contents of TOAST tables (Tom)
       Previously, large field values in a cursor result might be
       represented as TOAST pointers, which would fail if the referenced
       table got dropped before the cursor is read, or if the large value
       is deleted and then vacuumed away. This cannot happen with an
       ordinary cursor, but it could with a cursor that is held past its
       creating transaction.
     * Fix memory leak when a set-returning function is terminated without
       reading its whole result (Tom)
     * Fix "contrib/dblink"'s dblink_get_result(text,bool) function (Joe)
     * Fix possible garbage output from "contrib/sslinfo" functions (Tom)
     * Fix configure script to properly report failure when unable to
       obtain linkage information for PL/Perl (Andrew)
     * Make all documentation reference pgsql-bugs and/or pgsql-hackers as
       appropriate, instead of the now-decommissioned pgsql-ports and
       pgsql-patches mailing lists (Tom)
     * Update time zone data files to tzdata release 2009a (for Kathmandu
       and historical DST corrections in Switzerland, Cuba)
     __________________________________________________________________

                               Release 8.2.11

     Release date: 2008-11-03

   This release contains a variety of fixes from 8.2.10. For information
   about new features in the 8.2 major release, see the Section called
   Release 8.2.
     __________________________________________________________________

Migration to Version 8.2.11

   A dump/restore is not required for those running 8.2.X. However, if you
   are upgrading from a version earlier than 8.2.7, see the release notes
   for 8.2.7. Also, if you were running a previous 8.2.X release, it is
   recommended to "REINDEX" all GiST indexes after the upgrade.
     __________________________________________________________________

Changes

     * Fix GiST index corruption due to marking the wrong index entry
       "dead" after a deletion (Teodor)
       This would result in index searches failing to find rows they
       should have found. Corrupted indexes can be fixed with "REINDEX".
     * Fix backend crash when the client encoding cannot represent a
       localized error message (Tom)
       We have addressed similar issues before, but it would still fail if
       the "character has no equivalent" message itself couldn't be
       converted. The fix is to disable localization and send the plain
       ASCII error message when we detect such a situation.
     * Fix possible crash when deeply nested functions are invoked from a
       trigger (Tom)
     * Improve optimization of "expression" IN ("expression-list") queries
       (Tom, per an idea from Robert Haas)
       Cases in which there are query variables on the right-hand side had
       been handled less efficiently in 8.2.x and 8.3.x than in prior
       versions. The fix restores 8.1 behavior for such cases.
     * Fix mis-expansion of rule queries when a sub-SELECT appears in a
       function call in FROM, a multi-row VALUES list, or a RETURNING list
       (Tom)
       The usual symptom of this problem is an "unrecognized node type"
       error.
     * Fix memory leak during rescan of a hashed aggregation plan (Neil)
     * Ensure an error is reported when a newly-defined PL/pgSQL trigger
       function is invoked as a normal function (Tom)
     * Prevent possible collision of relfilenode numbers when moving a
       table to another tablespace with "ALTER SET TABLESPACE" (Heikki)
       The command tried to re-use the existing filename, instead of
       picking one that is known unused in the destination directory.
     * Fix incorrect tsearch2 headline generation when single query item
       matches first word of text (Sushant Sinha)
     * Fix improper display of fractional seconds in interval values when
       using a non-ISO datestyle in an "--enable-integer-datetimes" build
       (Ron Mayer)
     * Ensure SPI_getvalue and SPI_getbinval behave correctly when the
       passed tuple and tuple descriptor have different numbers of columns
       (Tom)
       This situation is normal when a table has had columns added or
       removed, but these two functions didn't handle it properly. The
       only likely consequence is an incorrect error indication.
     * Fix ecpg's parsing of "CREATE ROLE" (Michael)
     * Fix recent breakage of pg_ctl restart (Tom)
     * Ensure "pg_control" is opened in binary mode (Itagaki Takahiro)
       pg_controldata and pg_resetxlog did this incorrectly, and so could
       fail on Windows.
     * Update time zone data files to tzdata release 2008i (for DST law
       changes in Argentina, Brazil, Mauritius, Syria)
     __________________________________________________________________

                               Release 8.2.10

     Release date: 2008-09-22

   This release contains a variety of fixes from 8.2.9. For information
   about new features in the 8.2 major release, see the Section called
   Release 8.2.
     __________________________________________________________________

Migration to Version 8.2.10

   A dump/restore is not required for those running 8.2.X. However, if you
   are upgrading from a version earlier than 8.2.7, see the release notes
   for 8.2.7.
     __________________________________________________________________

Changes

     * Fix bug in btree WAL recovery code (Heikki)
       Recovery failed if the WAL ended partway through a page split
       operation.
     * Fix potential miscalculation of datfrozenxid (Alvaro)
       This error may explain some recent reports of failure to remove old
       pg_clog data.
     * Widen local lock counters from 32 to 64 bits (Tom)
       This responds to reports that the counters could overflow in
       sufficiently long transactions, leading to unexpected "lock is
       already held" errors.
     * Fix possible duplicate output of tuples during a GiST index scan
       (Teodor)
     * Fix missed permissions checks when a view contains a simple UNION
       ALL construct (Heikki)
       Permissions for the referenced tables were checked properly, but
       not permissions for the view itself.
     * Add checks in executor startup to ensure that the tuples produced
       by an "INSERT" or "UPDATE" will match the target table's current
       rowtype (Tom)
       "ALTER COLUMN TYPE", followed by re-use of a previously cached
       plan, could produce this type of situation. The check protects
       against data corruption and/or crashes that could ensue.
     * Fix possible repeated drops during "DROP OWNED" (Tom)
       This would typically result in strange errors such as "cache lookup
       failed for relation NNN".
     * Fix AT TIME ZONE to first try to interpret its timezone argument as
       a timezone abbreviation, and only try it as a full timezone name if
       that fails, rather than the other way around as formerly (Tom)
       The timestamp input functions have always resolved ambiguous zone
       names in this order. Making AT TIME ZONE do so as well improves
       consistency, and fixes a compatibility bug introduced in 8.1: in
       ambiguous cases we now behave the same as 8.0 and before did, since
       in the older versions AT TIME ZONE accepted *only* abbreviations.
     * Fix datetime input functions to correctly detect integer overflow
       when running on a 64-bit platform (Tom)
     * Prevent integer overflows during units conversion when displaying a
       configuration parameter that has units (Tom)
     * Improve performance of writing very long log messages to syslog
       (Tom)
     * Allow spaces in the suffix part of an LDAP URL in "pg_hba.conf"
       (Tom)
     * Fix bug in backwards scanning of a cursor on a SELECT DISTINCT ON
       query (Tom)
     * Fix planner bug with nested sub-select expressions (Tom)
       If the outer sub-select has no direct dependency on the parent
       query, but the inner one does, the outer value might not get
       recalculated for new parent query rows.
     * Fix planner to estimate that GROUP BY expressions yielding boolean
       results always result in two groups, regardless of the expressions'
       contents (Tom)
       This is very substantially more accurate than the regular GROUP BY
       estimate for certain boolean tests like "col" IS NULL.
     * Fix PL/pgSQL to not fail when a FOR loop's target variable is a
       record containing composite-type fields (Tom)
     * Fix PL/Tcl to behave correctly with Tcl 8.5, and to be more careful
       about the encoding of data sent to or from Tcl (Tom)
     * On Windows, work around a Microsoft bug by preventing libpq from
       trying to send more than 64kB per system call (Magnus)
     * Improve pg_dump and pg_restore's error reporting after failure to
       send a SQL command (Tom)
     * Fix pg_ctl to properly preserve postmaster command-line arguments
       across a restart (Bruce)
     * Update time zone data files to tzdata release 2008f (for DST law
       changes in Argentina, Bahamas, Brazil, Mauritius, Morocco,
       Pakistan, Palestine, and Paraguay)
     __________________________________________________________________

                                Release 8.2.9

     Release date: 2008-06-12

   This release contains one serious and one minor bug fix over 8.2.8. For
   information about new features in the 8.2 major release, see the
   Section called Release 8.2.
     __________________________________________________________________

Migration to Version 8.2.9

   A dump/restore is not required for those running 8.2.X. However, if you
   are upgrading from a version earlier than 8.2.7, see the release notes
   for 8.2.7.
     __________________________________________________________________

Changes

     * Make pg_get_ruledef() parenthesize negative constants (Tom)
       Before this fix, a negative constant in a view or rule might be
       dumped as, say, -42::integer, which is subtly incorrect: it should
       be (-42)::integer due to operator precedence rules. Usually this
       would make little difference, but it could interact with another
       recent patch to cause PostgreSQL to reject what had been a valid
       "SELECT DISTINCT" view query. Since this could result in pg_dump
       output failing to reload, it is being treated as a high-priority
       fix. The only released versions in which dump output is actually
       incorrect are 8.3.1 and 8.2.7.
     * Make "ALTER AGGREGATE ... OWNER TO" update pg_shdepend (Tom)
       This oversight could lead to problems if the aggregate was later
       involved in a "DROP OWNED" or "REASSIGN OWNED" operation.
     __________________________________________________________________

                                Release 8.2.8

     Release date: never released

   This release contains a variety of fixes from 8.2.7. For information
   about new features in the 8.2 major release, see the Section called
   Release 8.2.
     __________________________________________________________________

Migration to Version 8.2.8

   A dump/restore is not required for those running 8.2.X. However, if you
   are upgrading from a version earlier than 8.2.7, see the release notes
   for 8.2.7.
     __________________________________________________________________

Changes

     * Fix ERRORDATA_STACK_SIZE exceeded crash that occurred on Windows
       when using UTF-8 database encoding and a different client encoding
       (Tom)
     * Fix "ALTER TABLE ADD COLUMN ... PRIMARY KEY" so that the new column
       is correctly checked to see if it's been initialized to all
       non-nulls (Brendan Jurd)
       Previous versions neglected to check this requirement at all.
     * Fix possible "CREATE TABLE" failure when inheriting the "same"
       constraint from multiple parent relations that inherited that
       constraint from a common ancestor (Tom)
     * Fix pg_get_ruledef() to show the alias, if any, attached to the
       target table of an "UPDATE" or "DELETE" (Tom)
     * Fix GIN bug that could result in a too many LWLocks taken failure
       (Teodor)
     * Avoid possible crash when decompressing corrupted data (Zdenek
       Kotala)
     * Repair two places where SIGTERM exit of a backend could leave
       corrupted state in shared memory (Tom)
       Neither case is very important if SIGTERM is used to shut down the
       whole database cluster together, but there was a problem if someone
       tried to SIGTERM individual backends.
     * Fix conversions between ISO-8859-5 and other encodings to handle
       Cyrillic "Yo" characters (e and E with two dots) (Sergey Burladyan)
     * Fix several datatype input functions, notably array_in(), that were
       allowing unused bytes in their results to contain uninitialized,
       unpredictable values (Tom)
       This could lead to failures in which two apparently identical
       literal values were not seen as equal, resulting in the parser
       complaining about unmatched ORDER BY and DISTINCT expressions.
     * Fix a corner case in regular-expression substring matching
       (substring(string from pattern)) (Tom)
       The problem occurs when there is a match to the pattern overall but
       the user has specified a parenthesized subexpression and that
       subexpression hasn't got a match. An example is substring('foo'
       from 'foo(bar)?'). This should return NULL, since (bar) isn't
       matched, but it was mistakenly returning the whole-pattern match
       instead (ie, foo).
     * Update time zone data files to tzdata release 2008c (for DST law
       changes in Morocco, Iraq, Choibalsan, Pakistan, Syria, Cuba, and
       Argentina/San_Luis)
     * Fix incorrect result from ecpg's PGTYPEStimestamp_sub() function
       (Michael)
     * Fix broken GiST comparison function for "contrib/tsearch2"'s
       tsquery type (Teodor)
     * Fix possible crashes in "contrib/cube" functions (Tom)
     * Fix core dump in "contrib/xml2"'s xpath_table() function when the
       input query returns a NULL value (Tom)
     * Fix "contrib/xml2"'s makefile to not override CFLAGS (Tom)
     * Fix DatumGetBool macro to not fail with gcc 4.3 (Tom)
       This problem affects "old style" (V0) C functions that return
       boolean. The fix is already in 8.3, but the need to back-patch it
       was not realized at the time.
     __________________________________________________________________

                                Release 8.2.7

     Release date: 2008-03-17

   This release contains a variety of fixes from 8.2.6. For information
   about new features in the 8.2 major release, see the Section called
   Release 8.2.
     __________________________________________________________________

Migration to Version 8.2.7

   A dump/restore is not required for those running 8.2.X. However, you
   might need to "REINDEX" indexes on textual columns after updating, if
   you are affected by the Windows locale issue described below.
     __________________________________________________________________

Changes

     * Fix character string comparison for Windows locales that consider
       different character combinations as equal (Tom)
       This fix applies only on Windows and only when using UTF-8 database
       encoding. The same fix was made for all other cases over two years
       ago, but Windows with UTF-8 uses a separate code path that was not
       updated. If you are using a locale that considers some
       non-identical strings as equal, you may need to "REINDEX" to fix
       existing indexes on textual columns.
     * Repair potential deadlock between concurrent "VACUUM FULL"
       operations on different system catalogs (Tom)
     * Fix longstanding "LISTEN"/"NOTIFY" race condition (Tom)
       In rare cases a session that had just executed a "LISTEN" might not
       get a notification, even though one would be expected because the
       concurrent transaction executing "NOTIFY" was observed to commit
       later.
       A side effect of the fix is that a transaction that has executed a
       not-yet-committed "LISTEN" command will not see any row in
       pg_listener for the "LISTEN", should it choose to look; formerly it
       would have. This behavior was never documented one way or the
       other, but it is possible that some applications depend on the old
       behavior.
     * Disallow "LISTEN" and "UNLISTEN" within a prepared transaction
       (Tom)
       This was formerly allowed but trying to do it had various
       unpleasant consequences, notably that the originating backend could
       not exit as long as an "UNLISTEN" remained uncommitted.
     * Disallow dropping a temporary table within a prepared transaction
       (Heikki)
       This was correctly disallowed by 8.1, but the check was
       inadvertently broken in 8.2.
     * Fix rare crash when an error occurs during a query using a hash
       index (Heikki)
     * Fix memory leaks in certain usages of set-returning functions
       (Neil)
     * Fix input of datetime values for February 29 in years BC (Tom)
       The former coding was mistaken about which years were leap years.
     * Fix "unrecognized node type" error in some variants of "ALTER
       OWNER" (Tom)
     * Ensure pg_stat_activity.waiting flag is cleared when a lock wait is
       aborted (Tom)
     * Fix handling of process permissions on Windows Vista (Dave, Magnus)
       In particular, this fix allows starting the server as the
       Administrator user.
     * Update time zone data files to tzdata release 2008a (in particular,
       recent Chile changes); adjust timezone abbreviation VET (Venezuela)
       to mean UTC-4:30, not UTC-4:00 (Tom)
     * Fix pg_ctl to correctly extract the postmaster's port number from
       command-line options (Itagaki Takahiro, Tom)
       Previously, pg_ctl start -w could try to contact the postmaster on
       the wrong port, leading to bogus reports of startup failure.
     * Use "-fwrapv" to defend against possible misoptimization in recent
       gcc versions (Tom)
       This is known to be necessary when building PostgreSQL with gcc 4.3
       or later.
     * Correctly enforce statement_timeout values longer than INT_MAX
       microseconds (about 35 minutes) (Tom)
       This bug affects only builds with "--enable-integer-datetimes".
     * Fix "unexpected PARAM_SUBLINK ID" planner error when
       constant-folding simplifies a sub-select (Tom)
     * Fix logical errors in constraint-exclusion handling of IS NULL and
       NOT expressions (Tom)
       The planner would sometimes exclude partitions that should not have
       been excluded because of the possibility of NULL results.
     * Fix another cause of "failed to build any N-way joins" planner
       errors (Tom)
       This could happen in cases where a clauseless join needed to be
       forced before a join clause could be exploited.
     * Fix incorrect constant propagation in outer-join planning (Tom)
       The planner could sometimes incorrectly conclude that a variable
       could be constrained to be equal to a constant, leading to wrong
       query results.
     * Fix display of constant expressions in ORDER BY and GROUP BY (Tom)
       An explictly casted constant would be shown incorrectly. This could
       for example lead to corruption of a view definition during dump and
       reload.
     * Fix libpq to handle NOTICE messages correctly during COPY OUT (Tom)
       This failure has only been observed to occur when a user-defined
       datatype's output routine issues a NOTICE, but there is no
       guarantee it couldn't happen due to other causes.
     __________________________________________________________________

                                Release 8.2.6

     Release date: 2008-01-07

   This release contains a variety of fixes from 8.2.5, including fixes
   for significant security issues. For information about new features in
   the 8.2 major release, see the Section called Release 8.2.
     __________________________________________________________________

Migration to Version 8.2.6

   A dump/restore is not required for those running 8.2.X.
     __________________________________________________________________

Changes

     * Prevent functions in indexes from executing with the privileges of
       the user running "VACUUM", "ANALYZE", etc (Tom)
       Functions used in index expressions and partial-index predicates
       are evaluated whenever a new table entry is made. It has long been
       understood that this poses a risk of trojan-horse code execution if
       one modifies a table owned by an untrustworthy user. (Note that
       triggers, defaults, check constraints, etc. pose the same type of
       risk.) But functions in indexes pose extra danger because they will
       be executed by routine maintenance operations such as "VACUUM
       FULL", which are commonly performed automatically under a superuser
       account. For example, a nefarious user can execute code with
       superuser privileges by setting up a trojan-horse index definition
       and waiting for the next routine vacuum. The fix arranges for
       standard maintenance operations (including "VACUUM", "ANALYZE",
       "REINDEX", and "CLUSTER") to execute as the table owner rather than
       the calling user, using the same privilege-switching mechanism
       already used for SECURITY DEFINER functions. To prevent bypassing
       this security measure, execution of "SET SESSION AUTHORIZATION" and
       "SET ROLE" is now forbidden within a SECURITY DEFINER context.
       (CVE-2007-6600)
     * Repair assorted bugs in the regular-expression package (Tom, Will
       Drewry)
       Suitably crafted regular-expression patterns could cause crashes,
       infinite or near-infinite looping, and/or massive memory
       consumption, all of which pose denial-of-service hazards for
       applications that accept regex search patterns from untrustworthy
       sources. (CVE-2007-4769, CVE-2007-4772, CVE-2007-6067)
     * Require non-superusers who use "/contrib/dblink" to use only
       password authentication, as a security measure (Joe)
       The fix that appeared for this in 8.2.5 was incomplete, as it
       plugged the hole for only some "dblink" functions. (CVE-2007-6601,
       CVE-2007-3278)
     * Fix bugs in WAL replay for GIN indexes (Teodor)
     * Fix GIN index build to work properly when maintenance_work_mem is
       4GB or more (Tom)
     * Update time zone data files to tzdata release 2007k (in particular,
       recent Argentina changes) (Tom)
     * Improve planner's handling of LIKE/regex estimation in non-C
       locales (Tom)
     * Fix planning-speed problem for deep outer-join nests, as well as
       possible poor choice of join order (Tom)
     * Fix planner failure in some cases of WHERE false AND var IN (SELECT
       ...) (Tom)
     * Make "CREATE TABLE ... SERIAL" and "ALTER SEQUENCE ... OWNED BY"
       not change the currval() state of the sequence (Tom)
     * Preserve the tablespace and storage parameters of indexes that are
       rebuilt by "ALTER TABLE ... ALTER COLUMN TYPE" (Tom)
     * Make archive recovery always start a new WAL timeline, rather than
       only when a recovery stop time was used (Simon)
       This avoids a corner-case risk of trying to overwrite an existing
       archived copy of the last WAL segment, and seems simpler and
       cleaner than the original definition.
     * Make "VACUUM" not use all of maintenance_work_mem when the table is
       too small for it to be useful (Alvaro)
     * Fix potential crash in translate() when using a multibyte database
       encoding (Tom)
     * Make corr() return the correct result for negative correlation
       values (Neil)
     * Fix overflow in extract(epoch from interval) for intervals
       exceeding 68 years (Tom)
     * Fix PL/Perl to not fail when a UTF-8 regular expression is used in
       a trusted function (Andrew)
     * Fix PL/Perl to cope when platform's Perl defines type bool as int
       rather than char (Tom)
       While this could theoretically happen anywhere, no standard build
       of Perl did things this way ... until Mac OS X 10.5.
     * Fix PL/Python to work correctly with Python 2.5 on 64-bit machines
       (Marko Kreen)
     * Fix PL/Python to not crash on long exception messages (Alvaro)
     * Fix pg_dump to correctly handle inheritance child tables that have
       default expressions different from their parent's (Tom)
     * Fix libpq crash when PGPASSFILE refers to a file that is not a
       plain file (Martin Pitt)
     * ecpg parser fixes (Michael)
     * Make "contrib/pgcrypto" defend against OpenSSL libraries that fail
       on keys longer than 128 bits; which is the case at least on some
       Solaris versions (Marko Kreen)
     * Make "contrib/tablefunc"'s crosstab() handle NULL rowid as a
       category in its own right, rather than crashing (Joe)
     * Fix tsvector and tsquery output routines to escape backslashes
       correctly (Teodor, Bruce)
     * Fix crash of to_tsvector() on huge input strings (Teodor)
     * Require a specific version of Autoconf to be used when
       re-generating the "configure" script (Peter)
       This affects developers and packagers only. The change was made to
       prevent accidental use of untested combinations of Autoconf and
       PostgreSQL versions. You can remove the version check if you really
       want to use a different Autoconf version, but it's your
       responsibility whether the result works or not.
     * Update gettimeofday configuration check so that PostgreSQL can be
       built on newer versions of MinGW (Magnus)
     __________________________________________________________________

                                Release 8.2.5

     Release date: 2007-09-17

   This release contains a variety of fixes from 8.2.4. For information
   about new features in the 8.2 major release, see the Section called
   Release 8.2.
     __________________________________________________________________

Migration to Version 8.2.5

   A dump/restore is not required for those running 8.2.X.
     __________________________________________________________________

Changes

     * Prevent index corruption when a transaction inserts rows and then
       aborts close to the end of a concurrent "VACUUM" on the same table
       (Tom)
     * Fix ALTER DOMAIN ADD CONSTRAINT for cases involving domains over
       domains (Tom)
     * Make "CREATE DOMAIN ... DEFAULT NULL" work properly (Tom)
     * Fix some planner problems with outer joins, notably poor size
       estimation for t1 LEFT JOIN t2 WHERE t2.col IS NULL (Tom)
     * Allow the interval data type to accept input consisting only of
       milliseconds or microseconds (Neil)
     * Allow timezone name to appear before the year in timestamp input
       (Tom)
     * Fixes for GIN indexes used by "/contrib/tsearch2" (Teodor)
     * Speed up rtree index insertion (Teodor)
     * Fix excessive logging of SSL error messages (Tom)
     * Fix logging so that log messages are never interleaved when using
       the syslogger process (Andrew)
     * Fix crash when log_min_error_statement logging runs out of memory
       (Tom)
     * Fix incorrect handling of some foreign-key corner cases (Tom)
     * Fix stddev_pop(numeric) and var_pop(numeric) (Tom)
     * Prevent "REINDEX" and "CLUSTER" from failing due to attempting to
       process temporary tables of other sessions (Alvaro)
     * Update the time zone database rules, particularly New Zealand's
       upcoming changes (Tom)
     * Windows socket and semaphore improvements (Magnus)
     * Make "pg_ctl -w" work properly in Windows service mode (Dave Page)
     * Fix memory allocation bug when using MIT Kerberos on Windows
       (Magnus)
     * Suppress timezone name (%Z) in log timestamps on Windows because of
       possible encoding mismatches (Tom)
     * Require non-superusers who use "/contrib/dblink" to use only
       password authentication, as a security measure (Joe)
     * Restrict "/contrib/pgstattuple" functions to superusers, for
       security reasons (Tom)
     * Do not let "/contrib/intarray" try to make its GIN opclass the
       default (this caused problems at dump/restore) (Tom)
     __________________________________________________________________

                                Release 8.2.4

     Release date: 2007-04-23

   This release contains a variety of fixes from 8.2.3, including a
   security fix. For information about new features in the 8.2 major
   release, see the Section called Release 8.2.
     __________________________________________________________________

Migration to Version 8.2.4

   A dump/restore is not required for those running 8.2.X.
     __________________________________________________________________

Changes

     * Support explicit placement of the temporary-table schema within
       search_path, and disable searching it for functions and operators
       (Tom)
       This is needed to allow a security-definer function to set a truly
       secure value of search_path. Without it, an unprivileged SQL user
       can use temporary objects to execute code with the privileges of
       the security-definer function (CVE-2007-2138). See "CREATE
       FUNCTION" for more information.
     * Fix shared_preload_libraries for Windows by forcing reload in each
       backend (Korry Douglas)
     * Fix to_char() so it properly upper/lower cases localized day or
       month names (Pavel Stehule)
     * "/contrib/tsearch2" crash fixes (Teodor)
     * Require "COMMIT PREPARED" to be executed in the same database as
       the transaction was prepared in (Heikki)
     * Allow "pg_dump" to do binary backups larger than two gigabytes on
       Windows (Magnus)
     * New traditional (Taiwan) Chinese FAQ (Zhou Daojing)
     * Prevent the statistics collector from writing to disk too
       frequently (Tom)
     * Fix potential-data-corruption bug in how "VACUUM FULL" handles
       "UPDATE" chains (Tom, Pavan Deolasee)
     * Fix bug in domains that use array types (Tom)
     * Fix "pg_dump" so it can dump a serial column's sequence using "-t"
       when not also dumping the owning table (Tom)
     * Planner fixes, including improving outer join and bitmap scan
       selection logic (Tom)
     * Fix possible wrong answers or crash when a PL/pgSQL function tries
       to RETURN from within an EXCEPTION block (Tom)
     * Fix PANIC during enlargement of a hash index (Tom)
     * Fix POSIX-style timezone specs to follow new USA DST rules (Tom)
     __________________________________________________________________

                                Release 8.2.3

     Release date: 2007-02-07

   This release contains two fixes from 8.2.2. For information about new
   features in the 8.2 major release, see the Section called Release 8.2.
     __________________________________________________________________

Migration to Version 8.2.3

   A dump/restore is not required for those running 8.2.X.
     __________________________________________________________________

Changes

     * Remove overly-restrictive check for type length in constraints and
       functional indexes(Tom)
     * Fix optimization so MIN/MAX in subqueries can again use indexes
       (Tom)
     __________________________________________________________________

                                Release 8.2.2

     Release date: 2007-02-05

   This release contains a variety of fixes from 8.2.1, including a
   security fix. For information about new features in the 8.2 major
   release, see the Section called Release 8.2.
     __________________________________________________________________

Migration to Version 8.2.2

   A dump/restore is not required for those running 8.2.X.
     __________________________________________________________________

Changes

     * Remove security vulnerabilities that allowed connected users to
       read backend memory (Tom)
       The vulnerabilities involve suppressing the normal check that a SQL
       function returns the data type it's declared to, and changing the
       data type of a table column (CVE-2007-0555, CVE-2007-0556). These
       errors can easily be exploited to cause a backend crash, and in
       principle might be used to read database content that the user
       should not be able to access.
     * Fix not-so-rare-anymore bug wherein btree index page splits could
       fail due to choosing an infeasible split point (Heikki Linnakangas)
     * Fix Borland C compile scripts (L Bayuk)
     * Properly handle to_char('CC') for years ending in 00 (Tom)
       Year 2000 is in the twentieth century, not the twenty-first.
     * "/contrib/tsearch2" localization improvements (Tatsuo, Teodor)
     * Fix incorrect permission check in
       information_schema.key_column_usage view (Tom)
       The symptom is "relation with OID nnnnn does not exist" errors. To
       get this fix without using "initdb", use "CREATE OR REPLACE VIEW"
       to install the corrected definition found in
       "share/information_schema.sql". Note you will need to do this in
       each database.
     * Improve "VACUUM" performance for databases with many tables (Tom)
     * Fix for rare Assert() crash triggered by UNION (Tom)
     * Fix potentially incorrect results from index searches using ROW
       inequality conditions (Tom)
     * Tighten security of multi-byte character processing for UTF8
       sequences over three bytes long (Tom)
     * Fix bogus "permission denied" failures occurring on Windows due to
       attempts to fsync already-deleted files (Magnus, Tom)
     * Fix bug that could cause the statistics collector to hang on
       Windows (Magnus)
       This would in turn lead to autovacuum not working.
     * Fix possible crashes when an already-in-use PL/pgSQL function is
       updated (Tom)
     * Improve PL/pgSQL handling of domain types (Sergiy Vyshnevetskiy,
       Tom)
     * Fix possible errors in processing PL/pgSQL exception blocks (Tom)
     __________________________________________________________________

                                Release 8.2.1

     Release date: 2007-01-08

   This release contains a variety of fixes from 8.2. For information
   about new features in the 8.2 major release, see the Section called
   Release 8.2.
     __________________________________________________________________

Migration to Version 8.2.1

   A dump/restore is not required for those running 8.2.
     __________________________________________________________________

Changes

     * Fix crash with SELECT ... LIMIT ALL (also LIMIT NULL) (Tom)
     * "Several /contrib/tsearch2" fixes (Teodor)
     * On Windows, make log messages coming from the operating system use
       ASCII encoding (Hiroshi Saito)
       This fixes a conversion problem when there is a mismatch between
       the encoding of the operating system and database server.
     * Fix Windows linking of pg_dump using "win32.mak" (Hiroshi Saito)
     * Fix planner mistakes for outer join queries (Tom)
     * Fix several problems in queries involving sub-SELECTs (Tom)
     * Fix potential crash in SPI during subtransaction abort (Tom)
       This affects all PL functions since they all use SPI.
     * Improve build speed of PDF documentation (Peter)
     * Re-add JST (Japan) timezone abbreviation (Tom)
     * Improve optimization decisions related to index scans (Tom)
     * Have psql print multi-byte combining characters as before, rather
       than output as \u (Tom)
     * Improve index usage of regular expressions that use parentheses
       (Tom)
       This improves psql \d performance also.
     * Make pg_dumpall assume that databases have public CONNECT
       privilege, when dumping from a pre-8.2 server (Tom)
       This preserves the previous behavior that anyone can connect to a
       database if allowed by "pg_hba.conf".
     __________________________________________________________________

                                 Release 8.2

     Release date: 2006-12-05
     __________________________________________________________________

Overview

   This release adds many functionality and performance improvements that
   were requested by users, including:

     * Query language enhancements including "INSERT/UPDATE/DELETE
       RETURNING", multirow VALUES lists, and optional target-table alias
       in "UPDATE"/"DELETE"
     * Index creation without blocking concurrent
       "INSERT"/"UPDATE"/"DELETE" operations
     * Many query optimization improvements, including support for
       reordering outer joins
     * Improved sorting performance with lower memory usage
     * More efficient locking with better concurrency
     * More efficient vacuuming
     * Easier administration of warm standby servers
     * New FILLFACTOR support for tables and indexes
     * Monitoring, logging, and performance tuning additions
     * More control over creating and dropping objects
     * Table inheritance relationships can be defined for and removed from
       pre-existing tables
     * "COPY TO" can copy the output of an arbitrary "SELECT" statement
     * Array improvements, including nulls in arrays
     * Aggregate-function improvements, including multiple-input
       aggregates and SQL:2003 statistical functions
     * Many "contrib/" improvements
     __________________________________________________________________

Migration to Version 8.2

   A dump/restore using pg_dump is required for those wishing to migrate
   data from any previous release.

   Observe the following incompatibilities:

     * Set escape_string_warning to on by default (Bruce)
       This issues a warning if backslash escapes are used in non-escape
       (non-E'') strings.
     * Change the row constructor syntax (ROW(...)) so that list elements
       foo.* will be expanded to a list of their member fields, rather
       than creating a nested row type field as formerly (Tom)
       The new behavior is substantially more useful since it allows, for
       example, triggers to check for data changes with IF row(new.*) IS
       DISTINCT FROM row(old.*). The old behavior is still available by
       omitting .*.
     * Make row comparisons follow SQL standard semantics and allow them
       to be used in index scans (Tom)
       Previously, row = and <> comparisons followed the standard but < <=
       > >= did not. A row comparison can now be used as an index
       constraint for a multicolumn index matching the row value.
     * Make row IS [NOT] NULL tests follow SQL standard semantics (Tom)
       The former behavior conformed to the standard for simple cases with
       IS NULL, but IS NOT NULL would return true if any row field was
       non-null, whereas the standard says it should return true only when
       all fields are non-null.
     * Make "SET CONSTRAINT" affect only one constraint (Kris Jurka)
       In previous releases, "SET CONSTRAINT" modified all constraints
       with a matching name. In this release, the schema search path is
       used to modify only the first matching constraint. A schema
       specification is also supported. This more nearly conforms to the
       SQL standard.
     * Remove RULE permission for tables, for security reasons (Tom)
       As of this release, only a table's owner can create or modify rules
       for the table. For backwards compatibility, "GRANT"/"REVOKE RULE"
       is still accepted, but it does nothing.
     * Array comparison improvements (Tom)
       Now array dimensions are also compared.
     * Change array concatenation to match documented behavior (Tom)
       This changes the previous behavior where concatenation would modify
       the array lower bound.
     * Make command-line options of postmaster and postgres identical
       (Peter)
       This allows the postmaster to pass arguments to each backend
       without using -o. Note that some options are now only available as
       long-form options, because there were conflicting single-letter
       options.
     * Deprecate use of postmaster symbolic link (Peter)
       postmaster and postgres commands now act identically, with the
       behavior determined by command-line options. The postmaster
       symbolic link is kept for compatibility, but is not really needed.
     * Change log_duration to output even if the query is not output (Tom)
       In prior releases, log_duration only printed if the query appeared
       earlier in the log.
     * Make to_char(time) and to_char(interval) treat HH and HH12 as
       12-hour intervals
       Most applications should use HH24 unless they want a 12-hour
       display.
     * Zero unmasked bits in conversion from INET to CIDR (Tom)
       This ensures that the converted value is actually valid for CIDR.
     * Remove australian_timezones configuration variable (Joachim
       Wieland)
       This variable has been superseded by a more general facility for
       configuring timezone abbreviations.
     * Improve cost estimation for nested-loop index scans (Tom)
       This might eliminate the need to set unrealistically small values
       of random_page_cost. If you have been using a very small
       random_page_cost, please recheck your test cases.
     * Change behavior of "pg_dump" -n and -t options. (Greg Sabino
       Mullane)
       See the "pg_dump" manual page for details.
     * Change libpq PQdsplen() to return a useful value (Martijn van
       Oosterhout)
     * Declare libpq PQgetssl() as returning void *, rather than SSL *
       (Martijn van Oosterhout)
       This allows applications to use the function without including the
       OpenSSL headers.
     * C-language loadable modules must now include a PG_MODULE_MAGIC
       macro call for version compatibility checking (Martijn van
       Oosterhout)
     * For security's sake, modules used by a PL/PerlU function are no
       longer available to PL/Perl functions (Andrew)

     Note: This also implies that data can no longer be shared between a
     PL/Perl function and a PL/PerlU function. Some Perl installations
     have not been compiled with the correct flags to allow multiple
     interpreters to exist within a single process. In this situation
     PL/Perl and PL/PerlU cannot both be used in a single backend. The
     solution is to get a Perl installation which supports multiple
     interpreters.
     * In "contrib/xml2/", rename xml_valid() to xml_is_well_formed()
       (Tom)
       xml_valid() will remain for backward compatibility, but its
       behavior will change to do schema checking in a future release.
     * Remove "contrib/ora2pg/", now at http://www.samse.fr/GPL/ora2pg
     * Remove contrib modules that have been migrated to PgFoundry:
       "adddepend", "dbase", "dbmirror", "fulltextindex", "mac",
       "userlock"
     * Remove abandoned contrib modules: "mSQL-interface", "tips"
     * Remove QNX and BEOS ports (Bruce)
       These ports no longer had active maintainers.
     __________________________________________________________________

Changes

   Below you will find a detailed account of the changes between
   PostgreSQL 8.2 and the previous major release.
     __________________________________________________________________

Performance Improvements

     * Allow the planner to reorder outer joins in some circumstances
       (Tom)
       In previous releases, outer joins would always be evaluated in the
       order written in the query. This change allows the query optimizer
       to consider reordering outer joins, in cases where it can determine
       that the join order can be changed without altering the meaning of
       the query. This can make a considerable performance difference for
       queries involving multiple outer joins or mixed inner and outer
       joins.
     * Improve efficiency of IN (list-of-expressions) clauses (Tom)
     * Improve sorting speed and reduce memory usage (Simon, Tom)
     * Improve subtransaction performance (Alvaro, Itagaki Takahiro, Tom)
     * Add FILLFACTOR to table and index creation (ITAGAKI Takahiro)
       This leaves extra free space in each table or index page, allowing
       improved performance as the database grows. This is particularly
       valuable to maintain clustering.
     * Increase default values for shared_buffers and max_fsm_pages
       (Andrew)
     * Improve locking performance by breaking the lock manager tables
       into sections (Tom)
       This allows locking to be more fine-grained, reducing contention.
     * Reduce locking requirements of sequential scans (Qingqing Zhou)
     * Reduce locking required for database creation and destruction (Tom)
     * Improve the optimizer's selectivity estimates for LIKE, ILIKE, and
       regular expression operations (Tom)
     * Improve planning of joins to inherited tables and UNION ALL views
       (Tom)
     * Allow constraint exclusion to be applied to inherited "UPDATE" and
       "DELETE" queries (Tom)
       "SELECT" already honored constraint exclusion.
     * Improve planning of constant WHERE clauses, such as a condition
       that depends only on variables inherited from an outer query level
       (Tom)
     * Protocol-level unnamed prepared statements are re-planned for each
       set of BIND values (Tom)
       This improves performance because the exact parameter values can be
       used in the plan.
     * Speed up vacuuming of B-Tree indexes (Heikki Linnakangas, Tom)
     * Avoid extra scan of tables without indexes during "VACUUM" (Greg
       Stark)
     * Improve multicolumn GiST indexing (Oleg, Teodor)
     * Remove dead index entries before B-Tree page split (Junji Teramoto)
     __________________________________________________________________

Server Changes

     * Allow a forced switch to a new transaction log file (Simon, Tom)
       This is valuable for keeping warm standby slave servers in sync
       with the master. Transaction log file switching now also happens
       automatically during pg_stop_backup(). This ensures that all
       transaction log files needed for recovery can be archived
       immediately.
     * Add WAL informational functions (Simon)
       Add functions for interrogating the current transaction log
       insertion point and determining WAL filenames from the hex WAL
       locations displayed by pg_stop_backup() and related functions.
     * Improve recovery from a crash during WAL replay (Simon)
       The server now does periodic checkpoints during WAL recovery, so if
       there is a crash, future WAL recovery is shortened. This also
       eliminates the need for warm standby servers to replay the entire
       log since the base backup if they crash.
     * Improve reliability of long-term WAL replay (Heikki, Simon, Tom)
       Formerly, trying to roll forward through more than 2 billion
       transactions would not work due to XID wraparound. This meant warm
       standby servers had to be reloaded from fresh base backups
       periodically.
     * Add archive_timeout to force transaction log file switches at a
       given interval (Simon)
       This enforces a maximum replication delay for warm standby servers.
     * Add native LDAP authentication (Magnus Hagander)
       This is particularly useful for platforms that do not support PAM,
       such as Windows.
     * Add GRANT CONNECT ON DATABASE (Gevik Babakhani)
       This gives SQL-level control over database access. It works as an
       additional filter on top of the existing "pg_hba.conf" controls.
     * Add support for SSL Certificate Revocation List (CRL) files (Libor
       Hohos)
       The server and libpq both recognize CRL files now.
     * GiST indexes are now clusterable (Teodor)
     * Remove routine autovacuum server log entries (Bruce)
       pg_stat_activity now shows autovacuum activity.
     * Track maximum XID age within individual tables, instead of whole
       databases (Alvaro)
       This reduces the overhead involved in preventing transaction ID
       wraparound, by avoiding unnecessary VACUUMs.
     * Add last vacuum and analyze timestamp columns to the stats
       collector (Larry Rosenman)
       These values now appear in the pg_stat_*_tables system views.
     * Improve performance of statistics monitoring, especially
       stats_command_string (Tom, Bruce)
       This release enables stats_command_string by default, now that its
       overhead is minimal. This means pg_stat_activity will now show all
       active queries by default.
     * Add a waiting column to pg_stat_activity (Tom)
       This allows pg_stat_activity to show all the information included
       in the ps display.
     * Add configuration parameter update_process_title to control whether
       the ps display is updated for every command (Bruce)
       On platforms where it is expensive to update the ps display, it
       might be worthwhile to turn this off and rely solely on
       pg_stat_activity for status information.
     * Allow units to be specified in configuration settings (Peter)
       For example, you can now set shared_buffers to 32MB rather than
       mentally converting sizes.
     * Add support for include directives in "postgresql.conf" (Joachim
       Wieland)
     * Improve logging of protocol-level prepare/bind/execute messages
       (Bruce, Tom)
       Such logging now shows statement names, bind parameter values, and
       the text of the query being executed. Also, the query text is
       properly included in logged error messages when enabled by
       log_min_error_statement.
     * Prevent max_stack_depth from being set to unsafe values
       On platforms where we can determine the actual kernel stack depth
       limit (which is most), make sure that the initial default value of
       max_stack_depth is safe, and reject attempts to set it to unsafely
       large values.
     * Enable highlighting of error location in query in more cases (Tom)
       The server is now able to report a specific error location for some
       semantic errors (such as unrecognized column name), rather than
       just for basic syntax errors as before.
     * Fix "failed to re-find parent key" errors in "VACUUM" (Tom)
     * Clean out "pg_internal.init" cache files during server restart
       (Simon)
       This avoids a hazard that the cache files might contain stale data
       after PITR recovery.
     * Fix race condition for truncation of a large relation across a
       gigabyte boundary by "VACUUM" (Tom)
     * Fix bug causing needless deadlock errors on row-level locks (Tom)
     * Fix bugs affecting multi-gigabyte hash indexes (Tom)
     * Each backend process is now its own process group leader (Tom)
       This allows query cancel to abort subprocesses invoked from a
       backend or archive/recovery process.
     __________________________________________________________________

Query Changes

     * Add "INSERT"/"UPDATE"/"DELETE" RETURNING (Jonah Harris, Tom)
       This allows these commands to return values, such as the computed
       serial key for a new row. In the "UPDATE" case, values from the
       updated version of the row are returned.
     * Add support for multiple-row VALUES clauses, per SQL standard (Joe,
       Tom)
       This allows "INSERT" to insert multiple rows of constants, or
       queries to generate result sets using constants. For example,
       INSERT ... VALUES (...), (...), ...., and SELECT * FROM (VALUES
       (...), (...), ....) AS alias(f1, ...).
     * Allow "UPDATE" and "DELETE" to use an alias for the target table
       (Atsushi Ogawa)
       The SQL standard does not permit an alias in these commands, but
       many database systems allow one anyway for notational convenience.
     * Allow "UPDATE" to set multiple columns with a list of values
       (Susanne Ebrecht)
       This is basically a short-hand for assigning the columns and values
       in pairs. The syntax is UPDATE tab SET (column, ...) = (val, ...).
     * Make row comparisons work per standard (Tom)
       The forms <, <=, >, >= now compare rows lexicographically, that is,
       compare the first elements, if equal compare the second elements,
       and so on. Formerly they expanded to an AND condition across all
       the elements, which was neither standard nor very useful.
     * Add CASCADE option to "TRUNCATE" (Joachim Wieland)
       This causes "TRUNCATE" to automatically include all tables that
       reference the specified table(s) via foreign keys. While
       convenient, this is a dangerous tool -- use with caution!
     * Support FOR UPDATE and FOR SHARE in the same SELECT command (Tom)
     * Add IS NOT DISTINCT FROM (Pavel Stehule)
       This operator is similar to equality (=), but evaluates to true
       when both left and right operands are NULL, and to false when just
       one is, rather than yielding NULL in these cases.
     * Improve the length output used by UNION/INTERSECT/EXCEPT (Tom)
       When all corresponding columns are of the same defined length, that
       length is used for the result, rather than a generic length.
     * Allow ILIKE to work for multi-byte encodings (Tom)
       Internally, ILIKE now calls lower() and then uses LIKE.
       Locale-specific regular expression patterns still do not work in
       these encodings.
     * Enable standard_conforming_strings to be turned on (Kevin Grittner)
       This allows backslash escaping in strings to be disabled, making
       PostgreSQL more standards-compliant. The default is off for
       backwards compatibility, but future releases will default this to
       on.
     * Do not flatten subqueries that contain volatile functions in their
       target lists (Jaime Casanova)
       This prevents surprising behavior due to multiple evaluation of a
       volatile function (such as random() or nextval()). It might cause
       performance degradation in the presence of functions that are
       unnecessarily marked as volatile.
     * Add system views pg_prepared_statements and pg_cursors to show
       prepared statements and open cursors (Joachim Wieland, Neil)
       These are very useful in pooled connection setups.
     * Support portal parameters in "EXPLAIN" and "EXECUTE" (Tom)
       This allows, for example, JDBC ? parameters to work in these
       commands.
     * If SQL-level "PREPARE" parameters are unspecified, infer their
       types from the content of the query (Neil)
       Protocol-level "PREPARE" already did this.
     * Allow LIMIT and OFFSET to exceed two billion (Dhanaraj M)
     __________________________________________________________________

Object Manipulation Changes

     * Add TABLESPACE clause to "CREATE TABLE AS" (Neil)
       This allows a tablespace to be specified for the new table.
     * Add ON COMMIT clause to "CREATE TABLE AS" (Neil)
       This allows temporary tables to be truncated or dropped on
       transaction commit. The default behavior is for the table to remain
       until the session ends.
     * Add INCLUDING CONSTRAINTS to "CREATE TABLE LIKE" (Greg Stark)
       This allows easy copying of CHECK constraints to a new table.
     * Allow the creation of placeholder (shell) types (Martijn van
       Oosterhout)
       A shell type declaration creates a type name, without specifying
       any of the details of the type. Making a shell type is useful
       because it allows cleaner declaration of the type's input/output
       functions, which must exist before the type can be defined "for
       real". The syntax is "CREATE TYPE typename".
     * Aggregate functions now support multiple input parameters (Sergey
       Koposov, Tom)
     * Add new aggregate creation syntax (Tom)
       The new syntax is "CREATE AGGREGATE aggname (input_type)
       (parameter_list)". This more naturally supports the new
       multi-parameter aggregate functionality. The previous syntax is
       still supported.
     * Add "ALTER ROLE PASSWORD NULL" to remove a previously set role
       password (Peter)
     * Add "DROP" object IF EXISTS for many object types (Andrew)
       This allows "DROP" operations on non-existent objects without
       generating an error.
     * Add DROP OWNED to drop all objects owned by a role (Alvaro)
     * Add REASSIGN OWNED to reassign ownership of all objects owned by a
       role (Alvaro)
       This, and DROP OWNED above, facilitate dropping roles.
     * Add "GRANT ON SEQUENCE" syntax (Bruce)
       This was added for setting sequence-specific permissions. GRANT ON
       TABLE for sequences is still supported for backward compatibility.
     * Add USAGE permission for sequences that allows only currval() and
       nextval(), not setval() (Bruce)
       USAGE permission allows more fine-grained control over sequence
       access. Granting USAGE allows users to increment a sequence, but
       prevents them from setting the sequence to an arbitrary value using
       setval().
     * Add ALTER TABLE [ NO ] INHERIT (Greg Stark)
       This allows inheritance to be adjusted dynamically, rather than
       just at table creation and destruction. This is very valuable when
       using inheritance to implement table partitioning.
     * Allow comments on global objects to be stored globally (Kris Jurka)
       Previously, comments attached to databases were stored in
       individual databases, making them ineffective, and there was no
       provision at all for comments on roles or tablespaces. This change
       adds a new shared catalog pg_shdescription and stores comments on
       databases, roles, and tablespaces therein.
     __________________________________________________________________

Utility Command Changes

     * Add option to allow indexes to be created without blocking
       concurrent writes to the table (Greg Stark, Tom)
       The new syntax is "CREATE INDEX CONCURRENTLY". The default behavior
       is still to block table modification while a index is being
       created.
     * Provide advisory locking functionality (Abhijit Menon-Sen, Tom)
       This is a new locking API designed to replace what used to be in
       /contrib/userlock. The userlock code is now on pgfoundry.
     * Allow "COPY" to dump a "SELECT" query (Zoltan Boszormenyi, Karel
       Zak)
       This allows "COPY" to dump arbitrary SQL queries. The syntax is
       COPY (SELECT ...) TO.
     * Make the "COPY" command return a command tag that includes the
       number of rows copied (Volkan YAZICI)
     * Allow "VACUUM" to expire rows without being affected by other
       concurrent "VACUUM" operations (Hannu Krossing, Alvaro, Tom)
     * Make initdb detect the operating system locale and set the default
       DateStyle accordingly (Peter)
       This makes it more likely that the installed "postgresql.conf"
       DateStyle value will be as desired.
     * Reduce number of progress messages displayed by initdb (Tom)
     __________________________________________________________________

Date/Time Changes

     * Allow full timezone names in timestamp input values (Joachim
       Wieland)
       For example, '2006-05-24 21:11 America/New_York'::timestamptz.
     * Support configurable timezone abbreviations (Joachim Wieland)
       A desired set of timezone abbreviations can be chosen via the
       configuration parameter timezone_abbreviations.
     * Add pg_timezone_abbrevs and pg_timezone_names views to show
       supported timezones (Magnus Hagander)
     * Add clock_timestamp(), statement_timestamp(), and
       transaction_timestamp() (Bruce)
       clock_timestamp() is the current wall-clock time,
       statement_timestamp() is the time the current statement arrived at
       the server, and transaction_timestamp() is an alias for now().
     * Allow to_char() to print localized month and day names (Euler
       Taveira de Oliveira)
     * Allow to_char(time) and to_char(interval) to output AM/PM
       specifications (Bruce)
       Intervals and times are treated as 24-hour periods, e.g. 25 hours
       is considered AM.
     * Add new function justify_interval() to adjust interval units (Mark
       Dilger)
     * Allow timezone offsets up to 14:59 away from GMT
       Kiribati uses GMT+14, so we'd better accept that.
     * Interval computation improvements (Michael Glaesemann, Bruce)
     __________________________________________________________________

Other Data Type and Function Changes

     * Allow arrays to contain NULL elements (Tom)
     * Allow assignment to array elements not contiguous with the existing
       entries (Tom)
       The intervening array positions will be filled with nulls. This is
       per SQL standard.
     * New built-in operators for array-subset comparisons (@>, <@, &&)
       (Teodor, Tom)
       These operators can be indexed for many data types using GiST or
       GIN indexes.
     * Add convenient arithmetic operations on INET/CIDR values (Stephen
       R. van den Berg)
       The new operators are & (and), | (or), ~ (not), inet + int8, inet -
       int8, and inet - inet.
     * Add new aggregate functions from SQL:2003 (Neil)
       The new functions are var_pop(), var_samp(), stddev_pop(), and
       stddev_samp(). var_samp() and stddev_samp() are merely renamings of
       the existing aggregates variance() and stddev(). The latter names
       remain available for backward compatibility.
     * Add SQL:2003 statistical aggregates (Sergey Koposov)
       New functions: regr_intercept(), regr_slope(), regr_r2(), corr(),
       covar_samp(), covar_pop(), regr_avgx(), regr_avgy(), regr_sxy(),
       regr_sxx(), regr_syy(), regr_count().
     * Allow domains to be based on other domains (Tom)
     * Properly enforce domain CHECK constraints everywhere (Neil, Tom)
       For example, the result of a user-defined function that is declared
       to return a domain type is now checked against the domain's
       constraints. This closes a significant hole in the domain
       implementation.
     * Fix problems with dumping renamed SERIAL columns (Tom)
       The fix is to dump a SERIAL column by explicitly specifying its
       DEFAULT and sequence elements, and reconstructing the SERIAL column
       on reload using a new "ALTER SEQUENCE OWNED BY" command. This also
       allows dropping a SERIAL column specification.
     * Add a server-side sleep function pg_sleep() (Joachim Wieland)
     * Add all comparison operators for the tid (tuple id) data type (Mark
       Kirkwood, Greg Stark, Tom)
     __________________________________________________________________

PL/pgSQL Server-Side Language Changes

     * Add TG_table_name and TG_table_schema to trigger parameters
       (Andrew)
       TG_relname is now deprecated. Comparable changes have been made in
       the trigger parameters for the other PLs as well.
     * Allow FOR statements to return values to scalars as well as records
       and row types (Pavel Stehule)
     * Add a BY clause to the FOR loop, to control the iteration increment
       (Jaime Casanova)
     * Add STRICT to "SELECT INTO" (Matt Miller)
       STRICT mode throws an exception if more or less than one row is
       returned by the "SELECT", for Oracle PL/SQL compatibility.
     __________________________________________________________________

PL/Perl Server-Side Language Changes

     * Add table_name and table_schema to trigger parameters (Adam
       Sjøgren)
     * Add prepared queries (Dmitry Karasik)
     * Make $_TD trigger data a global variable (Andrew)
       Previously, it was lexical, which caused unexpected sharing
       violations.
     * Run PL/Perl and PL/PerlU in separate interpreters, for security
       reasons (Andrew)
       In consequence, they can no longer share data nor loaded modules.
       Also, if Perl has not been compiled with the requisite flags to
       allow multiple interpreters, only one of these languages can be
       used in any given backend process.
     __________________________________________________________________

PL/Python Server-Side Language Changes

     * Named parameters are passed as ordinary variables, as well as in
       the args[] array (Sven Suursoho)
     * Add table_name and table_schema to trigger parameters (Andrew)
     * Allow returning of composite types and result sets (Sven Suursoho)
     * Return result-set as list, iterator, or generator (Sven Suursoho)
     * Allow functions to return void (Neil)
     * Python 2.5 is now supported (Tom)
     __________________________________________________________________

psql Changes

     * Add new command \password for changing role password with
       client-side password encryption (Peter)
     * Allow \c to connect to a new host and port number (David, Volkan
       YAZICI)
     * Add tablespace display to \l+ (Philip Yarra)
     * Improve \df slash command to include the argument names and modes
       (OUT or INOUT) of the function (David Fetter)
     * Support binary "COPY" (Andreas Pflug)
     * Add option to run the entire session in a single transaction
       (Simon)
       Use option -1 or --single-transaction.
     * Support for automatically retrieving "SELECT" results in batches
       using a cursor (Chris Mair)
       This is enabled using "\set FETCH_COUNT n". This feature allows
       large result sets to be retrieved in psql without attempting to
       buffer the entire result set in memory.
     * Make multi-line values align in the proper column (Martijn van
       Oosterhout)
       Field values containing newlines are now displayed in a more
       readable fashion.
     * Save multi-line statements as a single entry, rather than one line
       at a time (Sergey E. Koposov)
       This makes up-arrow recall of queries easier. (This is not
       available on Windows, because that platform uses the native
       command-line editing present in the operating system.)
     * Make the line counter 64-bit so it can handle files with more than
       two billion lines (David Fetter)
     * Report both the returned data and the command status tag for
       "INSERT"/"UPDATE"/"DELETE RETURNING" (Tom)
     __________________________________________________________________

pg_dump Changes

     * Allow complex selection of objects to be included or excluded by
       pg_dump (Greg Sabino Mullane)
       pg_dump now supports multiple -n (schema) and -t (table) options,
       and adds -N and -T options to exclude objects. Also, the arguments
       of these switches can now be wild-card expressions rather than
       single object names, for example -t 'foo*', and a schema can be
       part of a -t or -T switch, for example -t schema1.table1.
     * Add pg_restore --no-data-for-failed-tables option to suppress
       loading data if table creation failed (i.e., the table already
       exists) (Martin Pitt)
     * Add pg_restore option to run the entire session in a single
       transaction (Simon)
       Use option -1 or --single-transaction.
     __________________________________________________________________

libpq Changes

     * Add PQencryptPassword() to encrypt passwords (Tom)
       This allows passwords to be sent pre-encrypted for commands like
       "ALTER ROLE ... PASSWORD".
     * Add function PQisthreadsafe() (Bruce)
       This allows applications to query the thread-safety status of the
       library.
     * Add PQdescribePrepared(), PQdescribePortal(), and related functions
       to return information about previously prepared statements and open
       cursors (Volkan YAZICI)
     * Allow LDAP lookups from "pg_service.conf" (Laurenz Albe)
     * Allow a hostname in "~/.pgpass" to match the default socket
       directory (Bruce)
       A blank hostname continues to match any Unix-socket connection, but
       this addition allows entries that are specific to one of several
       postmasters on the machine.
     __________________________________________________________________

ecpg Changes

     * Allow "SHOW" to put its result into a variable (Joachim Wieland)
     * Add "COPY TO STDOUT" (Joachim Wieland)
     * Add regression tests (Joachim Wieland, Michael)
     * Major source code cleanups (Joachim Wieland, Michael)
     __________________________________________________________________

Windows Port

     * Allow MSVC to compile the PostgreSQL server (Magnus, Hiroshi Saito)
     * Add MSVC support for utility commands and pg_dump (Hiroshi Saito)
     * Add support for Windows code pages 1253, 1254, 1255, and 1257 (Kris
       Jurka)
     * Drop privileges on startup, so that the server can be started from
       an administrative account (Magnus)
     * Stability fixes (Qingqing Zhou, Magnus)
     * Add native semaphore implementation (Qingqing Zhou)
       The previous code mimicked SysV semaphores.
     __________________________________________________________________

Source Code Changes

     * Add GIN (Generalized Inverted iNdex) index access method (Teodor,
       Oleg)
     * Remove R-tree indexing (Tom)
       Rtree has been re-implemented using GiST. Among other differences,
       this means that rtree indexes now have support for crash recovery
       via write-ahead logging (WAL).
